<%
    ' Currently edited card
    Function CurrentCardId
        CurrentCardId = ConvertTo(vbLong,Session("CARD_ID"))
    End Function
    Function NewCardEx(pcid) ' Create with parent
        Dim r, binder, cid
        NewCardEx = False
        ' On Error Resume Next
        ' On Error Goto 0
        If Database.BeginTransaction Then
            Err.Clear
            Set binder = Create_CRecordBinder("LANGUAGE")
            Set r = binder.ItemForWrite(0,"CARD")
            If Not r Is Nothing Then
                binder.Value(r,"CREATOR_PERSON_SID") = CurrentUser.PersonId
                binder.Value(r,"STATUS_PERSON_SID") = CurrentUser.PersonId
                binder.Value(r,"PARENT_CARD_SID") = NullConvertTo(vbLong, pcid)
                cid = binder.WriteItem(r, "CARD")
            End If
            If Database.CompleteTransaction Then
                Session("CARD_ID") = cid
                NewCardEx = True
            End If
        End If
        On Error Goto 0
    End Function
    Function NewCard ' Create without parent
    
        NewCard = NewCardEx(0)
    End Function
    
    Function OpenCard(id)
        Dim r, binder, cid
        OpenCard = False
        Set binder = Create_CRecordBinder("LANGUAGE")
        Set r = binder.ItemForEdit(id,"CARD")
        If r Is Nothing Then
            Database.AddError TR("Cannot access this card. You may not have enough rights to open it for editing.")
        Else
            Session("CARD_ID") = ConvertTo(vbLong,r(1)("SID"))
            OpenCard = True
        End If
    End Function
    Function CloseCard
        Session("CARD_ID") = Empty
    End Function
    
    Function NumberCard(cid)
        Dim binder, r, id, n
        NumberCard = Empty
        Set binder = Create_CRecordBinder("LANGUAGE")
            If Database.BeginTransaction Then
            'On Error Resume Next
                Set r = binder.ItemForWrite(cid,"CARD")
                If Not r Is Nothing Then
                    If ConvertTo(vbBoolean,binder.Value(r,"COMPLETED")) Then
                        If Len(ConvertTo(vbString,binder.Value(r,"CARD_NUMBER"))) > 0 Then
                            Database.CancelTransaction TR("The card already has a number")
                        Else
                            Database.DB.Execute("UPDATE CARD_NUMBERING SET NUM=NUM+1 WHERE NUM > 10000000;")
                            n = Database.DB.Execute("SELECT NUM FROM CARD_NUMBERING WHERE NUM > 10000000 LIMIT 1;")(1)(1)

                            n = StringUtilities.Sprintf("%08d",n)
                            binder.Value(r,"CARD_NUMBER") = n
                            id = binder.WriteItem(r, "CARD")
                            IndexCard id
                        End If
                    Else
                        Database.CancelTransaction TR("Card must be completed first")
                    End If
                Else
                    Database.CancelTransaction TR("Card not found or not accessible")
                End If
                
            If Database.CompleteTransaction Then
                NumberCard = n
            End If
        End If
    End Function
    
    ' Binder control for the card tab pages
    Function CardLoadTab(binder)
        Dim r
        CardLoadTab = False
        If CurrentCardId = 0 Then
            ASPRedirect = VirtPath("/")
            Exit Function
        End If
        Set r = binder.ItemForEdit(CurrentCardId, "CARD")
        If Not r Is Nothing Then
            binder.ReadFrom r
            CardLoadTab = True
        Else
            ASPRedirect = VirtPath("/")
            CardLoadTab = False
        End If
    End Function
    Function CardCloseTabEx(binder,proc)
        Dim r, id, customProc
        CardCloseTabEx = True
        If btnOk.Clicked Or cardMenu.Clicked Or btnComplete.Clicked Then
            If Validate(Empty) Then
                If Database.BeginTransaction Then
                    On Error Resume Next
                    
                        Set r = binder.ItemForWrite(CurrentCardId, "CARD")
                        If Not r Is Nothing Then
                            binder.WriteTo r
                            id = binder.WriteItem(r, "CARD")
                        End If
                        
                        If Len(proc) > 0 Then
                            Set customProc = GetRef(proc)
                            If Not customProc(r,binder) Then
                                Database.InvalidateTransaction
                            End If
                        End If
                        
                        IndexCard id
                        
                    If Database.CompleteTransaction Then
                        If cardMenu.Clicked Then 
                            CardCloseTabEx = cardMenu.Redirect
                        End If
                        If btnComplete.Clicked Then 
                            CardCloseTabEx = False
                            ASPRedirect = VirtPath("/x-cardcomplete.asp")
                        End If
                    End If
                End If
            End If
        ElseIf btnClose.Clicked Then
            CardCloseTabEx = False
            CloseCard
            ASPRedirect = VirtPath("/")
        End If
    End Function
    Function CardCloseTab(binder)
        CardCloseTab = CardCloseTabEx(binder, Empty)
    End Function
    Function Location_SaveLocList(r,binder)
        Dim locId, locs, I
        If Database.BeginTransaction Then
        On Error Resume Next
            If CurrentCardId = 0 Then Database.CancelTransaction TR("No card is opened for editing.")
            locid = ConvertTo(vbLong,binder.Value(r,"LOCATION_SID"))
            If locId <> 0 Then
                Set locs = GetLocation(locId)
                Database.DB.VExecute "DELETE FROM CARD_LOCATIONS WHERE CARD_SID=$CARD_SID",1,0, CurrentCardId
                For I = 1 To locs.Locations.Count
                    Database.DB.VExecute "INSERT INTO CARD_LOCATIONS (CARD_SID,LOCATION_SID) VALUES ($CARD_SID,$LOCATION_SID)",1,0, _
                                         CurrentCardId,NullConvertTo(vbLong,locs.Locations(I)("SID"))
                Next
            End If
            If Database.CompleteTransaction Then
                Location_SaveLocList = True
            End If
        End If
    End Function
    
    Function CardComplete(binder)
        Dim r, id
        CardComplete = True
        If btnOk.Clicked Or cardMenu.Clicked Or btnComplete.Clicked Then
            If Validate(Empty) Then
                If Database.BeginTransaction Then
                    On Error Resume Next
                    
                        Set r = binder.ItemForWrite(CurrentCardId, "CARD")
                        If Not r Is Nothing Then
                            binder.WriteTo r
                            id = binder.WriteItem(r, "CARD")
                        End If
                        
                        IndexCard id
                        
                    If Database.CompleteTransaction Then
                        If cardMenu.Clicked Then 
                            CardComplete = cardMenu.Redirect
                        End If
                        If btnComplete.Clicked Then 
                            CardComplete = False
                            ASPRedirect = VirtPath("/x-cardcomplete.asp")
                        End If
                    End If
                End If
            End If
        ElseIf btnClose.Clicked Then
            CardComplete = False
            CloseCard
            ASPRedirect = VirtPath("/")
        ElseIf btnFinalize.Clicked Then
            If Database.BeginTransaction Then
                On Error Resume Next
                    Set r = binder.ItemForWrite(CurrentCardId, "CARD")
                    If Not r Is Nothing Then
                        binder.WriteTo r
                        binder.Value(r,"COMPLETED") = -1
                        id = binder.WriteItem(r, "CARD")
                    End If
                    
                    IndexCard id
                    
                If Database.CompleteTransaction Then
                    CardComplete = False
                    ASPRedirect = VirtPath("/")
                End If
            End If
        End If
    End Function
    
    
    ' TO DO: Review this
    
    Function UpdateCardElementRights(cid)
        Dim r, sql, rs
        Set rs = RSYS_FOR(cid,"CARD")
        If rs.Count > 0 Then
            rs("CARD_ID") = ConvertTo(vbLong, cid)
            sql = ""
            sql = sql & "UPDATE RSYS SET OWNER_PERSON_ID=$OWNER_PERSON_ID, OWNER_GROUP_ID=$OWNER_GROUP_ID, URIGHTS=$URIGHTS, " & _
                        "GRIGHTS=$GRIGHTS, ARIGHTS=$ARIGHTS WHERE " & _
                        " ID IN (SELECT RSYS_ID FROM CARD_FACILITIES_REL WHERE CARD_ID=$CARD_ID) OR " & _
                        " ID IN (SELECT RSYS_ID FROM CARD_FINDINGS_REL WHERE CARD_ID=$CARD_ID) OR " & _
                        " ID IN (SELECT RSYS_ID CARD_TYPE_CHRONOLOGY_REL WHERE CARD_ID=$CARD_ID) OR " & _
                        " ID IN (SELECT RSYS_ID CARD_CORRECTION WHERE CARD_ID=$CARD_ID) OR " & _
                        " ID IN (SELECT RSYS_ID BORDER_POINTS WHERE CARD_ID=$CARD_ID)" & vbCrLf
            DB.CExecute sql, rs
            UpdateCardElementRights = True
        Else
            UpdateCardElementRights = False
        End If
    End Function
    
    
    
    ' Sub-cards/Parent cards
    'Sub DisplayRelatedCards(cid)
    '    Dim rChild, rParent
    '    Set rChild = DB.VExecute("SELECT * FROM VCARD_RESULTS WHERE PARENT_CARD_ID=$cid
    'End Sub

    Function AcviteFilterInfo
        Dim r, s
        s = ""
        Set r = Database.DB.VExecute("SELECT * FROM CARD_FILTER WHERE SID=$SID",1,1,NullConvertTo(vbLong,Session("FILTER_SID")))
        If r.Count > 0 Then
            s = ConvertTo(vbString, r(1)("FILTER_NAME"))
        End If
        AcviteFilterInfo = s
    End Function
    
    
    
    Class ExportDatabase
        Private Export
        Public  Message
        Sub Class_Initialize
            If CurrentUser.IsServiceAllowed("EXPORT") Or IsAdmin Then
                Set Export = New CDatabase
                Export.DatabaseFile = "/export/" & CurrentUser.Id & ".db"
                Export.SessionInitializer = "InitDatabaseConnection" ' The same as the root database
            Else
                Message = TR("You are not allowed to export data")
            End If
        End Sub
        Function IsInitialized
            Dim r, dbVer ,exVer
            IsInitialized = False
            If IsNotObject(Export) Then Exit Function
            exVer = 0
            dbVer = 0
            Set r = Export.DB.Execute("SELECT VER FROM DBVERSION")
            If r.Count > 0 Then
                exVer = ConvertTo(vbLong, r(1)(1))
            End If
            Set r = Database.DB.Execute("SELECT VER FROM DBVERSION")
            If r.Count > 0 Then
                dbVer = ConvertTo(vbLong, r(1)(1))
            End If
            
            If exVer = 0 Then
                Message = TR("Export not initialized.")
            ElseIf exVer = dbVer Then
                IsInitialized = True
            Else
                Message = TR("Export is configured for different version of the database.")
            End If
        End Function
        Function ExportCard(sid)
            ExportCard = False
            If Not IsInitialized Then Exit Function
            Dim cid
            cid = NullConvertTo(vbLong, sid)
            Export.DB.Execute "ATTACH DATABASE '" & MapPath(Database.DatabaseFile) & "' AS XDB;"
            If Export.BeginTransaction Then
                
                    Export.DB.VExecute "INSERT INTO CARD SELECT * FROM XDB.CARD WHERE SID=$SID AND " & SQLReadRights, 1, 0 , cid
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID=$SID", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID=$SID", 1, 0, cid
                    
                    Export.DB.VExecute "INSERT INTO CARD_TYPE_CHRONOLOGY_REL SELECT * FROM XDB.CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$SID", 1, 0, cid
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID IN (SELECT SID FROM XDB.CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID IN (SELECT SID FROM XDB.CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    
                    Export.DB.VExecute "INSERT INTO CARD_FACILITY_REL SELECT * FROM XDB.CARD_FACILITY_REL WHERE CARD_SID=$SID", 1, 0, cid
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID IN (SELECT SID FROM XDB.CARD_FACILITY_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID IN (SELECT SID FROM XDB.CARD_FACILITY_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    
                    Export.DB.VExecute "INSERT INTO CARD_FINDING_REL SELECT * FROM XDB.CARD_FINDING_REL WHERE CARD_SID=$SID", 1, 0, cid
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID IN (SELECT SID FROM XDB.CARD_FINDING_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID IN (SELECT SID FROM XDB.CARD_FINDING_REL WHERE CARD_SID=$SID)", 1, 0, cid
                    
                    Export.DB.VExecute "INSERT INTO CARD_CORRECTION SELECT * FROM XDB.CARD_CORRECTION WHERE CARD_SID=$SID AND " & SQLReadRights, 1, 0, cid
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID IN (SELECT SID FROM XDB.CARD_CORRECTION WHERE CARD_SID=$SID AND " & SQLReadRights & ")", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID IN (SELECT SID FROM XDB.CARD_CORRECTION WHERE CARD_SID=$SID AND " & SQLReadRights & ")", 1, 0, cid
                
                    Export.DB.VExecute "INSERT INTO CARD_LOCATIONS SELECT * FROM XDB.CARD_LOCATIONS WHERE CARD_SID=$SID", 1, 0, cid
                    
                    Export.DB.VExecute "DELETE FROM BORDER_POINT WHERE CARD_SID=$SID", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO BORDER_POINT SELECT * FROM XDB.BORDER_POINT WHERE CARD_SID=$SID", 1, 0, cid
                    
                    Export.DB.VExecute "INSERT INTO IMAGE SELECT * FROM XDB.IMAGE WHERE SID IN (SELECT TARGET_SID FROM XDB.RELATION WHERE OBJECT_SID=$SID) AND " & SQLReadRights, 1, 0, cid
                    Export.DB.VExecute "INSERT INTO FILE SELECT * FROM XDB.FILE WHERE SID IN (SELECT TARGET_SID FROM XDB.RELATION WHERE OBJECT_SID=$SID) AND " & SQLReadRights, 1, 0, cid
                
                    Export.DB.VExecute "DELETE FROM SYS WHERE ID IN (SELECT TARGET_SID FROM XDB.RELATION WHERE OBJECT_SID=$SID)", 1, 0, cid
                    Export.DB.VExecute "INSERT INTO SYS SELECT * FROM XDB.SYS WHERE ID IN (SELECT TARGET_SID FROM XDB.RELATION WHERE OBJECT_SID=$SID)", 1, 0, cid
                
                
                If Export.CompleteTransaction Then
                    ExportCard = True
                End If
            Else
                Message = TR("Cannot start transaction")
            End If
            Export.DB.Execute "DETACH DATABASE XDB;" 
        End Function
        
        
    End Class

    
    

%>