<%
    ' EXAMPLE COMMON INCLUDE FILE
    ' ===========================
    ' This file and directory is intended for ASP include files used throughout the application. There is no specific rule
    ' about how they should be organized.
    ' The utility routines in this example file provide some DB access goodies and are used (or similar ones) in some examples
    ' fill free to delete everything here and organize your library base as you prefer. If you like the utility routines below
    ' keep them and include in all the pages. If so it is perhaps a good ideia to remove the comments and thus reduce the code 
    ' processed by the ASP container (IIS/PWS/ALP).

    
    ' --== Simple Database heplers for SQLite3 COM ==--
    ' How to use:
    ' When you need to execute a query just use DB.VExecute(...) or other Execute variants. The point is:
    ' call them on the DB global function. This function returns the currently opened database, or opens it if it is not
    ' yet opened. Typically you should not need to call directly GetDb which means that typically the reference count will
    ' stay 1
    Dim g_db, g_dbref
    Set g_db = Nothing
    g_dbref = 0
    Function GetDb
        If g_db Is Nothing Then
            Set g_db = Server.CreateObject("newObjects.sqlite3.dbutf8")
            g_db.Open(Server.MapPath("/db/arch.db"))
            g_db.BusyTimeout = 30000 ' Wait for lock when required by the operation for up to 30s
            ' Session parameters
            ' Remember that in SQLite3 COM you can pass named session parameters and use them in view, triggers, queries
            ' through the database function Parameter('<param_name>'). This greatly reduces the number of parameters you need
            ' to pass with each query and simplifies the queries themselves (by making possible to create more specialized views)
            ' It is a good idea to pass with each connection all the ASP session specific parameters that are of concern for the 
            ' database. See the "Using ASP-CTL" tutorial in the documentation for more information.
            g_db.Parameters("USERID") = CurrentUserId ' See later
        End If
        g_dbref = g_dbref + 1
        Set GetDb = g_db
    End Function
    Function DB
        If g_db Is Nothing Then Set DB = GetDb Else Set DB = g_db
    End Function
    
    Function FreeDb
        g_dbref = g_dbref - 1
        If g_dbref <= 0 Then
            If Not g_db Is Nothing Then g_db.Close
            Set g_db = Nothing
            g_dbref = 0
        End If
        FreeDb = g_dbref
    End Function
    
    ' Transactions. For example use them like this:
    ' BeginTransaction
    ' On Error Resume Next
    '   ... Transacted code ...
    ' message = EndTransaction(Err.Number, "Error occured: " & Err.Description)
    Sub BeginTransaction
        DB.Execute "BEGIN TRANSACTION"    
    End Sub
    Function EndTransaction(code,msg)
        If Not g_db Is Nothing Then
            If code <> 0 Then
                g_db.Execute "ROLLBACK TRANSACTION"
                EndTransaction = msg
            Else
                g_db.Execute "COMMIT TRANSACTION"
                EndTransaction = Empty
            End If    
        Else
            EndTransaction = "The database is closed!"
        End If
    End Function
    

    ' --== User management ==--
    ' This cannot be implemented in universal manner, so we put this only for example purposes
    ' A real life system may require also the group(s) to which the user belongs, identifiers of work objects
    ' user right flag sets and much more depending on the application.
    Function CurrentUserId
        Dim id
        id = Session("USER_ID") 
        If IsNull(id) Or IsEmpty(id) Then CurrentUserId = Null Else CurrentUserId = CLng(id)
    End Function
    
    ' Example rendering of the validator messages
    Sub RenderValidatorMessages
        Dim vm, I
        Set vm = GetValidatorMessages(Empty) ' Get the messages from all the validators that have been activated and failed no matter to which group they belong
        If vm.Count > 0 Then
            %>
            <table width="100%">
                <% For I = 1 To vm.Count %>
                <tr>
                    <td class="messageLight"><%= HTMLEncode(vm(I)) %></td>    
                </tr>
                <% Next %>
            </table>
            <%
        End If
    End Sub

%>