<%
    ' TO DO: Check the include directives for the framework features you will need.
    '   Because this is a common include file used by all the pages in the application
    '   this is the perfect place to refer all the framework features that will be used
    '   by the majority of the pages in the application. If some features are needed only
    '   in a few pages and nowhere else you can perform a little optimization by removing
    '   the corresponding include directives from this file and putting them only in the
    '   pages that use them. This is best done in the final stages of the development.
    '
    '   Note that the most frequently used features of the framework are automatically
    '   included by the aspctl-main.asp (the include directive is in the template page)
    '   The rest are listed here, because you may not need all of them.
%>
<!-- #include file="../aspctl/misc.asp" -->
<!-- #include file="../aspctl/aspctl-sesprefs.asp" -->
<!-- #include file="../aspctl/filestore.asp" -->
<!-- #include file="../aspctl/bincache.asp" -->
<!-- #include file="../aspctl/aspctl-encparams.asp" -->
<!-- #include file="configuration.asp" -->
<!-- #include file="userapi.asp" -->
<!-- #include file="indexer.asp" -->
<!-- #include file="card.asp" -->
<%
    ' 2. User controls that are used in the majority of the ASP-CTL pages or/and master pages.
    '   It is helpful to include the implementations of such controls globaly. Keep them to a minimum
    '   in order to reduce the overal size of the code involved in each page compilation. This will
    '   save memory on the server and allow IIS to keep more ASP pages cached in the RAM.
%>
<!-- #include file="../usercontrols/Grids/uc-simplegrid.asp" -->
<!-- #include file="../usercontrols/uc-language.asp" -->
<!-- #include file="../usercontrols/uc-login.asp" -->
<!-- #include file="../usercontrols/uc-objectrights.asp" -->
<!-- #include file="../usercontrols/uc-multilangtext.asp" -->
<!-- #include file="../usercontrols/uc-multilangtextarea.asp" -->
<!-- #include file="../usercontrols/uc-buttonmenu.asp" -->
<!-- #include file="../usercontrols/uc-linkpanel.asp" -->
<!-- #include file="../usercontrols/uc-hint.asp" -->
<%

    Dim GlobalInfoMessage ' Put a string in this variable if something must be confirmed to the user

    Sub RenderValidatorMessages
        Dim vm, I
        Set vm = GetValidatorMessages(Empty) ' Get the messages from all the validators that have been activated and failed no matter to which group they belong
        If vm.Count > 0 Then
            %>
            <table width="100%">
                <% For I = 1 To vm.Count %>
                <tr>
                    <td class="messageLight"><%= HTMLEncode(vm(I)) %></td>    
                </tr>
                <% Next %>
            </table>
            <%
        End If
    End Sub
    Sub LanguageValueIndicators(ctl)
        Dim I, coll
        Set coll = ctl.Values
        For I = 1 To coll.Count
            If coll(I) <> "" Then
                %><img src="<%= LanguageIcon(coll.Key(I)) %>" alt="<%= coll.Key(I) %>" /><%
            End If
        Next
    End Sub
    
    ' Misc. Utility functions
    
    ' String formatting
    Function FormatDouble(x,decimals)
        Dim d, g
        If ConvertTo(vbLong, deciamals) >= 0 Then g = ConvertTo(vbLong, deciamals) Else g = 2
        d = NullConvertTo(vbDouble, x)
        If IsNull(d) Then
            FormatDouble = ""
        Else
            FormatDouble = Trim(StringUtilities.Sprintf("%10." & g & "f",d))
        End If
    End Function
    Function DoubleAsPriceString(x)
        Dim d
        d = NullConvertTo(vbDouble, x)
        If IsNull(d) Then
            DoubleAsPriceString = ""
        Else
            DoubleAsPriceString = Trim(StringUtilities.Sprintf("%10.2f",d))
        End If
    End Function
    Private Function FileSizeString(sizeIn)
        Dim size
        size = ConvertTo(vbLong, sizeIn)
        If size < 0 Then
            FileSizeString = "big!"
        ElseIf size <= 999 Then
            FileSizeString = StringUtilities.Sprintf("%dB",size)
        ElseIf size >= 1000 And size < 1000000 Then
            FileSizeString = StringUtilities.Sprintf("%8.1fKB",CDbl(size) / 1024)
        ElseIf size >= 1000000 and size < 1000000000 Then
            FileSizeString = StringUtilities.Sprintf("%8.1fMB",CDbl(size) / (1024 * 1024))
        Else
            FileSizeString = StringUtilities.Sprintf("%8.1fGB",CDbl(size) / (1024 * 1024 * 1024))
        End If
    End Function
    Function GetFileExt(FileName)
        Dim n
        n = InStrRev(ConvertTo(vbString,FileName),".")
        If n > 0 Then
            GetFileExt = Mid(FileName,n + 1)
        Else
            GetFileExt = ""
        End If
    End Function
    
    Sub RenderStaticTexts(table, code, bRandom)
        Dim r, I
        If bRandom Then
            Set r = Database.DB.VExecute("SELECT * FROM " & table & " WHERE CODE LIKE $CODE AND LANGUAGE=$LANGUAGE ORDER BY random() LIMIT 1",1,1,NullLikeString(code,False,True),PageUILanguage)
        Else
            Set r = Database.DB.VExecute("SELECT * FROM " & table & " WHERE CODE LIKE $CODE AND LANGUAGE=$LANGUAGE",1,0,NullLikeString(code,False,True),PageUILanguage)
        End If
        If r.Count > 0 Then
            For I = 1 To r.Count
                %>
                <h4><%= HTMLEncode(r(I)("NAME")) %></h4>
                <%
                If ConvertTo(vbLong, r(I)("IMAGE_SID")) <> 0 Then
                    %><img src="<%= VirtPath("/image.asp") & "?image=" & ConvertTo(vbLong, r(I)("IMAGE_SID")) %>" alt="" align="right" /><%
                End If
                Response.Write BBCodeNoImages(r(I)("BODY"))
                Response.Write "<br/>"
                
            Next
        End If
        
    End Sub
    Sub RenderStaticTextById(table, tid, Lang)
        Dim r
        Set r = Database.DB.VExecute("SELECT * FROM " & table & " WHERE SID=$ID AND LANGUAGE=$LANGUAGE",1,1,NullConvertTo(vbLong, tid),Lang)
        If r.Count > 0 Then
            RenderStaticTexts table, ConvertTo(vbString,r(1)("CODE")), False
        End If
    End Sub
    
    
    ' Images
    Function ResizeKeepingAspectRatio(wimg, toWidth, toHeight, bIfBigger)
        Dim w, h
        Dim ih, iw
        Dim dw, dh
        ResizeKeepingAspectRatio = False
        If wimg.ImageCount < 1 Then Exit Function
        iw = ConvertTo(vbLong, toWidth)
        ih = ConvertTo(vbLong, toHeight)
        If iw > 0 And ih > 0 Then
            ' Fit it into that rectangle
            dw = ConvertTo(vbDouble,wimg.Width) / ConvertTo(vbDouble,iw)
            dh = ConvertTo(vbDouble,wimg.Height) / ConvertTo(vbDouble,ih)
            If Not (bIfBigger And dw < 1 And dh < 1) Then
                If dw > dh Then
                    ' By width
                    w = iw
                    h = (iw * wimg.Height) / wimg.Width
                    wimg.TransResizeWidth = w
                    wimg.TransResizeHeight = h
                    wimg.ApplyTransform
                    ResizeKeepingAspectRatio = True
                Else
                    h = ih
                    w = (ih * wimg.Width) / wimg.Height
                    wimg.TransResizeWidth = w
                    wimg.TransResizeHeight = h
                    wimg.ApplyTransform
                    ResizeKeepingAspectRatio = True
                End If
            Else
                ResizeKeepingAspectRatio = True
            End If
        ElseIf iw > 0 Then
            ' By width
            dw = ConvertTo(vbDouble,wimg.Width) / ConvertTo(vbDouble,iw)
            If Not (bIfBigger And dw < 1) Then
                w = iw
                h = (iw * wimg.Height) / wimg.Width
                wimg.TransResizeWidth = w
                wimg.TransResizeHeight = h
                wimg.ApplyTransform
                ResizeKeepingAspectRatio = True
            Else
                ResizeKeepingAspectRatio = True
            End If
        ElseIf ih > 0 Then
            dh = ConvertTo(vbDouble,wimg.Height) / ConvertTo(vbDouble,ih)
            If Not (bIfBigger And dh < 1) Then
                h = ih
                w = (ih * wimg.Width) / wimg.Height
                wimg.TransResizeWidth = w
                wimg.TransResizeHeight = h
                wimg.ApplyTransform
                ResizeKeepingAspectRatio = True
            Else
                ResizeKeepingAspectRatio = True
            End If
        End If
    End Function

%>