<%
    ' General configuration settings
    ' Some settings of similar purpose are set in the global.asa, but they are settings that may
    '   need to be changed at deployment time.
    '
    ' The settings here are mostly constants dependent on the application design
    ' and limitations. They are development time settings - determined during the development of the application
    
    ClientScripts.AsyncPostBackErrorText = TR("An error occured while trying to perform AJAX operation. Do you want to temporarily disable AJAX on this page?")
    ClientScripts.EnableAsyncLibrary
    
    ' Images
    cImageCache = "/db/imagecache.db"
        ' Image store
        Const ImageStore_Path = "/imagestore"
        Const ImageStore_NumDirs = 100
        Const ImageCache_DatabaseFile = "/db/imagecache.db"
        ImageNone_Path = VirtPath("/img/noimage.gif")
        ImageError_Path = VirtPath("/img/noimage.gif")
        ImageErrorIcon_Path = VirtPath("/img/pixel.gif")
    
        ' 4 kinds of small images may be used throughout the application
        Const ThumbnailSize = 100               ' The width is limited, but the height may grow over X pixels depending on the aspect ratio
        Const ThumbNailSizeSmall = 100          ' The width and height are limited to X pixels.
        Const ThumbNailSizeIcon = 40            ' The width is limited, but the height may grow over X pixels depending on the aspect ratio
        Const ThumbNailSizeIconSmall = 40       ' The width and height are limited to X pixels.
    
        ' Image browsers
        ' Thumbnail view
        Const ImageBrowsers_Columns = 4
        Const ImageBrowsers_Rows = 3
        Const ImageBrowsers_ThumbnailType = 2   ' Usually thumbnails small are used here
        ' List view (compact)
        Const ImageBrowsers_ListRows = 10
        Const ImageBrowsers_ListThumbnailType = 4   ' Usually icons small are used here
        
        Const cMaxImageAttachments = 10
        Const cMaxFileAttachments = 5
        
        ' File store
        Const FileStore_Path = "/filestore"
        Const FileStore_NumDirs = 100
        Const FileStore_MaxSize = 1000000
        
        ' Quotas
        ' It is important to write the table names uppercase
        Const UCQuotas_QFields = "IMAGE,STATUS,FILE,PERSON"
        Const UCQuotas_QLabels = "Images,Status reports,Files,Persons"
        Const MaxAnonymousIPActions = 2

        ' Services
        Const UCServices_Fields = "MESSAGES,MAILALL,CARD,IMAGES,FILES,RUSER,RGROUP,RALL"
        Const UCServices_Labels = "Private messages,Message any user,Enter cards,Upload images,Upload files,Edit own permisions,Edit group permisions,Edit everyone permissions"
        
        ' Notify
        Const UCNotify_Fields = "ANNOUNCE,MESSAGE,OTHER"
        Const UCNotify_Labels = "General announcements,Notification for new private messages,Other notifications"
        
        ' Persons
        cPersonAllowAvatar = True
        
        ' Email
        cMailMode = "JMail"
        cMailFromName = TR("Site administrator")
        
    ' Some common texts
    

        
%>