<%
    
    ' Full text search related routines ==================
    
    ' INDEXING Related ==========================
    
    Const KeywordSplitPattern = "[^\;\,\.\:\!\~\`\$\#\%\^\&\*\(\)\[\]\{\}\?\/\\\+\-\=\|\""\'\<\>\s]{2,20}"
    
    ' Adds the keywords found and links to the sid in the link table
    Function AddKeywords(textIn,sid)
        Dim m, re, matches, w, text
        AddKeywords = False
        text = ConvertTo(vbString, textIn)
        If Len(text) < 2 Then Exit Function
        If Database.BeginTransaction Then
        On Error Resume Next
        Err.Clear
            Set re = New RegExp
            re.Pattern = KeywordSplitPattern
            re.Global = True
            Set matches = re.Execute(text)
            For Each m In matches
                w = UCase(m.Value)
                ' Database.DB.VExecute("SELECT ID FROM KEYWORD WHERE WORD=$WORD
                Database.DB.VExecute "INSERT INTO KEYWORD (WORD) VALUES ($WORD)", 1, 0, w
                Database.DB.VExecute "INSERT INTO OBJECT_KEYWORD (OBJECT_SID,KEYWORD_ID) SELECT $SID, ID FROM KEYWORD WHERE WORD=$WORD;", 1, 0, NullConvertTo(vbLong, sid), w
            Next
            If Database.CompleteTransaction Then
                AddKeywords = True
            End If
        End If
    End Function
    Function AddNomenclatureKeywords(nom, nomSid, fieldName, sid)
        Dim r, I
        Set r = Database.DB.VExecute("SELECT * FROM [" & nom & "] WHERE SID=$sid", 1, 0 , NullConvertTo(vbLong,nomSid))
        For I = 1 To r.Count
            AddKeyWords r(I)(fieldName), sid
        Next
    End Function
    
    ' Search related ============================
    
    ' Internal use
    ' coll - keywords as keys, the values must be Boolean - True the keyword must be present, False the keyword must not be present
    ' bPos - include in the output the must present keywords
    ' bNeg - include in the output the must not present keywords
    Function WordsCollectionToDBList(coll,bPos,bNeg)
        Dim I, s
        s = ""
        For I = 1 To coll.Count
            If bPos And coll(I) Then
                If Len(s) > 0 Then s = s & ","
                s = s & "'" & UCase(Replace(coll.Key(I),"'","''")) & "'"
            ElseIf bNeg And Not coll(I) Then
                If Len(s) > 0 Then s = s & ","
                s = s & "'" & UCase(Replace(coll.Key(I),"'","''")) & "'"
            End If
        Next
        WordsCollectionToDBList = s
    End Function
    
    ' text - the keywords
    ' bPos - include the must present keywords
    ' bNeg - include the must not present keywrods
    Function KeywordIDList(text, bPos, bNeg)
        Dim coll, I, w, l, r, s, nPositive
        nPositive = 0
        Set coll = CreateCollection
        arr = Split(text," ")
        If IsArray(arr) Then
            For I = LBound(arr) To UBound(arr)
                w = UCase(arr(I))
                l = Len(w)
                If l > 0 Then
                    If Left(w,1) = "-" Then
                        If l > 1 Then coll(Mid(w,2)) = False
                    ElseIf Left(w,1) = "+" Then
                        If l > 1 Then 
                            coll(Mid(w,2)) = True
                            nPositive = nPositive + 1
                        End If
                    Else
                        coll(w) = True
                        nPositive = nPositive + 1
                    End If
                End If
            Next
        End If
        
        s = "0"
        If coll.Count > 0 Then
            If bPos Then
                l = WordsCollectionToDBList(coll, True, False)
                Set r = Database.DB.Execute("SELECT ID FROM KEYWORD WHERE WORD IN (" & l & ")")
                'If r.Count < nPositive Then
                '    s = s & ",-1" ' One or more positive keywords is not even present in the database
                'Else
                    For I = 1 To r.Count
                        s = s & "," & ConvertTo(vbLong, r(I)("ID"))
                    Next                                   
                'End If
            End If
            If bNeg Then
                l = WordsCollectionToDBList(coll, False, True)
                Set r = Database.DB.Execute("SELECT DISTINCT ID FROM KEYWORD WHERE WORD IN (" & l & ")")
                For I = 1 To r.Count
                    s = s & "," & ConvertTo(vbLong, r(I)("ID"))
                Next                                   
            End If
        End If
        
        KeywordIDList = s
    End Function
    
    ' BEGIN NOT USED
    
                        ' Optimized keyword search for a database item. The complexity is on purpose!
                        Function Create_CKeywordSearch(text)
                            Dim o
                            Set o = New CKeywordSearch
                            o.Init text
                            Set Create_CKeywordSearch = o
                        End Function
                        
                        Class CKeywordSearch
                            Dim idList
                            Sub Init(text)
                                'idList = 
                            End Sub
                        End Class
                        
                        
                        
                        
                        
                        ' Usage: The positive form should be included in listing queries which also need to include the COUNT(objectFld) in their output
                        '   and be grouped by it. This value represents the relevance of the results - i.e. how many keywords has been matched.
                        '   The negative form (bNeg = True) does not need any additional elements in the query and can be included whenever desired
                        '   Note! For this to work both the table being queried and the OBJECT_KEYWORD must be included in the FROM clause
                        '   the keywordLinkTable is its alias in the particular query.
                        Function SQLSearchCriteria(objectFld,keywordLinkTable,text,bNeg) ' Positive criteria by default
                            Dim idlist, sql
                            idlist = KeywordIDList(text, Not bNeg, bNeg)
                            If Len(idlist) > 1 Then
                                sql = "(" & objectFld & "=" & keywordLinkTable & ".OBJECT_SID AND " & keywordLinkTable & ".KEYWORD_ID " & _
                                            IfThenElse(bNeg,"NOT","") & " IN (" & idlist & "))"
                            Else
                                sql = "1=1"
                            End If
                            SQLSearchCriteria = sql
                        End Function
    
    ' END NOT USED
    
    
    
    
    Function SQLSearchAny(text, fld) ' A simpler search option where any positive keyword matched qualifies the result
        Dim pos, neg, sql
        pos = KeywordIDList(text, True, False)
        neg = KeywordIDList(text, False, True)
        sql = ""
        If pos <> "0" Then sql = sql & "(" & fld & " IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & pos & ")))"
        If neg <> "0" Then
            If Len(sql) <> 0 Then sql = sql & " AND "
            sql = sql & "(" & fld & " NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & neg & ")))"
        End If
        If Len(sql) <> 0 Then
            SQLSearchField = "(" & sql & ")"
        Else
            SQLSearchField = "1=1"
        End If
    End Function
    
    
    ' Indexers for specific datatabase entries ===================

    Function IndexEntity(sid)
        Dim r, I, code, arr
        IndexEntity = False
        If Database.BeginTransaction Then
            On Error Resume Next
            Err.Clear
            Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, sid
            Set r = Database.DB.VExecute("SELECT * FROM PERSON WHERE SID=$sid", 1, 0 , sid)
            For I = 1 To r.Count
                AddKeywords r(I)("NAME1"), sid
                AddKeywords r(I)("NAME2"), sid
                AddKeywords r(I)("NAME3"), sid
                AddKeywords r(I)("TITLE"), sid
                AddKeywords r(I)("EGN"), sid
                AddKeywords r(I)("COMMENT"), sid
            Next
            IndexEntity = Database.CompleteTransaction
            On Error Goto 0
        End If
    End Function
    Function IndexImage(sid)
        Dim r, I, code, arr
        IndexImage = False
        If Database.BeginTransaction Then
            On Error Resume Next
            Err.Clear
            Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, sid
            Set r = Database.DB.VExecute("SELECT * FROM IMAGE WHERE SID=$sid", 1, 0 , sid)
            For I = 1 To r.Count
                AddKeywords r(I)("NAME"), sid
            Next
            IndexImage = Database.CompleteTransaction
            On Error Goto 0
        End If
    End Function
    Function IndexFile(sid)
        Dim r, I, code, arr
        IndexFile = False
        If Database.BeginTransaction Then
            On Error Resume Next
            Err.Clear
            Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, sid
            Set r = Database.DB.VExecute("SELECT * FROM FILE WHERE SID=$sid", 1, 0 , sid)
            For I = 1 To r.Count
                AddKeywords r(I)("FILE_NAME"), sid
                AddKeywords r(I)("CAPTION"), sid
            Next
            IndexFile = Database.CompleteTransaction
            On Error Goto 0
        End If
    End Function
    Function IndexCard(sid)
        Dim r, I, code, arr, J, rr
        IndexCard = False
        If Database.BeginTransaction Then
            ' On Error Resume Next
            Err.Clear
            Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, sid
            Set r = Database.DB.VExecute("SELECT * FROM CARD WHERE SID=$sid", 1, 0 , sid)
            For I = 1 To r.Count
                AddKeywords r(I)("PLACE_ADDRESS"), sid
                AddKeywords r(I)("RELATIVE_LOCALIZATION"), sid
                AddKeywords r(I)("ARCHIVE_INFO"), sid
                AddKeywords r(I)("MUSEUM_INFO"), sid
                AddKeywords r(I)("OTHER_INFO"), sid
                AddKeywords r(I)("SPECIFICS"), sid
                AddKeywords r(I)("BELONG_COMPLEX"), sid
                AddKeywords r(I)("BELONG_SYSTEM"), sid
                AddKeywords r(I)("BELONG_CULTURE"), sid
                AddKeywords r(I)("RESEARCH_HISTORY"), sid
                AddKeywords r(I)("PROTECTION_COMMENT"), sid
                AddKeywords r(I)("COMMENTS"), sid
                AddKeywords r(I)("OBJECT_NUMBER"), sid
                AddKeywords r(I)("CARD_NUMBER"), sid
                AddKeywords r(I)("PUBLICATIONS_INFO"), sid
                AddKeywords r(I)("OBJECT_NAME"), sid
                AddKeywords r(I)("OBJECT_DESCRIPTION"), sid
                
                AddKeywords GetLocation(r(I)("LOCATION_SID")).FullName, sid
                
                ' Nomenclatures
                AddNomenclatureKeywords "OWNERSHIP", r(I)("OWNERSHIP_SID"), "NAME", sid
                AddNomenclatureKeywords "TERRAINUSAGE", r(I)("TERRAINUSAGE_SID"), "NAME", sid
                AddNomenclatureKeywords "GEOFORM", r(I)("GEOFORM_SID"), "NAME", sid
                AddNomenclatureKeywords "OROGRAPHY", r(I)("OROGRAPHY_SID"), "NAME", sid
                AddNomenclatureKeywords "HYDROGRAPHY", r(I)("HYDROGRAPHY_SID"), "NAME", sid
                AddNomenclatureKeywords "SOIL_TYPE", r(I)("SOIL_TYPES_SID"), "NAME", sid
                AddNomenclatureKeywords "EXPOSITION", r(I)("EXPOSITION_SID"), "NAME", sid
                AddNomenclatureKeywords "ACCESSIBILITY", r(I)("ACCESSIBILITY_SID"), "NAME", sid
                AddNomenclatureKeywords "OBSERVABILITY", r(I)("OBSERVABILITY_SID"), "NAME", sid
                AddNomenclatureKeywords "SLOPE", r(I)("SLOPE_SID"), "NAME", sid
                AddNomenclatureKeywords "CONCENTRATION", r(I)("CONCENTRATION_SID"), "NAME", sid
                AddNomenclatureKeywords "GROUPING", r(I)("GROUPING_SID"), "NAME", sid
                AddNomenclatureKeywords "PROTECTION", r(I)("PROTECTION_SID"), "NAME", sid
                AddNomenclatureKeywords "IMPORTANCE", r(I)("IMPORTANCE_SID"), "NAME", sid
                AddNomenclatureKeywords "GUARD", r(I)("GUARD_SID"), "NAME", sid
                AddNomenclatureKeywords "ENVIRONMENT", r(I)("ENVIRONMENT_SID"), "NAME", sid
                AddNomenclatureKeywords "PRESERVATION", r(I)("PRESERVATION_SID"), "NAME", sid
                AddNomenclatureKeywords "SOCIALIZATION", r(I)("SOCIALIZATION_SID"), "NAME", sid
                AddNomenclatureKeywords "USAGEREGIME", r(I)("USAGEREGIME_SID"), "NAME", sid
                AddNomenclatureKeywords "USAGEREGIME", r(I)("USAGEREGIME_SID"), "NAME", sid
                
                Set rr = Database.DB.VExecute("SELECT NAME FROM CHRONOLOGY WHERE SID IN (SELECT CHRONOLOGY_SID FROM CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$CARD)",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)("NAME"), sid
                Next
                Set rr = Database.DB.VExecute("SELECT COMMENTS FROM CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$CARD",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)(1), sid
                Next
                
                Set rr = Database.DB.VExecute("SELECT NAME FROM TYPE WHERE SID IN (SELECT TYPE_SID FROM CARD_TYPE_CHRONOLOGY_REL WHERE CARD_SID=$CARD)",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)("NAME"), sid
                Next
                
                Set rr = Database.DB.VExecute("SELECT NAME FROM FACILITY WHERE SID IN (SELECT FACILITY_SID FROM CARD_FACILITY_REL WHERE CARD_SID=$CARD)",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)("NAME"), sid
                Next
                Set rr = Database.DB.VExecute("SELECT COMMENTS FROM CARD_FACILITY_REL WHERE CARD_SID=$CARD",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)(1), sid
                Next
                
                Set rr = Database.DB.VExecute("SELECT NAME FROM FINDING WHERE SID IN (SELECT FINDING_SID FROM CARD_FINDING_REL WHERE CARD_SID=$CARD)",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)("NAME"), sid
                Next
                Set rr = Database.DB.VExecute("SELECT COMMENTS FROM CARD_FINDING_REL WHERE CARD_SID=$CARD",_
                                        1,0, NullConvertTo(vbLong,r(I)("SID")))
                For J = 1 To rr.Count
                    AddKeywords rr(J)(1), sid
                Next
                
            Next
            IndexCard = Database.CompleteTransaction
            On Error Goto 0
        End If
    End Function
    
%>