<%
    ' Various utilities for database and user related functionality
    
    Function CreateSQLParameterList(lst)
        Dim I, arr, s
        s = ""
        If IsObject(lst) Then ' A collection keyed with the field names
            For I = 1 To lst.Count
                If Len(s) > 0 Then s = s & ","
                s = s & lst.Key(I)
            Next
        Else ' Comma separated list of field names
            arr = Split(lst,",")
            For I = LBound(arr) To UBound(arr)
                If Len(s) > 0 Then s = s & ","
                s = s & arr(I)
            Next
        End If
        CreateSQLParameterList = s
    End Function
    Function CreateSQLValuesList(lst)
        Dim I, arr, s
        s = ""
        If IsObject(lst) Then ' A collection keyed with the field names
            For I = 1 To lst.Count
                If Len(s) > 0 Then s = s & ","
                s = s & "$" & lst.Key(I)
            Next
        Else ' Comma separated list of field names
            arr = Split(lst,",")
            For I = LBound(arr) To UBound(arr)
                If Len(s) > 0 Then s = s & ","
                s = s & "$" & arr(I)
            Next
        End If
        CreateSQLValuesList = s
    End Function
    Function CreateSQLInList(lst)
        Dim I, vt, s, v
        s = ""
        If IsObject(lst) Then ' A collection keyed with the field names
            For I = 1 To lst.Count
                If Len(s) > 0 Then s = s & ","
                v = lst(I)
                vt = VarType(v)
                If vt = vbInteger Or vt = vbLong Then
                    s = s & StringUtilities.Sprintf("%d",v)
                ElseIf vt = vbSingle Or vt = vbDouble Or vt = vbDate Then
                    s = s & StringUtilities.Sprintf("%M",v)
                ElseIf vt = vbString Then
                    s = s & StringUtilities.Sprintf("%q",v)
                ElseIf vt = vtNull Then
                    s = s & "NULL"
                End If
            Next
        Else ' Comma separated list of values
            s = lst
        End If
        CreateSQLInList = s
    End Function
    Function CreateSQLAssignList(lst)
        Dim I, arr, s
        s = ""
        If IsObject(lst) Then ' A collection keyed with the field names
            For I = 1 To lst.Count
                If Len(s) > 0 Then s = s & ","
                s = s & lst.Key(I) & "=$" & lst.Key(I)
            Next
        Else ' Comma separated list of field names
            arr = Split(lst,",")
            For I = LBound(arr) To UBound(arr)
                If Len(s) > 0 Then s = s & ","
                s = s & arr(I) & "=$" & arr(I)
            Next
        End If
        CreateSQLAssignList = s
    End Function
    
    ' Nomenclature
    '   TO DO: May be apply rights
    
    Function GetNomenclature(Nomenclature, sid, Lang)
        Dim r, o
        Set o = New HNomenclature
        Set r = Database.DB.VExecute("SELECT * FROM [" & Nomenclature & "] WHERE SID=$SID AND LANGUAGE=$LANGUAGE", 1, 1, ConvertTo(vbLong, sid), Lang)
        If r.Count <> 0 Then
            o.Caption = ConvertTo(vbString, r(1)("NAME"))
            o.Description = ConvertTo(vbString, r(1)("BODY"))
            o.Code = ConvertTo(vbString, r(1)("CODE"))
            o.Image = ConvertTo(vbLong, r(1)("IMAGE_SID"))
        End If
        Set GetNomenclature = o
    End Function
    Function Nomenclature(Nom,sid)
        Set Nomenclature = GetNomenclature(Nom, sid, PageUILanguage)
    End Function
    Class HNomenclature
        Public Caption, Description, Code
        Public Image
        Public Property Get Name
            Name = HTMLEncode(Caption)
        End Property
        Public Property Get NameAndImage
            Dim s
            s = "<table><tr>" & vbCrLf
            If Len(Image) <> 0 Then
                s = s & "<td align=""center"" valign=""middle"" width=""40""><img border=""0"" alt=""" & Name & """ src=""" & VirtPath("/image.asp") & "?th=3&image=" & Image & """/></td>" & vbCrLf
            End If
            If Len(Caption) <> 0 Then
                s = s & "<td align=""center"" valign=""middle"">" & Name & "</td>" & vbCrLf
            End If
            s = s & "</tr></table>" & vbCrLf
            NameAndImage = s
        End Property
    End Class
    
    Function NomenclatureList(nom)
        Set NomenclatureList = Database.DB.VExecute("SELECT * FROM [" & nom & "] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & SQLReadRights & " ORDER BY NAME",1,0,PageUILanguage)
    End Function
    
    Function SimpleNomenclatureListBox(nom)
        Dim o
        Set o = Create_CList(Empty)
        o.AddItem "", ""
        o.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME FROM [" & nom & "] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & SQLReadRights & " ORDER BY NAME",1,0,PageUILanguage),"SID","NAME"
        Set SimpleNomenclatureListBox = o
    End Function
    Function TreeNomenclatureSelector(nom)
        Dim o
        Set o = Create_UCTreeNomReadOnly(Empty)
        o.AsyncPostBack(o) = True
        o.Nomenclature = nom
        o.Width = 400
        o.Height = 200
        Set TreeNomenclatureSelector = o
    End Function
    
    Function PersonName(r)
        Dim s
        s = ""
        s = IfEmpty(r("TITLE") & " ","") & IfEmpty(r("NAME1") & " ","") & IfEmpty(r("NAME2") & " ","") & IfEmpty(r("NAME3"),"")
        PersonName = s
    End Function
    
    
    Function GetPerson(pid,Lang)
        Dim o, r
        Set o = New HPerson
        Set r = Database.DB.VExecute("SELECT * FROM PERSON WHERE SID=$SID AND LANGUAGE=$LANGUAGE AND " & SQLReadRights,1,1,NullConvertTo(vbLong, pid),Lang)
        If r. Count > 0 Then
            o.Name1 = ConvertTo(vbString, r(1)("NAME1"))
            o.Name2 = ConvertTo(vbString, r(1)("NAME2"))
            o.Name3 = ConvertTo(vbString, r(1)("NAME3"))
            o.Title = ConvertTo(vbString, r(1)("TITLE"))
            o.Id = ConvertTo(vbLong, r(1)("SID"))
            o.ImageId = ConvertTo(vbLong, r(1)("IMAGE_SID"))
            o.Comment = ConvertTo(vbString, r(1)("COMMENT"))
            o.IsValid = True
        End If
        Set GetPerson = o
    End Function
    Class HPerson
        Public Name1, Name2, Name3, Title, Comment
        Public ImageId, Id
        Public IsValid
        Public Property Get Name
            Dim s
            s = ""
            If Len(Title) > 0 Then s = s & Title & " "
            If Len(Name1) > 0 Then s = s & Name1 & " "
            If Len(Name2) > 0 Then s = s & Name2 & " "
            If Len(Name3) > 0 Then s = s & Name3 & " "
            Name = HTMLEncode(Trim(s))
        End Property
        Public Function RenderIconSmall
            If ConvertTo(vbLong,ImageId) <> 0 Then
                RenderIconSmall = "<img src=""" & VirtPath("/image.asp") & "?th=4&image=" & ImageId & """ alt=""" & Name & """ border=""0""/>"
            Else
                RenderIconSmall = "<img src=""" & VirtPath("/img/person.png") & """ alt=""" & Name & """ border=""0""/>"
            End If
        End Function
        Public Property Get IconAndName
            Dim s
            If ConvertTo(vbLong,ImageId) <> 0 Then
                s = RenderIconSmall & " "
            End If
            s = s & Name
            IconAndName = s
        End Property
    End Class

    Function DisplayFileIcon(fid,bLink)
        Dim r, s
        s = ""
        If bLink Then
            Set r = Database.DB.VExecute("SELECT * FROM FILE WHERE SID=$SID AND LANGUAGE=$LANGUAGE AND " & SQLReadRights,1,1,NullConvertTo(vbLong,fid),PageUILanguage)
        Else
            Set r = Database.DB.VExecute("SELECT * FROM FILE WHERE SID=$SID AND LANGUAGE=$LANGUAGE",1,1,NullConvertTo(vbLong,fid),PageUILanguage)
        End If
        If r.Count > 0 Then
            Set r = r(1)
            If bLink Then s = s & "<a href=""" & VirtPath("/file.asp") & "?File=" & fid & """ target=""_blank"">"
            s = s & "<img src=""" & FileIcon(GetFileExt(ConvertTo(vbString,r("FILE_NAME")))) & """ alt="""" border=""0""/>" & _
                " " & HTMLEncode(r("FILE_NAME")) & " (" & FileSizeString(ConvertTo(vbLong,r("SIZE"))) & ")"
            If bLink Then s = s & "</a>"
        End If
        DisplayFileIcon = s
    End Function
    Function DisplayFileIconFromRecord(r,bLink)
        Dim  s
        s = ""
        If r.Count > 0 Then
            Set r = r(1)
            If bLink Then s = s & "<a href=""" & VirtPath("/file.asp") & "?File=" & r("SID") & """ target=""_blank"" title=""" & HTMLEncode(r("CAPTION")) & """>"
            s = s & "<img src=""" & FileIcon(GetFileExt(ConvertTo(vbString,r("FILE_NAME")))) & """ alt="""" border=""0""/>" & _
                " " & HTMLEncode(r("FILE_NAME")) & " (" & FileSizeString(ConvertTo(vbLong,r("SIZE"))) & ")"
            If bLink Then s = s & "</a>"
        End If
        DisplayFileIconFromRecord = s
    End Function
    Function DisplayImageIcon(iid, bLink)
        Dim r, s
        s = ""
        If bLink Then
            Set r = Database.DB.VExecute("SELECT * FROM IMAGE WHERE SID=$SID AND LANGUAGE=$LANGUAGE AND " & SQLReadRights,1,1,NullConvertTo(vbLong,iid),PageUILanguage)
        Else
            Set r = Database.DB.VExecute("SELECT * FROM IMAGE WHERE SID=$SID AND LANGUAGE=$LANGUAGE",1,1,NullConvertTo(vbLong,iid),PageUILanguage)
        End If
        If r.Count > 0 Then
            Set r = r(1)
            If bLink Then s = s & "<a href=""" & VirtPath("/image.asp") & "?image=" & iid & """ target=""_blank"">"
            s = s & "<img src=""" & VirtPath("/image.asp") & "?th=4&image=" & iid & """ alt="""" border=""0""/>" & _
                " " & HTMLEncode(r("CAPTION")) & " (" & ConvertTo(vbLong,r("WIDTH")) & " x " & ConvertTo(vbLong,r("HEIGHT")) & ")"
            If bLink Then s = s & "</a>"
        End If
        DisplayImageIcon = s
    End Function
    
    Function GetLocation(locId)
        Dim r, curId, o
        curId = ConvertTo(vbLong, locId)
        Set o = New HLocation
        While curId <> 0
            Set r = Database.DB.Vexecute("SELECT * FROM LOCATION WHERE SID=$SID AND LANGUAGE=$LANGUAGE AND " & SQLReadRights,1,1,curId,PageUILanguage)
            If r.Count > 0 Then
                o.Locations.Add "", r(1)
                curId = ConvertTo(vbLong, r(1)("PARENT_SID"))
            Else
                curId = 0
            End If
        Wend
        Set GetLocation = o
    End Function
    
    Class HLocation
        Public Locations
        Sub Class_Initialize
            Set Locations = CreateList
        End Sub
        Public Property Get ShortName
            Dim s
            s = ""
            If Locations.Count > 0 Then
                s = s & Locations(1)("NAME")
            End If
            ShortName = s
        End Property
        Public Property Get FullName
            Dim s, I
            s = ""
            For I = 1 To Locations.Count
                If Len(s) > 0 Then s = s & ", "
                s = s & Locations(I)("NAME")
            Next
            FullName = s
        End Property
        Public Property Get CadCode
            Dim s
            s = ""
            If Locations.Count > 0 Then
                s = s & Locations(1)("CADCODE")
            End If
            CadCode = s
        End Property
        Public Property Get FullCadCode
            Dim s, I
            s = ""
            For I = Locations.Count To 1 Step -1
                If Len(s) > 0 Then s = s & "."
                s = s & Locations(I)("CADCODE")
            Next
            FullCadCode = s
        End Property
    End Class
    
%>