<%
    Const SimpleGrid_None = Empty
    Const SimpleGrid_Text = "TEXT"
    Const SimpleGrid_Integer = "INTEGER"
    Const SimpleGrid_Boolean = "BOOLEAN"
    Const SimpleGrid_Left = "LEFT" ' Like string 'xxx%'
    Const SimpleGrid_Both = "BOTH" ' Like string '%xxx%'
    
    ' SimpleGrid_TextLimit = 128
    
    Class UCSimpleGrid
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        Public ListQuery ' As String
        Public CountQuery ' As String
        Public ShowFilters ' As Boolean
        Public IDField ' As Integer Or String
        Public HideSelect ' As Boolean
        Public NonSelectable ' As Boolean
        Public ShowRowNumbers ' As Boolean
        Public ButtonsOnLeft ' As Boolean
        Public Database ' As newObjects.sqlite3.dbutf8
        
        Private Fields
        Private CustomVariables
        
        ' CONTROLS
        Private btnReload, btnSelect
        Private orderer, pager
        
        ' INDICATORS
        Public Selected, SelectedId
        
        ' Internals
        
        Sub Class_Initialize
            
            Set Fields = CreateDictionary
            Set CustomVariables = CreateDictionary
            ' TO DO: Initialize any user controls contained in this control e.g.
            ' Set myUserControl = New UCMyUserControl
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            ' CONTROLS
            Set btnReload = Create_CImageButton(Empty)
            btnReload.SkinId = "GridReload"
            btnReload.AsyncPostBack(Me) = True
            Set btnSelect = Create_CImageButton(Empty)
            btnSelect.SkinId = "GridSelect"
            btnSelect.AsyncPostBack(Me) = True
            
            Set orderer = Create_OrdererSet(Empty)
            orderer.SkinId = "GridOrderer"
            orderer.AsyncPostBack(Me) = True
            'orderer.ImgNone = VirtPath("/img/forder-none.gif")
            'orderer.ImgDesc = VirtPath("/img/forder-desc.gif")
            'orderer.ImgAsc = VirtPath("img/forder-asc.gif")
            Set pager = Create_ButtonPager(Empty)
            pager.SkinId = "GridPager"
            pager.AsyncPostBack(Me) = True
  
            ' Set txtBox = Create_CText(Empty)
            ' Set btnOk = Create_CButton(Empty)
            
            ' TO DO: Perform additional initialization tasks if any
            IDField = 1
            ClientScripts.EnablePostBack
            ClientScripts.EnableAsyncLibrary
            CssClass = "UCSimpleGrid"
            
        End Sub
        
        Public Property Let SelectSkinId(v)
            btnSelect.SkinId = v
        End Property
        
        ' Name, Caption, Order As Boolean, Filter As Enum, FormatterProc As String
        Public Sub AddField(n, c, o, f, fmt)
            Dim fld
            Set fld = New UCSimpleGridField
            fld.Name = n
            fld.Caption = c
            fld.Order = o
            fld.Filter = f
            If ShowFilters Then
                Set fld.Control = CreateFilterControl(fld)
                If Not fld.Control Is Nothing Then
                    Set fld.Control.AsyncPostBack(Me) = btnReload
                    ' Set fld.Control.AutoPostBack = btnReload
                End If
            End If
            If fld.Order Then
                orderer(n).Caption = c
            End If
            If Len(fmt) = 0 Then
                Set fld.Formatter = GetRef("UCSimpleGrid_DefaultFormatter")
            Else
                Set fld.Formatter = GetRef(fmt)
            End If
            Fields.Add n, fld
        End Sub
        Public Property Get Field(n)
            If IsObject(Fields(n)) Then
                Set Field = Fields(n)
            Else
                Set Field = Nothing
            End If
        End Property
        Public Property Get Variable(vkey)
            Variable = CustomVariables(vkey)
        End Property
        Public Property Let Variable(vkey,vval)
            CustomVariables(vkey) = vval
        End Property
        
        Private Function GetFilter
            Dim s, I, f
            s = " 1=1 "
            For I = 1 To Fields.Count
                Set f = Fields(I)
                If UCase(f.Filter) = UCase(SimpleGrid_Text) Or UCase(f.Filter) = UCase(SimpleGrid_Boolean) Or UCase(f.Filter) = UCase(SimpleGrid_Integer) Then
                    If Len(s) > 0 Then s = s & "AND"
                    s = s & " ($" & f.Name & " ISNULL OR " & f.Name & "=$" & f.Name & ") "
                ElseIf UCase(f.Filter) = UCase(SimpleGrid_Left) Or UCase(f.Filter) = UCase(SimpleGrid_Both) Then
                    If Len(s) > 0 Then s = s & "AND"
                    s = s & " ($" & f.Name & " ISNULL OR " & f.Name & " LIKE $" & f.Name & ") "
                End If
            Next
            GetFilter = s
        End Function
        Private Function CreateFilterControl(f)
            Dim c
            If UCase(f.Filter) = UCase(SimpleGrid_Text) Or UCase(f.Filter) = UCase(SimpleGrid_Left) Or UCase(f.Filter) = UCase(SimpleGrid_Both) Or UCase(f.Filter) = UCase(SimpleGrid_Integer) Then
                Set c = Create_CText(Me.Name & "_" & f.Name)
                c.Style = "width: 100%"
                c.CssClass = "FilterControl"
            ElseIf UCase(f.Filter) = UCase(SimpleGrid_Boolean) Then
                Set c = Create_CList(Me.Name & "_" & f.Name)
                c.Style = "width: 100%"
                c.AddItem "", ""
                c.AddItem "0", TR("No")
                c.AddItem "-1", TR("Yes")
                c.CssClass = "FilterControl"
            Else
                Set c = Nothing
            End If
            Set CreateFilterControl = c
        End Function
        Private Function GetFilterVariables
            Dim c, I, f
            Set c = CustomVariables.Clone
            c.Missing = Null
            For I = 1 To Fields.Count
                Set f = Fields(I)
                If Not f.Control Is Nothing Then
                    If UCase(f.Filter) = UCase(SimpleGrid_Text) Then
                        c(f.Name) = NullConvertTo(vbString, f.Control.Value)
                    ElseIf UCase(f.Filter) = UCase(SimpleGrid_Boolean) Then
                        If Len(f.Control.Value) = 0 Then
                            c(f.Name) = Null
                        Else
                            c(f.Name) = ConvertTo(vbLong, f.Control.Value)
                        End If
                        
                    ElseIf UCase(f.Filter) = UCase(SimpleGrid_Integer) Then
                        c(f.Name) = NullConvertTo(vbLong, f.Control.Value)
                    ElseIf UCase(f.Filter) = UCase(SimpleGrid_Left) Then
                        c(f.Name) = NullLikeString(f.Control.Value, False, True)
                    ElseIf UCase(f.Filter) = UCase(SimpleGrid_Both) Then
                        c(f.Name) = NullLikeString(f.Control.Value, True, True)
                    End If
                End If
            Next
            Set GetFilterVariables = c
        End Function
        Private Function GetList
            Dim r, vars, filt
            filt = GetFilter
            Set vars = GetFilterVariables
            
            ' Set r = Database.VExecute("SELECT Parameter('USER_ID')",1,0)
            
            pager.ItemCount = Database.CExecute(CountQuery & filt,vars,1,1)(1)(1)
            Set r = Database.CExecute(ListQuery & filt & orderer.OrderClause & pager.LimitOffsetClause, vars)
            Set GetList = r
        End Function
        Private Function ColumnClass(f)
            ColumnClass = ""
            If f.Order Then
                If orderer.SortField = f.Name Then
                    ColumnClass = "class=""ordered"""
                End If
            End If
        End Function
        
        Sub ProcessPage
            If btnSelect.Clicked Then
                Selected = True
                SelectedId = NullConvertTo(vbLong, btnSelect.Value)
                Id = ConvertTo(vbLong, btnSelect.Value)
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        ' TO DO: If needed implement properties for complex post variables - Post Collections
        ' Remember the property implemented this way returns an empty collection if this is the first time you use it.
        ' You cannot store objects in these collections - they will be lost after postback.
        ' Example:
        ' Public Property Get MyCollection
        '    Set MyCollection = PostVariables.CtlPostCollection(Me,"MyColl")
        ' End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCSimpleGrid" 
        End Property
        
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs
        End Sub
        Public Sub RenderPartial
            Dim results, rec, nRec, I, f, rowclass, totalcols, cellstyle
            totalcols = Fields.Count
            If ShowFilters Then 
                totalcols = totalcols + 1
            ElseIf Not HideSelect Then
                totalcols = totalcols + 1
            End If
            If ShowRowNumbers Then totalcols = totalcols + 1

            If Active Then
                Set results = GetList
                %>
                <table cellspacing="0" class="grid">
                    <tr class="heading">
                        <%
                        If ShowRowNumbers Then
                            %><th class="rownumber">&nbsp;</th><%
                        End If
                        If ButtonsOnLeft Then
                            %><th>&nbsp;</th><%
                        End If
                        For I = 1 To Fields.Count
                            Set f = Fields(I)
                            If f.Order Then
                                %><th onclick="<%= orderer(f.Name).GetASyncPostBack(Me) %>"><% orderer(f.Name).Render %></th><%
                            Else
                                %><th><%= HTMLEncode(f.Caption) %></th><%
                            End If
                        Next
                        If Not ButtonsOnLeft Then
                            %><th>&nbsp;</th><%
                        End If
                        %>
                    </tr>
                    <% If ShowFilters Then %>
                    <tr class="filter">
                        <%
                        If ShowRowNumbers Then
                            %><th class="rownumber">&nbsp;</th><%
                        End If
                        If ButtonsOnLeft Then
                            %><th><% btnReload.Render %></th><%
                        End If
                        For I = 1 To Fields.Count
                            Set f = Fields(I)
                            If Not f.Control Is Nothing Then
                                %><th><% f.Control.Render %></th><%
                            Else
                                %><th>&nbsp;</th><%
                            End If
                        Next
                        If Not ButtonsOnLeft Then
                            %><th><% btnReload.Render %></th><%
                        End If
                        %>
                        
                    </tr>
                    <% End If %>
                    <%
                    For nRec = 1 To results.Count
                        Set rec = results(nRec)
                        If ConvertTo(vbLong,rec(IDField)) = Id Then
                            rowclass = "selected"
                        Else
                            If nRec Mod 2 <> 0 Then rowclass = "odd" Else rowclass = "even"
                        End If
                        If Not NonSelectable Then
                            %><tr class="<%= rowclass %>" onclick="<%= btnSelect.GetAsyncPostBack(Me,ConvertTo(vbLong,rec(IDField))) %>"><%
                        Else
                            %><tr class="<%= rowclass %>"><%
                        End If    
                            If ShowRowNumbers Then
                                %><th class="rownumber"><%= (pager.Page - 1) * pager.PageSize + nRec %></th><%
                            End If
                            If ButtonsOnLeft Then
                                %>
                                <td><% 
                                If Not NonSelectable And Not HideSelect Then 
                                    btnSelect.RenderValue(ConvertTo(vbLong,rec(IDField))) 
                                End If
                                %></td>
                                <%
                            End If
                            For I = 1 To Fields.Count
                                Set f = Fields(I)
                                cellstyle = "style="""
                                If Not NonSelectable Then cellstyle = cellstyle & "cursor: pointer;"
                                If Len(f.Align) <> 0 Then cellstyle = cellstyle & "text-align: " & f.Align & ";"
                                cellstyle = cellstyle & """"
                                %><td <%= ColumnClass(f) %> <%= cellstyle %>><%= f.Formatter(rec(f.Name)) %></td><%
                            Next
                            If Not ButtonsOnLeft Then
                                %>
                                <td><% 
                                If Not NonSelectable And Not HideSelect Then 
                                    btnSelect.RenderValue(ConvertTo(vbLong,rec(IDField))) 
                                End If
                                %></td>
                                <%
                            End If
                            %>
                        </tr>
                        <%
                    Next
                    %>
                    <tr class="pager">
                        <th colspan="<%= totalcols %>"><% pager.Render %></th>
                    </tr>
                </table>
                <%
                orderer.Render
            End If
        End Sub
    
    End Class

    Class UCSimpleGridField
        Public Name, Caption, Order
        Public Filter ' As String
        Public Control
        Public Formatter
        Public Align
        Sub Class_Initialize
            Set Control = Nothing
        End Sub
        
    End Class

    Function UCSimpleGrid_DefaultFormatter(v)
        UCSimpleGrid_DefaultFormatter = HTMLEncode(ConvertTo(vbString,v))
    End Function
    Function UCSimpleGrid_Text(v)
        Dim l
        l = ConvertTo(vbLong,SimpleGrid_TextLimit)
        If l <= 0 Then l = 44
        UCSimpleGrid_Text = HTMLEncode(Elipsis(ConvertTo(vbString,v), l))
    End Function        
    Function UCSimpleGrid_Boolean(v)
        Dim b
        b = ConvertTo(vbBoolean,v)
        If b Then
            UCSimpleGrid_Boolean = TR("Yes")
        Else
            UCSimpleGrid_Boolean = TR("No")
        End If
    End Function        
    Function UCSimpleGrid_Date(v)
        Dim d
        d = NullConvertTo(vbDate, v)
        If Not IsNull(d) Then
            UCSimpleGrid_Date = FormatDateString(d,Empty)
        Else
            UCSimpleGrid_Date = " "
        End If
    End Function        
%>