<%
    Function Create_UCTabButtons(ctlName) 
        Set ctl = New UCTabButtons ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCTabButtons= ctl ' TO DO: Change the control name
    End Function

    Class UCTabButtons
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = Me.Name & "=" & Tab
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' Controls ===============
        Private btnTab
        
        ' TO DO: Declare indicator properties e.g.
        ' Public Changed
        
        ' TO DO: Declare fields you need internally for the control functionality
        Public Buttons ' As CTabButton
        Public CssClassTable ' As String - The CSS class of the holder table
        Public CssClassItem ' As String - The CSS Class for the non-selected items
        Public CssClassSelected ' As String - The CSS Class for the current item
        Public CssClassMarker ' As String - The CSS Class for the caption displayed on the button bar
        Public CssClassCaption ' As String - The CSS Class for the caption displayed on the button bar
        Public DefaultTab ' As String - the default tab
        
        Public Caption
        
        Public Clicked
        
        Sub Init
            Rendered = False
            
            Set Buttons = CreateCollection
            Set btnTab = Create_CImageButton(Empty)
            btnTab.CssClass = "UCTabButtonsButton"
            btnTab.NoLabel = True
            ' btnTab.Style = "border: 1px solid #000000;"
            
            ' Other
            CssClassTable = "tabTable"
            CssClassItem = "tabItem"
            CssClassSelected = "tabItemOn"
            CssClassMarker = "tabMarker"
            CssClassCaption = "tabCaption"
            CssClass = "UCTabButtons"
            
            Clicked = False
        End Sub
        
        Sub ProcessPage
            If Not IsPostBack Then
                If Len(ASPGET(Me.Name)) <> 0 Then Tab = ASPGET(Me.Name)
            End If
            If Len(Tab) = 0 Then Tab = DefaultTab
            If IsPostBack Then
                If btnTab.Clicked Then
                    Tab = ConvertTo(vbString,btnTab.Value)
                    Clicked = True
                End If
            Else
                If Len(Tab) = 0 Then
                    Tab = DefaultTab
                End If
                Clicked = True ' To help processing the selection
            End If
        End Sub
        
        Public Function AddButton(capt,v,img, imgOn)
            Dim o
            Set o = New CTabButton
            o.Init capt, v, img, imgOn
            Buttons.Add ConvertTo(vbString,v), o
            Set AddButton = o
        End Function

        ' Post Variables
        Public Property Get Tab
            Tab = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"T"))
        End Property
        Public Property Let Tab(v)
            PostVariables.SetCtlVar Me, "T", ConvertTo(vbString,v)
        End Property
        
        ' Async post back
        Public Property Get AsyncPostBack(ctl)
            AsyncPostBack = btnTab.AsyncPostBack(ctl)
        End Property
        Public Property Let AsyncPostBack(ctl,v)
            btnTab.AsyncPostBack(ctl) = v
        End Property
        
        Public Default Property Get Value
            Value = Tab
        End Property
        Public Property Let Value(v)
            Tab = v
        End Property
        
        Public Property Get ClassType
            ClassType = "UCTabButtons" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            Dim I
            btnTab.NoLabel = True
            %>
            <table width="100%" cellspacing="0" cellpadding="0" <%= StyleAndCssString(CssClassTable,Empty) %>>
                <tr>
                    <td <%= StyleAndCssString(CssClassCaption,Empty) %> width="100%" nowrap><%
                         If Len(Caption) <> 0 Then 
                             Response.Write HTMLEncode(Caption) 
                         ElseIf Tab <> "" Then
                             Response.Write HTMLEncode(Buttons(Tab).Caption)
                         End If
                         %>&nbsp;
                         </td>
                    <% 
                    For I = 1 To Buttons.Count 
                        btnTab.Caption = Buttons(I).Caption
                        If UCase(Tab) = UCase(Buttons(I).Value) Then
                            btnTab.Src = Buttons(I).ImageOn
                            %><td <%= StyleAndCssString(CssClassMarker,Empty) %>>&nbsp;</td>
                            <td <%= StyleAndCssString(IfThenElse(Len(CssClassItem) > 0,CssClassItem & "img",""),Empty) %> nowrap>
                                            <% btnTab.RenderValue(Buttons(I).Value) %></td>
                            <td <%= StyleAndCssString(CssClassSelected,Empty) %> nowrap>
                                            <%= btnTab.RenderLabel(Buttons(I).Value) %></td><%
                        Else
                            btnTab.Src = Buttons(I).Image
                            %><td <%= StyleAndCssString(CssClassMarker,Empty) %>>&nbsp;</td>
                            <td <%= StyleAndCssString(IfThenElse(Len(CssClassItem) > 0,CssClassItem & "img",""),Empty) %> nowrap>
                                            <% btnTab.RenderValue(Buttons(I).Value) %></td>
                            <td <%= StyleAndCssString(CssClassItem,Empty) %> nowrap>
                                            <%= btnTab.RenderLabel(Buttons(I).Value) %></td><%
                                            
                        End If
                    Next
                    %>
                    <td <%= StyleAndCssString(CssClassMarker,Empty) %>>&nbsp;&nbsp;</td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    Class CTabButton
        Public Value
        Public Caption
        Public Image
        Public ImageOn
        Public Sub Init(c,v,i,ion)
            Caption = c
            Value = v
            Image = i
            ImageOn = ion
        End Sub
    End Class  

%>