<%
    Class UCAccessDefaults ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
            Public IsGroup
            Public ShowRemove
        
        ' CONTROLS
           Private lstUser, lstGroup, lstAll
           Private btnSave, btnOpen, btnClose, btnRemove
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            
            ' INIT CONTAINED WEB CONTROLS
            Set lstUser = Create_CList(Empty)
            With lstUser
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            Set lstGroup = Create_CList(Empty)
            With lstGroup
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            Set lstAll = Create_CList(Empty)
            With lstAll
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            
            
            Set btnSave = Create_CButton(Empty)
            btnSave.Caption = TR("Save")
            btnSave.SkinId = "Green"
            btnSave.AsyncPostBack(Me) = True
            Set btnRemove = Create_CButton(Empty)
            btnRemove.Caption = TR("Remove")
            btnRemove.SkinId = "Red"
            btnRemove.AsyncPostBack(Me) = True
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            CssClass = "UCAccessDefaults"
            
        End Sub
        
        Public Sub InitSessionPreferences(vars)
        End Sub
        Public Sub SavePrefs
        End Sub
        Public Sub LoadPrefs
        End Sub
        
        Public Function Load(uid)
            Dim r
            Load = False
            If IsGroup Then
                Set r = Database.DB.VExecute("SELECT * FROM GROUP_ACCESSDEFAULTS WHERE GROUP_ID=$ID",1,1,NullConvertTo(vbLong, uid))
            Else
                Set r = Database.DB.VExecute("SELECT * FROM USER_ACCESSDEFAULTS WHERE USER_ID=$ID",1,1,NullConvertTo(vbLong, uid))
            End If
            If r.Count > 0 Then
                Set r = r(1)
                lstUser.SelectedValue = ConvertTo(vbLong,r("R_USER"))
                lstGroup.SelectedValue = ConvertTo(vbLong,r("R_GROUP"))
                lstAll.SelectedValue = ConvertTo(vbLong,r("R_ALL"))
                Id = uid
                Load = True
            End If
        End Function
        Public Function Save
            Dim tbl
            If IsGroup Then tbl = "GROUP_ACCESSDEFAULTS" Else tbl = "USER_ACCESSDEFAULTS"
            Save = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.DB.VExecute "INSERT INTO " & tbl & " (" & IfThenElse(IsGroup,"GROUP_ID","USER_ID") & ",R_USER,R_GROUP,R_ALL)" & _
                                         "  VALUES ($ID,$R_USER,$R_GROUP,$R_ALL)", 1, 0, _
                                         Id, ConvertTo(vbLong,lstUser.SelectedValue), ConvertTo(vbLong,lstGroup.SelectedValue), _
                                         ConvertTo(vbLong,lstAll.SelectedValue)
                    If Database.CompleteTransaction Then
                        Save = True
                    End If
                End If
            End If
        End Function
        Public Function Remove
            Dim tbl
            Remove = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    If IsGroup Then tbl = "GROUP_ACCESSDEFAULTS" Else tbl = "USER_ACCESSDEFAULTS"
                    Database.DB.VExecute "DELETE FROM " & tbl & " WHERE " & IfThenElse(IsGroup,"GROUP_ID","USER_ID") & "=$ID", 1, 0, Id
                    If Database.CompleteTransaction Then
                        Remove = True
                    End If
                End If
            End If
        End Function
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If btnSave.Clicked Then
                    If Save Then
                        Active = False
                    End If
                ElseIf btnRemove.Clicked Then
                    If Remove Then Active = False
                ElseIf btnOpen.Clicked Or btnClose.Clicked Then
                    If Active Then
                        Active = False
                    Else
                        Loaded = Load(Id)
                        Active = True
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
           Active = False
        End Property
        Public Property Get Loaded
            Loaded = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"L"))
        End Property
        Public Property Let Loaded(v)
            PostVariables.SetCtlVar Me, "L", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
            ' More complex example - a collection of values in the post variables
            ' Public Property Get MyCollection
            '    Set MyCollection = PostVariables.CtlPostCollection(Me,"MyColl")
            ' End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then
                 Value = Id
            End If        
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCAccessDefaults" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If Id <> 0 Then
                If Active Then
                    RenderSlim
                    RenderForm
                Else
                    RenderSlim
                End If
            End If
        End Sub
        
        Private Sub RenderSlim
            Dim sbarClass
            If Active Then sbarClass = "SelectorBarActive" Else sbarClass = "SelectorBar"
            %>
            <table class="<%= sbarClass %>" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Mode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%= TR("Default access flags") %></td>
                    <td nowrap><% 
                        If Not Active Then
                            btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="formCaption" colspan="2"><%= TR("Default access flags") %></th>
                </tr>
                <tr>
                    <td class="formLabel"><%= TR("Owner user") %></td>
                    <td class="formField"><% lstUser.Render %></td>
                </tr>
                <tr>
                    <td class="formLabel"><%= TR("Owner group") %></td>
                    <td class="formField"><% lstGroup.Render %></td>
                </tr>
                <tr>
                    <td class="formLabel"><%= TR("Everyone") %></td>
                    <td class="formField"><% lstAll.Render %></td>
                </tr>
                <tr>
                    <td colspan="2" class="formButtons">
                        <%
                            btnSave.Render
                            If ShowRemove And Loaded Then btnRemove.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCAccessDefaults(ctlName) 
        Set ctl = New UCAccessDefaults ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCAccessDefaults = ctl ' TO DO: Change the control name
    End Function

%>