<%
    Class UCCardStatus ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
        Private txtStatusComment, lstStatus, dtDate, person
        Private vldStatusComment, vldStatus, vldDate, vldPerson
        Private btnAddNew, btnOk, btnCancel, btnDelete, btnChange
        Private cRights
        Private orderer, pager
        Private binder
        
        
        ' INDICATORS
        Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set cRights = Create_UCObjectRights(Empty)
            cRights.Table = "CARD_CORRECTION"
            
            Set txtStatusComment = Create_UCMultiLangTextArea(Empty)
            Set vldStatusComment = Create_PGValidator(txtStatusComment, Empty, "CardTextArea")
            
            Set lstStatus = Create_CList(Empty)
            lstStatus.AddItem "", TR("Please select")
            lstStatus.AddSQLiteItems Database.DB.VExecute("SELECT * FROM STATUS WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & SQLReadRights & " ORDER BY NAME",1,0,PageUILanguage), "SID", "NAME"
            Set vldStatus = Create_RequiredValidator(lstStatus,Empty,True)
            vldStatus.Message = TR("Please select status")
            vldStatus.Group = Me.Name
            
            Set dtDate = Create_CDateBox(Empty)
            Set vldDate = Create_UCValidator(dtDate, Me, "AnyDate")
            vldDate.Required = True
            
            Set person = Create_UCPerson(Empty)
            Set vldPerson = Create_RequiredValidator(person,Empty,True)
            vldPerson.Message = TR("Please select/add person")
            vldPerson.Group = Me.Name
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you really want to remove this item?")
            
            Set btnAddNew = Create_CButton(Empty)
            btnAddNew.Caption = TR("Add new status report")
            btnAddNew.AsyncPostBack(Me) = True
            
            Set btnChange = Create_CButton(Empty)
            btnChange.SkinId = "Yellow"
            btnChange.Caption = TR("Edit")
            btnChange.AsyncPostBack(Me) = True
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl txtStatusComment, vbString, "STATUS_COMMENTS", vbString, "Default", "Default"
            binder.BindControl lstStatus, vbString, "STATUS_SID", vbString, "Default", "Default"
            binder.BindControl dtDate, vbDouble, "CORRECTION_DATE", vbDouble, "Default", "Default"
            binder.BindControl person, vbLong, "PERSON_SID", vbLong, "Default", "Default"
            binder.BindPostVariable Me , "C" ,vbLong , "CARD_SID" , vbLong
            
            Set orderer = Create_OrdererSet(Empty)
            orderer("STATUS_NAME").Caption = TR("Status type")
            orderer("CORRECTION_DATE").Caption = TR("Date observed")
            orderer("C.MODIFIED").Caption = TR("Modified")
            orderer("C.CREATED").Caption = TR("Created")
            
            orderer.AsyncPostBack(Me) = True
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            CssClass = "UCSimpleGrid"            
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            If ReadOnly Then Exit Function
            Set r = binder.ItemForEdit(sid,"CARD_CORRECTION")
            If r Is Nothing Then Exit Function
            If ConvertTo(vbLong, sid) = 0 Then binder.Binding("CARD_SID").Disabled = True
            binder.ReadFrom r
            binder.Binding("CARD_SID").Disabled = False
            Id = sid
            txtStatusComment.Language = PageUILanguage
            If Id = 0 Then
                ' Set defaults
                person.Id = CurrentUser.PersonId
                dtDate.DateValue = Now
            End If
            cRights.Id = Id
            Load = True
        End Function
        Public Function Save
            Dim r
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = Id
                    Set r = binder.ItemForWrite(Id, "CARD_CORRECTION")
                    If Not r Is Nothing Then
                        binder.WriteTo r
                        Id = binder.WriteItem(r,"CARD_CORRECTION")
                    End If
                    If Database.CompleteTransaction Then
                        cRights.Id = Id
                        Save = True
                    End If
                On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
        End Function
        Public Function Delete
            Delete = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = Id
                    binder.DeleteItem Id, "CARD_CORRECTION"
                    Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, id
                    Id = 0
                    If Database.CompleteTransaction Then
                        cRights.Id = Id
                        Delete = True
                    End If
                On Error Goto 0
                End If
            End If
        End Function
        
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                cRights.Id = Id
            End If
        End Function
        
        Sub ProcessPage
            If Not IsPostBack Then
                orderer.SortField = "CORRECTION_DATE"
                orderer.SortDir = -1
            Else
                If btnChange.Clicked Then
                    If Load(ConvertTo(vbLong,btnChange.Value)) Then
                        Active = True
                    End If
                ElseIf btnAddNew.Clicked Then
                    If Load(0) Then
                        Active = True
                    End If
                ElseIf btnCancel.Clicked Then
                    Active = False
                ElseIf btnOk.Clicked And Active Then
                    If Save Then
                        Changed = True
                        Active = False
                    End If
                ElseIf btnDelete.Clicked And Active Then
                    If Delete Then 
                        Changed = True
                        Active = False
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get CardId
           CardId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"C"))
        End Property
        Public Property Let CardId(v)
           PostVariables.SetCtlVar Me, "C", ConvertTo(vbLong,v)
        End Property

        Public Property Get Id ' Selected status Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active ' Is the form opened
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCCardStatus" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            RenderList
        End Sub
        Public Sub RenderList
            Dim r, rec, I, p
            pager.ItemCount = Database.DB.VExecute("SELECT COUNT(*) FROM CARD_CORRECTION C WHERE C.LANGUAGE=$LANGUAGE AND " & _
                                                   " C.CARD_SID=$CARD_SID AND " & SQLReadRightsTable("C"),1, 1,PageUILanguage, CardId)(1)(1)
            set r = Database.DB.VExecute("SELECT C.*, S.NAME AS STATUS_NAME FROM CARD_CORRECTION C, STATUS S WHERE C.STATUS_SID=S.SID AND C.LANGUAGE=$LANGUAGE AND " & _
                                                   " S.LANGUAGE=$LANGUAGE AND C.CARD_SID=$CARD_SID AND " & SQLReadRightsTable("C") & orderer.OrderClause & pager.LimitOffsetClause,1, 0, _
                                                   PageUILanguage, CardId)
            %>
            <table cellspacing="0" class="<%= CssClass %>" width="100%" style="width:100%">
                <%
                If Id = 0 And Active Then
                    %>
                    <tr class="even">
                        <td colspan="5" calign="top" align="left">
                            <% RenderForm %>
                        </td>
                    </tr>
                    <%
                Else
                    %>
                    <tr class="even">
                        <td colspan="5" calign="top" align="left">
                            <% btnAddNew.Render %>
                        </td>
                    </tr>
                    <%
                End If
                %>
                <tr class="heading">
                    <th><% orderer("STATUS_NAME").Render %></th>
                    <th><% orderer("CORRECTION_DATE").Render %></th>
                    <th><% orderer("C.MODIFIED").Render %></th>
                    <th><% orderer("C.CREATED").Render %></th>
                    <th>&nbsp;</th>
                </tr>
                <%
                For I = 1 To r.Count
                    Set rec = r(I)
                    If I Mod 2 <> 0 Then rowClass = "odd" Else rowClass = "even"
                    If ConvertTo(vbLong,rec("SID")) = Id And Active Then
                        %>
                        <tr class="<%= rowClass %>">
                            <td colspan="5" calign="top" align="left">
                                <% RenderForm %>
                            </td>
                        </tr>
                        <%
                    Else
                    %>
                    <tr class="<%= rowClass %>" onclick="<%= btnChange.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer">
                        <td nowrap><%= HTMLEncode(rec("STATUS_NAME")) %></td>
                        <td nowrap><%= FormatDateString(rec("CORRECTION_DATE"),PageUIDateFormat) %></td>
                        <td nowrap><%= FormatDateString(rec("MODIFIED"),PageUIDateTimeFormat) %></td>
                        <td nowrap><%= FormatDateString(rec("CREATED"),PageUIDateTimeFormat) %></td>
                        <td nowrap><% btnChange.RenderValue(rec("SID")) %></td>
                    </tr>
                    <tr class="<%= rowClass %>" onclick="<%= btnChange.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer">
                        <td colspan="5" calign="top" align="left">
                        <%= HTMLEncode(rec("STATUS_COMMENTS")) %><br/>
                        <%
                            Set p = GetPerson(rec("PERSON_SID"),PageUILanguage)
                            If p.IsValid Then
                                Response.Write p.RenderIconSmall & " " & p.Name
                            End If
                        %>
                        </td>
                    </tr>
                    <%
                    End If
                Next
                %>
                <tr class="pager">
                    <th colspan="5"><% pager.Render %></th>
                </tr>
                
            </table>
            <%
        End Sub
        Public Sub RenderForm
            %>
            <table class="form">
                <tr>
                    <th class="formCaption" colspan="4"><%= TR("Status") %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="4"><% cRights.Render %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Status") %></th>
                    <td nowrap class="formField"><% lstStatus.Render : vldStatus.Render %></td>
                    <th nowrap class="formLabel"><%= TR("Date observed") %></th>
                    <td nowrap class="formField"><% dtDate.Render : vldDate.Render %><%= dtDate.Format %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Observed by") %><% vldPerson.Render %></th>
                    <td nowrap class="formField" colspan="3"><% person.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Details") %><% vldStatusComment.Render %></th>
                    <td nowrap class="formField" colspan="3"><% txtStatusComment.Render %></td>
                </tr>
                <tr>
                    <td nowrap class="formButtons" colspan="4">
                        <% 
                            btnOk.Render
                            btnCancel.Render
                            Response.Write "&nbsp;"
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCCardStatus(ctlName) 
        Set ctl = New UCCardStatus ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCCardStatus = ctl ' TO DO: Change the control name
    End Function

%>