<%
    ' Shows any global (page scope) error messages collected from the Database instance of the Database
    Class UCErrorMessages ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public Database ' Checked for error messages for display
        
        ' CONTROLS
        '   TO DO: Declare control/user control variables for contained controls e.g.
        '   Private txtBox1, btnOk, myUserControl
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            
            ' INIT CONTAINED WEB CONTROLS
            '   TO DO: Create/initialize all the contained controls you use here e.g.
                ' Set txtBox = Create_CText(Empty)
                ' Set btnOk = Create_CButton(Empty)
                    ' Async post back examples
                    ' btnOk.AsyncPostBack(Me) = True ' Enable asynchronous partial post back to be initiated by this button
                    ' Set txtBox.AsyncPostBack(Me) = btnOk ' Enable async post back on text change on behalf of btnOk
                ' example validator
                ' Set vldBox = Create_CValidatorFor(Empty, txtBox, "ValidateRequired,ValidateLength")
                ' vldBox.Required = True
                ' vldBox.MaxLength = 128
                ' vldBox.Group = Me.Name ' It is important to assign an unique group name to the validators in the user control
                '                        In order to avoid mixing them with the validators outside. The easiest way is to assign the 
                '                        name of the user control as group name. Then validate them using Validate(Me.Name)
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            CssClass = "UCErrorMessages"
            
        End Sub
        
        ' SESSION Preferences
        ' TO DO: If you do not need session preferences you can remove the 3 members below
        '   Call SavePrefs in the Render phase - as late as possible
        '   Call LoadPrefs in ProcessPage or from outside when the control shows for the first time. Note that choosing the right conditions may be tricky
        '       depending on the way the application is designed. Check the documentation for a discussion on how to find the right conditions.
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            '   vars("myparam") = "hello"
        End Sub
        Public Sub SavePrefs
            ' TO DO: save the values of the session preferences
            '   example:
            '   SessionPreferences.SetCtlVar Me, "myparam", txtTextBox1.Value
            '   ' A session preference may correspond to a value of a contained control, internal variable or a property
            '   ' In this routine you must fetch it and pass it to the SessionPreferences global singleton class for safekeeping
        End Sub
        Public Sub LoadPrefs
            ' TO DO: Recover the values of the session preferences 
            '   example:
            '   txtTextBox1.Value = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "myparam"))
            '   ' When restoring the session preferences you must assign them to their roles inside the control.
            '   ' They may correspond to a value of a contained control (like the example line above), a variable, a property or they
            '   ' can even be only a base over which more than one values are calculated - this is up to you.
        End Sub
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If IsPartialRequest Then ' An async (partial page rendering) request
                    RegisterForPartialRender Me
                End If
            Else ' Get request
            End If
        End Sub
        
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCErrorMessages" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL

        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>"><% RenderPartial %></div>
            <%
        End Sub
        Public Sub RenderPartial
            Dim vm, I, message
            message = Database.ErrorMessage
            Set vm = GetValidatorMessages(Empty) ' Get the messages from all the validators that have been activated and failed no matter to which group they belong
            If vm.Count > 0 Or message <> "" Then
                %>
                <table class="<%= CssClass %>">
                    <tr>
                        <td class="image"><img src="<%= VirtPath("/img/exclamation-small.png") %>" /></td>
                        <td>
                            <% 
                                If message <> "" Then
                                    Response.Write message & "<br/>"
                                End If
                                For I = 1 To vm.Count
                                    Response.Write HTMLEncode(vm(I)) & "<br/>"
                                Next 
                            %>
                        </td>
                    </tr>
                </table>
                <%
            End If
            If Len(GlobalInfoMessage) > 0 Then
                %>
                <table class="<%= CssClass %>">
                    <tr>
                        <td class="image"><img src="<%= VirtPath("/img/information-small.png") %>" /></td>
                        <td>
                            <% 
                                    Response.Write HTMLEncode(GlobalInfoMessage)
                            %>
                        </td>
                    </tr>
                </table>
                <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCErrorMessages(ctlName) 
        Set ctl = New UCErrorMessages ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCErrorMessages = ctl ' TO DO: Change the control name
    End Function

%>