<%
    Class UCExportCfg ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
            Private btnInit, btnSave, btnIndex
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
            Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
            Private Export ' As SQLiteDb
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            If CurrentUser.IsServiceAllowed("EXPORT") Or IsAdmin Then
                Set Export = New CDatabase
                Export.DatabaseFile = "/export/" & CurrentUser.Id & ".db"
                Export.SessionInitializer = "InitDatabaseConnection" ' The same as the root database
            End If
            
            Set btnInit = Create_CButton(Empty)
            btnInit.SkinId = "Red"
            btnInit.Caption = TR("Start new")
            
            Set btnIndex = Create_CButton(Empty)
            btnIndex.SkinId = "Yellow"
            btnIndex.Caption = TR("Add index")
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            
            ' INIT CONTAINED WEB CONTROLS
            '   TO DO: Create/initialize all the contained controls you use here e.g.
                ' Set txtBox = Create_CText(Empty)
                ' Set btnOk = Create_CButton(Empty)
                    ' Async post back examples
                    ' btnOk.AsyncPostBack(Me) = True ' Enable asynchronous partial post back to be initiated by this button
                    ' Set txtBox.AsyncPostBack(Me) = btnOk ' Enable async post back on text change on behalf of btnOk
                ' example validator
                ' Set vldBox = Create_CValidatorFor(Empty, txtBox, "ValidateRequired,ValidateLength")
                ' vldBox.Required = True
                ' vldBox.MaxLength = 128
                ' vldBox.Group = Me.Name ' It is important to assign an unique group name to the validators in the user control
                '                        In order to avoid mixing them with the validators outside. The easiest way is to assign the 
                '                        name of the user control as group name. Then validate them using Validate(Me.Name)
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Private Function ImportTable(table)
            Export.DB.Execute "INSERT INTO [" & table & "] SELECT * FROM XDB.[" & table & "] WHERE NOT DELETED AND " & SQLReadRights
            Export.DB.Execute "INSERT INTO [SYS] SELECT S.* FROM XDB.[SYS] S WHERE S.ID IN (SELECT SID FROM [" & table & "])"
            Export.DB.Execute "UPDATE [" & table & "] SET CHANGED=0"
            ImportTable = True
        End Function
        Public Function InitExport
            Dim r, e, I
            InitExport = False
            If Not Export.DeleteDataStore Then
                Exit Function
            End If
            
            Export.DB.Execute "ATTACH DATABASE '" & MapPath(Database.DatabaseFile) & "' AS XDB;"
            
            If Export.BeginTransaction Then
            On Error Resume Next
                Set r = Database.DB.Execute("SELECT * FROM SQLITE_MASTER WHERE type='table' AND sql notnull ORDER BY rootpage")
                For I = 1 To r.Count
                    Export.DB.Execute(r(I)("sql"))
                Next
                Set r = Database.DB.Execute("SELECT * FROM SQLITE_MASTER WHERE type='view' AND sql notnull ORDER BY rootpage")
                For I = 1 To r.Count
                    Export.DB.Execute(r(I)("sql"))
                Next
                Set r = Database.DB.Execute("SELECT * FROM SQLITE_MASTER WHERE type='index' AND sql notnull ORDER BY rootpage")
                For I = 1 To r.Count
                    Export.DB.Execute(r(I)("sql"))
                Next
                Set r = Database.DB.Execute("SELECT * FROM SQLITE_MASTER WHERE type='trigger' AND sql notnull ORDER BY rootpage")
                For I = 1 To r.Count
                    Export.DB.Execute(r(I)("sql"))
                Next
                
                ' Create default user
                Export.DB.Execute "INSERT INTO SYS (ID, UID) VALUES (1,'0000000000000001');"
                Export.DB.Execute "INSERT INTO SYS (ID, UID) VALUES (2,'0000000000000002');"
                Export.DB.Execute "INSERT INTO S_GROUP (ID,SID,NAME,DESCRIPTION,CODE,CANLOGIN) VALUES (1,2,'Administrators','Application administrators','ADMINS',-1);"
                Export.DB.Execute "INSERT INTO USER (ID,SID,LOGIN,PASS,LEVEL,EMAIL,GROUP_ID,ATTEMPTED,FAILURES,PERSON_SID) VALUES (1,1,'root','',100,'root@localhost',1,OleSysTime(),0,NULL);"
                
                ' Transfer base data
                
                
                ImportTable "EXPOSITION"
                ImportTable "ACCESSIBILITY"
                ImportTable "OBSERVABILITY"
                ImportTable "SLOPE"
                ImportTable "CONCENTRATION"
                ImportTable "GROUPING"
                ImportTable "PROTECTION"
                ImportTable "OWNERSHIP"
                ImportTable "TERRAINUSAGE"
                ImportTable "GUARD"
                ImportTable "IMPORTANCE"
                ImportTable "ENVIRONMENT"
                ImportTable "PRESERVATION"
                ImportTable "SOCIALIZATION"
                ImportTable "USAGEREGIME"
                ImportTable "STATUS"
                ImportTable "HELP"
                ImportTable "SOIL_TYPE"
                ImportTable "GEOFORM"
                ImportTable "TYPE"
                ImportTable "CHRONOLOGY"
                ImportTable "FACILITY"
                ImportTable "FINDING"
                ImportTable "HYDROGRAPHY"
                ImportTable "OROGRAPHY"
                ImportTable "LOCATION"
                ImportTable "LOCATION_TYPE"
                ImportTable "IMAGE_TYPE"
                
                Export.DB.Execute "INSERT INTO DBVERSION SELECT * FROM XDB.DBVERSION"
                
                
                If Export.CompleteTransaction Then
                    InitExport = True
                End If
                
            End If
            
            Export.DB.Execute "DETACH DATABASE XDB;" 
        End Function
        Function AddIndex
            AddIndex = False
            Export.DB.Execute "ATTACH DATABASE '" & MapPath(Database.DatabaseFile) & "' AS XDB;"
            If Export.BeginTransaction Then
            On Error Resume Next
                Export.DB.Execute "DELETE FROM KEYWORD"
                Export.DB.Execute "DELETE FROM OBJECT_KEYWORD"
                Export.DB.Execute "INSERT INTO OBJECT_KEYWORD SELECT * FROM XDB.OBJECT_KEYWORD WHERE OBJECT_SID IN (SELECT SID FROM CARD)"
                Export.DB.Execute "INSERT INTO KEYWORD SELECT * FROM XDB.KEYWORD WHERE ID IN (SELECT KEYWORD_ID FROM OBJECT_KEYWORD)"
                
                If Export.CompleteTransaction Then
                    AddIndex = True
                End If
            End If
            Export.DB.Execute "DETACH DATABASE XDB;" 
        End Function
        
        Sub ProcessPage
            If IsPostBack Then
                If btnInit.Clicked Then
                    If CurrentUser.IsServiceAllowed("EXPORT") Or IsAdmin Then
                        If InitExport Then
                            GlobalInfoMessage = TR("Export file has been initialized successfuly.")
                        Else
                            Database.AddError TR("Failed to initialize the export file.")
                        End If
                    Else
                        Database.AddError TR("You are not allowed to export data")
                    End If
                ElseIf btnIndex.Clicked Then
                    If CurrentUser.IsServiceAllowed("EXPORT") Or IsAdmin Then
                        If AddIndex Then
                            GlobalInfoMessage = TR("Index added.")
                        Else
                            Database.AddError TR("Failed to add index.")
                        End If
                    Else
                        Database.AddError TR("You are not allowed to export data")
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        ' Frequently used properties
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        

        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            ' TO DO: If you want to attach validators to this user control this property will be used by all the standard validator procedures
            '   return whatever is appropriate for validation. For example if this control enables the user to select something and you want to attach
            '   a "required validator" you need to return Empty when nothing is selected and something else (a database Id of the item for example) otherwise.
            '   While the Value is not declared as default (to leave the option usable for other purposes) it is intended for library usage. It may be needed
            '   for future functionality enhancements - be careful to implement it as described.
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCExportCfg" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Private ExportAllRight
        Function ExportLink
            Dim r, bInitialized, dbVer ,exVer
            bInitialized = False
            exVer = 0
            dbVer = 0
            On Error Resume Next
            Set r = Export.DB.Execute("SELECT VER FROM DBVERSION")
            If r.Count > 0 Then
                exVer = ConvertTo(vbLong, r(1)(1))
            End If
            If Err.Number <> 0 Then exVer = 0
            On Error Goto 0
            
            Set r = Database.DB.Execute("SELECT VER FROM DBVERSION")
            If r.Count > 0 Then
                dbVer = ConvertTo(vbLong, r(1)(1))
            End If
            
            If exVer = 0 Then
                ExportLink = TR("Export not initialized.")
            ElseIf exVer = dbVer Then
                Set r = Export.DB.VExecute("SELECT COUNT(*) FROM CARD WHERE LANGUAGE=$LANGUAGE",1,1,PageUILanguage)
                ExportLink = "<a href=""getexport.asp"" target=""_blank"">" & TR("Download the exported data") & "</a><br/>" & _
                             ConvertTo(vbLong,r(1)(1)) & " " & TR("cards")
                ExportAllRight = True
            Else
                ExportLink = TR("Export is configured for different version of the database.")
            End If
        End Function
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            %>
            <h4><%= TR("Export status") %></h4>
            <% btnInit.Render %><br/>
            <%= ExportLink %><br/>
            <%
            If ExportAllRight Then
                btnIndex.Render
            End If
            %><br/>
            <%= TR("It is recommended to add index before downloading. Otherwise full text search will not work over the exported data!") %>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCExportCfg(ctlName) 
        Set ctl = New UCExportCfg ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCExportCfg = ctl ' TO DO: Change the control name
    End Function

%>