<%
    Const UCFileDlg_Slim = 0
    Const UCFileDlg_Form = 1
    Const UCFileDlg_List = 2

    ' Shows a file and gives its Id as a value
    ' Allows the user to select a file from the inventory or to upload a new one
    Class UCFileDlg
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public ShowSelected
        
        ' CONTROLS
        Private cFile, cList
        Private btnNew, btnEdit, btnBrowse, btnCancel, btnClear
        
        ' INDICATORS
        Public Changed ' A file has been selected or the same selection has been left after fiddling with the control
        Public Closed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
        
            Set cFile = Create_UCFileForm(Me.Name & "_F")
            Set cList = Create_UCFileList(Me.Name & "_L")
            cList.Rows = ImageBrowsers_ListRows
            
            Set btnNew = Create_CButton(Empty)
            btnNew.Caption = TR("Upload new file")
            btnNew.AsyncPostBack(Me) = True
            Set btnEdit = Create_CButton(Empty)
            btnEdit.Caption = TR("Change")
            btnEdit.SkinId = "Yellow"
            btnEdit.AsyncPostBack(Me) = True
            Set btnBrowse = Create_CButton(Empty)
            btnBrowse.Caption = TR("Browse inventory")
            btnBrowse.SkinId = "Blue"
            btnBrowse.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Close")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnClear = Create_CButton(Empty)
            btnClear.Caption = TR("Clear")
            btnClear.SkinId = "Orange"
            btnClear.AsyncPostBack(Me) = True
            
            ClientScripts.EnableAsyncLibrary
            
        End Sub
        
        Public Sub InitSessionPreferences(vars)
        End Sub
        Public Sub SavePrefs
        End Sub
        Public Sub LoadPrefs
        End Sub
        
        ' Load file for editing
        Public Function Load(fid)
            Load = False
            If cFile.Load(fid) Then
                Id = fid
                Mode = UCFileDlg_Form
                cList.Id = 0
                Load = True
            End If
        End Function
        Public Function Browse(fid)
            Id = fid
            cList.LoadPrefs
            Mode = UCFileDlg_List
            cList.Id = Id
        End Function
        
        
        Sub ProcessPage
            If btnEdit.Clicked Then
                If Id <> 0 Then
                    Load Id
                End If
            ElseIf btnBrowse.Clicked Then
                Mode = UCFileDlg_List
                cList.LoadPrefs
                cList.Id = Id
            ElseIf btnNew.Clicked Then
                Mode = UCFileDlg_Form
                cFile.Load 0
                cList.Id = 0
            ElseIf cFile.Changed Then
                Id = cFile.Id
                Changed = True
                Closed = True
                Mode = UCFileDlg_Slim
            ElseIf btnCancel.Clicked Then
                Mode = UCFileDlg_Slim
                Changed = True
                Closed = True
            ElseIf btnClear.Clicked Then
                Mode = UCFileDlg_Slim
                cList.Id = 0
                Id = 0
                Changed = True
                Closed = True
            ElseIf cList.Selected Then
                Mode = UCFileDlg_Slim
                OvertakePartialRender Me
                Changed = True
                Id = cList.Id
                Closed = True
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Mode
            Mode = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let Mode(v)
            PostVariables.SetCtlVar Me, "M", ConvertTo(vbLong,v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCFileDlg" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If Mode = UCFileDlg_Slim Then
                RenderSlim
            ElseIf Mode = UCFileDlg_Form Then
                If ShowSelected Then
                    RenderSlim
                End IF
                cFile.Render
            ElseIf Mode = UCFileDlg_List Then
                If ShowSelected Then
                    RenderSlim
                End If
                cList.Render
                ' btnCancel.Render
            End If
        End Sub
        Public Sub RenderSlim
            Dim r, rec
            If Id <> 0 Then
                Set r = Database.DB.VExecute("SELECT I.* FROM FILE I WHERE " & _
                                             " NOT I.DELETED AND I.SID=$SID AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I"),1,1,Id, PageUILanguage)
                If r.Count > 0 Then
                    Set rec = r(1)
                Else
                    Set rec = CreateCollection
                End If
            Else
                Set rec = CreateCollection
            End If
            %>
            <table class="form">
                <tr>
                    <td class="formField" style="width:100%; vertical-align: top;">
                        <table class="viewPanel">
                            <tr>
                                <td class="content" colspan="2">
                                    <% If Id <> 0 Then %>
                                        <strong><%= HTMLEncode(rec("CAPTION")) %></strong><br/>
                                        <%= FileSizeString(rec("SIZE")) %></br>
                                        <%= DisplayFileIcon(Id,True) %>
                                    <% Else %>
                                        <%= TR("No file selected") %>
                                    <% End If %>
                                </td>
                            </tr>
                            <tr>
                                <td class="buttons" width="100%" colspan="2">
                                    <% 
                                        btnNew.Render
                                        If Id <> 0 And Mode <> UCFileDlg_Form Then btnEdit.Render
                                        If Mode <> UCFileDlg_List Then btnBrowse.Render
                                        If Id <> 0 And Mode = UCFileDlg_Slim Then btnClear.Render
                                    %>
                                </td>
                            </tr>
                        </table>
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    Function Create_UCFileDlg(ctlName) 
        Set ctl = New UCFileDlg ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFileDlg = ctl ' TO DO: Change the control name
    End Function

%>