<%
    Class UCFileForm ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
        Private txtCaption, vldCaption
        Private fileField, vldFile, vldFileRequired ' File upload 
        Private binder
        Private fileStore
        Private cRights
        Private btnOk, btnCancel, btnDelete
        
        ' INDICATORS
        Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            ' INIT CONTAINED USER CONTROLS
            Set cRights = Create_UCObjectRights(Empty)
            cRights.Table = "FILE"
            
            Set fileField = Create_CFile(Empty)
            Set vldFile = Create_CValidatorFor(Empty, fileField, "ValidateUpload")
            vldFile.MaxLength = FileStore_MaxSize
            vldFile.Group = Me.Name
            vldFile.Message = TR("The uploaded file is too big. The acceptable size is up to 2 MB.")
            Set vldFileRequired = Create_CValidatorFor(Empty, fileField, "ValidateRequired")
            vldFileRequired.Required = True
            vldFileRequired.Group = Me.Name & "R"
            vldFileRequired.Message = TR("You must upload a file.")
            
            Set txtCaption = Create_UCMultiLangText(Empty)
            txtCaption.Style = "width: 100%;"
            txtCaption.SkinId = "Gray"
            Set vldCaption = Create_TextValidator(txtCaption,MaxCaptionSize,False,0,MaxCaptionSize,Empty)
            vldCaption.Group = Me.Name
            vldCaption.Message = TR("The caption can be up to 255 characters long.")
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.ConfirmationText = TR("Do you really want to delete this file?")
            btnDelete.SkinId = "Red"
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl txtCaption, vbString, "CAPTION", vbString, "Default", "Default"
            binder.BindPostVariable Me, "FS", vbLong, "SIZE", vbLong
            binder.BindPostVariable Me, "FN", vbString, "FILE_NAME", vbString
            binder.BindPostVariable Me, "CT", vbString, "CONTENT_TYPE", vbString
            binder.BindPostVariable Me, "SP", vbString, "PATH", vbString
            
            
            Set fileStore = Create_CFileStore(MapPath(FileStore_Path),FileStore_NumDirs)
            fileStore.DoNotAddTimePortion = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        ' SESSION Preferences
        ' TO DO: If you do not need session preferences you can remove the 3 members below
        '   Call SavePrefs in the Render phase - as late as possible
        '   Call LoadPrefs in ProcessPage or from outside when the control shows for the first time. Note that choosing the right conditions may be tricky
        '       depending on the way the application is designed. Check the documentation for a discussion on how to find the right conditions.
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            '   vars("myparam") = "hello"
        End Sub
        Public Sub SavePrefs
            ' TO DO: save the values of the session preferences
            '   example:
            '   SessionPreferences.SetCtlVar Me, "myparam", txtTextBox1.Value
            '   ' A session preference may correspond to a value of a contained control, internal variable or a property
            '   ' In this routine you must fetch it and pass it to the SessionPreferences global singleton class for safekeeping
        End Sub
        Public Sub LoadPrefs
            ' TO DO: Recover the values of the session preferences 
            '   example:
            '   txtTextBox1.Value = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "myparam"))
            '   ' When restoring the session preferences you must assign them to their roles inside the control.
            '   ' They may correspond to a value of a contained control (like the example line above), a variable, a property or they
            '   ' can even be only a base over which more than one values are calculated - this is up to you.
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            
            ' Response.Write "Load image: " & sid
            Set r = binder.ItemForEdit(sid, "FILE")
            
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            Id = sid
            txtCaption.Language = PageUILanguage
            cRights.Id = Id
            Load = True
        End Function
        Public Function Save
            Dim r, rType
            Dim w, h, ct, img, I, s, fext
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                Err.Clear
                    Database.FailureValue(Me,"Id") = Id
                    Database.FailureValue(Me,"ContentType") = ContentType
                    Database.FailureValue(Me,"FileStorePath") = FileStorePath
                    Database.FailureValue(Me,"Size") = Size
                    Database.FailureValue(Me,"FileName") = FileName
                    
                    Set r = binder.ItemForWrite(Id, "FILE")
                    If Not r Is Nothing Then
                        If fileField.IsUploaded Then
                            Id = r(1)("SID")
                            
                            Size = fileField.ContentLength
                            ContentType = fileField.ContentType
                            FileName = fileField.FileName
                            fext = fileField.FileNameExtension
                            FileStorePath = fileStore.StoreData(id, fileField.Data, fext)
                            If txtCaption.Values.Count = 0 Then
                                For I = LBound(SupportedLanguages) To UBound(SupportedLanguages)
                                    s = fileField.FileName & " (" & FileSizeString(fileField.ContentLength) & ")"
                                    txtCaption.LanguageValue(SupportedLanguages(I)) = s
                                Next
                            End If
                            
                            binder.WriteTo r
                            Id = binder.WriteItem(r, "FILE")
                            IndexFile Id
                        Else
                            If IsNull(NullConvertTo(vbString,binder.Value(r,"PATH"))) Then
                                ' Response.Write Id & " " & binder.Value(r,"PATH") & " " & ConvertTo(vbLong, Database.DB.VExecute("SELECT COUNT(*) FROM IMAGE_DATA WHERE SID=$SID AND DATA NOTNULL",1,1,Id)(1)(1))
                                vldFileRequired.IsValid = False
                                Database.InvalidateTransaction
                            Else
                                binder.WriteTo r
                                Id = binder.WriteItem(r,"FILE")
                                IndexFile Id
                            End If
                        End IF
                    End If
                    If Database.CompleteTransaction Then
                        Active = False
                        Changed = True
                        cRights.Id = Id
                        Save = True
                    End If
                    On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
            
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                ContentType = Failure("ContentType")
                FileName = Failure("FileName")
                FileStorePath = Failure("FileStorePath")
                Size = Failure("Size")
                cRights.Id = Id
            End If
        End Function
        
        Sub ProcessPage
            If btnOk.Clicked Then
                If Save Then Changed = True
            ElseIf btnDelete.Clicked Then
                If Delete Then Changed = True
            ElseIf btnCancel.Clicked Then
                Changed = True
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"ID"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "ID", ConvertTo(vbLong,v)
            cRights.Id = v
        End Property
        Public Property Get Size
            Size = ConvertTo(vbLong, PostVariables.GetCtlVar(Me,"FS"))
        End Property
        Public Property Let Size(v)
            PostVariables.SetCtlVar Me, "FS", ConvertTo(vbLong, v)
        End Property
        Public Property Get ContentType
            ContentType = ConvertTo(vbString, PostVariables.GetCtlVar(Me,"CT"))
        End Property
        Public Property Let ContentType(v)
            PostVariables.SetCtlVar Me, "CT", ConvertTo(vbString, v)
        End Property
        Public Property Get FileName
            FileName = ConvertTo(vbString, PostVariables.GetCtlVar(Me,"FN"))
        End Property
        Public Property Let FileName(v)
            PostVariables.SetCtlVar Me, "FN", ConvertTo(vbString, v)
        End Property
        Public Property Get FileStorePath
            FileStorePath = ConvertTo(vbString, PostVariables.GetCtlVar(Me,"SP"))
        End Property
        Public Property Let FileStorePath(v)
            PostVariables.SetCtlVar Me, "SP", ConvertTo(vbString, v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCFileForm" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            %>
            <table class="form">
                <tr>
                    <th nowrap class="formLabel" colspan="2"><% cRights.Render %></th>
                </tr>
                <tr>
                    <% If Id <> 0 Then %>
                        <th nowrap class="formLabel"><%= TR("Replace the file") %></th>
                    <% Else %>
                        <th nowrap class="formLabel"><%= TR("Choose local file to upload") %></th>
                    <% End If %>
                    <td class="formField"><% fileField.Render : vldFile.Render %></td>
                </tr>
                <% If Id <> 0 Then %>
                <tr>
                    <td nowrap class="formField" colspan="2"><%= DisplayFileIcon(Id,True) %></td>
                </tr>
                <% End If %>
                <tr>
                    <% If Id <> 0 Then %>
                        <th nowrap class="formLabel"><%= TR("Comments") %><% vldCaption.Render %></th>
                        <td class="formField" style="text-align: right">
                        <%
                            Response.Write TR("Size") & ": " & FileSizeString(Size)
                        %>
                        </td>
                    <% Else %>
                        <th nowrap colspan="2" class="formLabel"><%= TR("Comments") & " " & TR("(if left empty the file name will be used)") %><% vldCaption.Render %></th>
                    <% End If %>
                    
                </tr>
                <tr>
                    <td nowrap class="formField" colspan="2"><% txtCaption.Render %></td>
                </tr>
                <tr>
                    <td nowrap class="formButtons" colspan="2">
                        <% 
                            If Id = 0 Then btnOk.Caption = TR("Upload")
                            btnOk.Render
                            btnCancel.Render
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCFileForm(ctlName) 
        Set ctl = New UCFileForm ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFileForm = ctl ' TO DO: Change the control name
    End Function

%>