<%
    ' Image selector with various filters
    ' Constructor
    Function Create_UCFileList(ctlName) 
        Set ctl = New UCFileList ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFileList = ctl ' TO DO: Change the control name
    End Function
    Class UCFileList
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' PROPERTIES
        Public Rows
        Public ShowDeleted, OnlyEditable ' Show deleted images, show only those that the user can edit
        Public CssClassTable
        
        ' CONTROLS
        Private orderer, pager
        Private txtCaption, vldCaption
        Private lstOwnerFilter
        Private btnReload, btnCancel
        
        Private btnImage ' The image button used for file selection
        
        ' Options
        Private ckShowCaptions, ckShowDates
        
        ' INDICATORS
        Public Selected
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Init
            Rendered = False
            
            Set ckShowCaptions = Create_CCheckBox(Empty)
            ckShowCaptions.Caption = TR("Show comments")
            Set ckShowDates = Create_CCheckBox(Empty)
            ckShowDates.Caption = TR("Show dates (modified)")
            
            Set txtCaption = Create_CText(Empty)
            txtCaption.SkinId = "FilterWide"
            Set vldCaption = Create_TextValidator(txtCaption,255,False,0,255,Empty)
            vldCaption.Group = Me.Name
            
            Set lstOwnerFilter = Create_CList(Empty)
            lstOwnerFilter.AddItem 0, TR("Your own")
            lstOwnerFilter.AddItem 1, TR("Your group's own")
            lstOwnerFilter.AddItem 2, TR("All accessible")
            
            Set btnImage = Create_CImageButton(Empty)
            btnImage.SkinId = "ImageThumb"
            btnImage.NoLabel = True
            
            ' Set btnReload = Create_CImageButton(Empty)
            Set btnReload = Create_CButton(Empty)
            btnReload.Caption = TR("Reload")
            btnReload.AsyncPostBack(Me) = True
            btnReload.SkinId = "Blue"
            
            Set orderer = Create_OrdererSet(Empty)
            orderer("CAPTION").Caption = TR("Comments")
            orderer("FILE_NAME").Caption = TR("File name")
            orderer("SIZE").Caption = TR("Size")
            orderer("MODIFIED").Caption = TR("Date modified")
            orderer("CREATED").Caption = TR("Date created")
            
            orderer.AsyncPostBack(Me) = True
            Set txtCaption.AsyncPostBack(Me) = btnReload
            Set lstOwnerFilter.AsyncPostBack(Me) = btnReload
            Set ckShowCaptions.AsyncPostBack(Me) = btnReload
            Set ckShowDates.AsyncPostBack(Me) = btnReload
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Close")
            btnCancel.AsyncPostBack(Me) = True
            btnCancel.SkinId = "Orange"
            
            RegisterForPreRender Me
            
            Rows = ImageBrowsers_ListRows
            ShowDeleted = False
            CssClassTable = "UCSimpleGrid"
        End Sub
        
        Public Sub InitSessionPreferences(vars)
            vars("ShowCaptions") = True
            vars("ShowDates") = True
            vars("OwnerFilter") = 0
            vars("SortField") = "MODIFIED"
            vars("SortDir") = -1
        End Sub
        Public Sub SavePrefs
            SessionPreferences.SetCtlVar Me, "ShowCaptions", ckShowCaptions.Checked
            SessionPreferences.SetCtlVar Me, "ShowDates", ckShowDates.Checked
            
            SessionPreferences.SetCtlVar Me, "OwnerFilter", lstOwnerFilter.SelectedValue
            
            SessionPreferences.SetCtlVar Me, "SortField", orderer.SortField
            SessionPreferences.SetCtlVar Me, "SortDir", orderer.SortDir
        End Sub
        Public Sub LoadPrefs
        
            ckShowCaptions.Checked = ConvertTo(vbBoolean,SessionPreferences.GetCtlVar(Me, "ShowCaptions"))
            ckShowDates.Checked = ConvertTo(vbBoolean,SessionPreferences.GetCtlVar(Me, "ShowDates"))
            
            lstOwnerFilter.SelectedValue = ConvertTo(vbLong, SessionPreferences.GetCtlVar(Me, "OwnerFilter"))
            
            orderer.SortField = ConvertTo(vbString, SessionPreferences.GetCtlVar(Me, "SortField"))
            orderer.SortDir = ConvertTo(vbLong, SessionPreferences.GetCtlVar(Me, "SortDir"))
        End Sub
        
        
        Sub ProcessPage
            If btnImage.Clicked Then
                Id = ConvertTo(vbLong, btnImage.Value)
                Selected = True
            ElseIf btnCancel.Clicked Then
                Selected = True
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"ID"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "ID", ConvertTo(vbLong,v)
        End Property
        
        Public Property Get Value
            Value = Id
            If Id = 0 Then Value = Empty
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCFileList" 
        End Property
        
        Sub PreRender(param)
            pager.PageSize = Rows
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            SavePrefs
            RenderListView
        End Sub
        
        Private Function GetResults()
            Dim sSearchCaption, sql, params, sWhich, sRights, r
            Dim idlistPos, idlistNeg
            Set params = CreateDictionary
            params.Missing = Null
            params("LANGUAGE") = PageUILanguage
            sSearchCaption = ""
            
            If Validate(Me.Name) And Len(txtCaption.Value) > 0 Then
                sSearchCaption = txtCaption.Value
            End If
            
            Select Case ConvertTo(vbLong, lstOwnerFilter.SelectedValue)
                Case 1
                    sWhich = "I.OWNER_GROUP_ID=Parameter('GROUP_ID')"
                Case 2
                    sWhich = "1=1"
                Case Else
                    sWhich = "I.OWNER_USER_ID=Parameter('USER_ID')"
            End Select
            
            If OnlyEditable Then
                sRights = SQLWriteRightsTable("I")
            Else
                sRights = SQLReadRightsTable("I")
            End If
            
            idlistPos = KeywordIDList(sSearchCaption, True, False)
            idlistNeg = KeywordIDList(sSearchCaption, False, True)
            
            If idlistPos <> "0" Then
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM FILE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                    sWhich & " AND " & sRights & " AND I.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                    " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            Else
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM FILE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                    sWhich & " AND " & sRights & " AND I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            End If
            pager.PageSize = Rows
            
            'Response.Write sql
            'Response.End
            If idlistPos <> "0" Then
                Set r = Database.DB.CExecute("SELECT I.*, (SELECT COUNT(*) FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ") AND OBJECT_SID=I.SID) AS SEARCH_RANK " & _
                                             " FROM FILE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                                sWhich & " AND " & sRights & " AND I.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                                " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            Else
                Set r = Database.DB.CExecute("SELECT I.*, 0 AS SEARCH_RANK " & _
                                             " FROM FILE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                                sWhich & " AND " & sRights & " AND " & _
                                                " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            End If
            Set GetResults = r
        End Function
        
        Public Sub RenderListView
            Dim r, I, J, K, rec, elementCss, bPutBr, rowClass
            Set r = GetResults
            %>
            <div <%= StyleAndCssString(CssClass,Style) %>>
            <table class="<%= CssClassTable %>" cellspacing="1">
                <tr>
                    <th nowrap class="formCaption" colspan="6">
                        <%= TR("Choose a file from the inventory") %>
                    </th>
                </tr>
                <tr>
                    <th nowrap colspan="6">
                        <table class="ImageBrowserfilter">
                            <tr>
                                <th nowrap>
                                    <%= TR("Caption") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% txtCaption.Render : vldCaption.Render %>
                                </td>
                            </tr>
                            <tr>
                                <th nowrap>
                                    <%= TR("Ownership") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% lstOwnerFilter.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap colspan="2">&nbsp;</th>
                                <td nowrap colspan="1" class="formField" style="text-align: right;">
                                    <% btnReload.Render : btnCancel.Render %>
                                </td>
                            </tr>                
                        </table>                        
                    </th>
                </tr>
                <tr class="heading">
                    <th>&nbsp;</th>
                    <th nowrap><% orderer("FILE_NAME").Render %></th>
                    <th nowrap><% orderer("SIZE").Render %></th>
                    <th nowrap><% orderer("CREATED").Render %></th>
                    <th nowrap><% orderer("MODIFIED").Render %></th>
                    <th nowrap><% orderer("CAPTION").Render %></th>
                </tr>
                
                <% 
                For I = 1 To r.Count
                    Set rec = r(I)
                    If Id <> ConvertTo(vbLong,rec("SID")) Then 
                        If I Mod 2 <> 0 Then rowClass = "odd" Else rowClass = "even"
                    Else
                        rowClass = "selected"
                    End If
                    %>
                    <tr class="<%= rowClass %>" onclick="<%= btnImage.GetAsyncPostBack(Me,rec("SID")) %>" style="cursor: pointer;">
                        <% 
                        btnImage.Src = FileIcon(GetFileExt(rec("FILE_NAME")))
                        btnImage.Caption = rec("FILE_NAME")
                        If Id = ConvertTo(vbLong, rec("SID")) Then elementCss = "selected" Else elementCss = "element"
                        bPutBr = False
                        %>
                        <td nowrap><% btnImage.RenderValue(rec("SID")) %></td>
                        <td nowrap><%= HTMLEncode(Ellipsis(rec("FILE_NAME"),42)) %></td>
                        <td nowrap><%= FileSizeString(rec("SIZE")) %></td>
                        <td nowrap><%= FormatDateString(rec("CREATED"),PageUIDateTimeFormat) %></td>
                        <td nowrap><%= FormatDateString(rec("MODIFIED"),PageUIDateTimeFormat) %></td>
                        <td nowrap title="<%= HTMLEncode(rec("CAPTION")) %>"><%= HTMLEncode(Ellipsis(rec("CAPTION"),42)) %></td>
                    </tr>
                    <% 
                Next 
                %>
                <tr>
                    <td colspan="6" class="pager">
                        <% pager.Render %>
                    </td>
                </tr>
            </table>
            </div>
            <%
        End Sub
    
    End Class

%>