<%
    ' Edit a single filter
    Class UCFilterForm ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
           Private txtFilterName, vldFilterName, ctlPoint
           Private btnOk, btnCancel, btnDelete
           Private ctlProps, cRights
        
        ' INDICATORS
            Public Changed
        
        ' INTERNAL
            Private binder
        
        Sub Init
            Dim p
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set cRights = Create_UCObjectRights(Empty)
            cRights.Table = "CARD_FILTER"
            
            Set ctlPoint = New UCGPSCoordinate
            
            Set txtFilterName = Create_CText(Empty)
            txtFilterName.SkinId = "Gray"
            Set vldFilterName = Create_UCValidator(txtFilterName, Me, "CardTextLine")
            vldFilterName.Required = True
            
            Set ctlProps = Create_UCPropSheet(Empty) 
            
            Set p = ctlProps.AddProperty("LOCATION_SID", "Location", TR("Location"))
            Set p = ctlProps.AddProperty("OWNERSHIP_SID", "List", TR("Ownership"))
            p.Table = "OWNERSHIP"
            Set p = ctlProps.AddProperty("TERRAINUSAGE_SID", "List", TR("Terrain usage"))
            p.Table = "TERRAINUSAGE"
            Set p = ctlProps.AddProperty("GEOFORM_SID", "Tree", TR("Geomorphology"))
            p.Table = "GEOFORM"
            Set p = ctlProps.AddProperty("OROGRAPHY_SID", "Tree", TR("Orography"))
            p.Table = "OROGRAPHY"
            Set p = ctlProps.AddProperty("HYDROGRAPHY_SID", "Tree", TR("Hydrography"))
            p.Table = "HYDROGRAPHY"
            Set p = ctlProps.AddProperty("SOIL_TYPES_SID", "Tree", TR("Soil type"))
            p.Table = "SOIL_TYPE"
            Set p = ctlProps.AddProperty("EXPOSITION_SID", "List", TR("Exposition"))
            p.Table = "EXPOSITION"
            Set p = ctlProps.AddProperty("ACCESSIBILITY_SID", "List", TR("Accessibility"))
            p.Table = "ACCESSIBILITY"
            Set p = ctlProps.AddProperty("OBSERVABILITY_SID", "List", TR("Observability"))
            p.Table = "OBSERVABILITY"
            Set p = ctlProps.AddProperty("SLOPE_SID", "List", TR("Slope"))
            p.Table = "SLOPE"
            Set p = ctlProps.AddProperty("CONCENTRATION_SID", "List", TR("Concenration"))
            p.Table = "CONCENTRATION"
            Set p = ctlProps.AddProperty("GROUPING_SID", "List", TR("Grouping"))
            p.Table = "GROUPING"
            Set p = ctlProps.AddProperty("PROTECTION_SID", "List", TR("Protection"))
            p.Table = "PROTECTION"
            Set p = ctlProps.AddProperty("IMPORTANCE_SID", "List", TR("Importance"))
            p.Table = "IMPORTANCE"
            Set p = ctlProps.AddProperty("GUARD_SID", "List", TR("Guard"))
            p.Table = "GUARD"
            Set p = ctlProps.AddProperty("ENVIRONMENT_SID", "List", TR("Environment"))
            p.Table = "ENVIRONMENT"
            Set p = ctlProps.AddProperty("PRESERVATION_SID", "List", TR("Preservation"))
            p.Table = "PRESERVATION"
            Set p = ctlProps.AddProperty("SOCIALIZATION_SID", "List", TR("Socialization"))
            p.Table = "SOCIALIZATION"
            Set p = ctlProps.AddProperty("USAGEREGIME_SID", "List", TR("Usage regime"))
            p.Table = "USAGEREGIME"
            Set p = ctlProps.AddProperty("STATUS_SID", "List", TR("Status"))
            p.Table = "STATUS"
            
            Set p = ctlProps.AddProperty("PERSON_SID", "Person", TR("Person involved"))
            
            Set p = ctlProps.AddProperty("TYPE_SID", "Tree", TR("Type"))
            p.Table = "TYPE"
            Set p = ctlProps.AddProperty("CHRONOLOGY_SID", "Tree", TR("Chronology"))
            p.Table = "CHRONOLOGY"
            Set p = ctlProps.AddProperty("FACILITY_SID", "Tree", TR("Facilities"))
            p.Table = "FACILITY"
            Set p = ctlProps.AddProperty("FINDING_SID", "Tree", TR("Findings"))
            p.Table = "FINDING"
            
            Set p = ctlProps.AddProperty("CREATED_DATE_MIN", "Date", TR("Created after"))
            Set p = ctlProps.AddProperty("CREATED_DATE_MAX", "Date", TR("Created before"))
            
            Set p = ctlProps.AddProperty("MODIFIED_DATE_MIN", "Date", TR("Modified after"))
            Set p = ctlProps.AddProperty("MODIFIED_DATE_MAX", "Date", TR("Modified before"))
            
            Set p = ctlProps.AddProperty("ELEVATION_MIN", "Integer", TR("Elevation greater than"))
            Set p.PropValidator = Create_UCValidator(Empty, Me, "Elevation")
            Set p = ctlProps.AddProperty("ELEVATION_MAX", "Integer", TR("Elevation lower than"))
            Set p.PropValidator = Create_UCValidator(Empty, Me, "Elevation")
            Set p = ctlProps.AddProperty("GEO_RANGE", "Double", TR("Range around location"))
            Set p.PropValidator = Create_UCValidator(Empty, Me, "GeoRange")
            
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you really want to remove this item?")
            
            Dim curbinding
            Set binder = Create_CRecordBinder(Empty) ' No language
            binder.BindControl txtFilterName, vbString, "FILTER_NAME", vbString, "Default", "Default"
            Set curbinding = binder.BindControl(ctlPoint, vbDouble, "LATITUDE", vbDouble, "Default", "Default")
            curbinding.ValueName = "LATITUDE"
            Set curbinding = binder.BindControl(ctlPoint, vbDouble, "LONGITUDE", vbDouble, "Default", "Default")
            curbinding.ValueName = "LONGITUDE"
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Public Property Get AsyncPostBack
            AsyncPostBack = btnOk.AsyncPostBack(Me)
        End Property
        Public Property Let AsyncPostBack(v)
            btnOk.AsyncPostBack(Me) = v
            btnCancel.AsyncPostBack(Me) = v
            btnDelete.AsyncPostBack(Me) = v
        End Property
        
        Function Load(sid)
            Dim r
            Load = False
            Set r = binder.ItemForEdit(sid,"CARD_FILTER")
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            If Not ctlProps.Load(binder, r) Then
                Load = False
                Exit Function
            End If
            Id = sid
            cRights.Id = Id
            Load = True
        End Function
        Function Save
            Dim r
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    If Not ctlProps.Close Then
                        Database.InvalidateTransaction
                        Exit Function
                    End If
                    Database.FailureValue(Me,"Id") = Id
                    Set r = binder.ItemForWrite(Id, "CARD_FILTER")
                    If Not r Is Nothing Then
                        binder.WriteTo r
                        ctlProps.Save binder, r
                        Id = binder.WriteItem(r,"CARD_FILTER")
                    End If
                    If Database.CompleteTransaction Then
                        cRights.Id = Id
                        Save = True
                    End If
                On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
        End Function
        Public Function Delete
            Delete = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = Id
                    binder.DeleteItem Id, "CARD_FILTER"
                    Id = 0
                    If Database.CompleteTransaction Then
                        cRights.Id = Id
                        Delete = True
                    End If
                On Error Goto 0
                End If
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                cRights.Id = Id
            End If
        End Function
        
        Sub ProcessPage
            ' TO DO: If you are using advanced features like session preferences or PreserveInQueryString it is a good idea
            '   to implement them before writing the bulk of the processing code. This can be done in a separate method called at this point
            '   or in-place - choice is entirely a matter of taste.
            '
            '   example: Load session preferences assuming the control is never hidden. For more complicated scenarios see the discussion in the documentation
            '   If Not IsPostBack Then LoadPrefs
            
            If IsPostBack Then
                If btnOk.Clicked Then
                    If Save Then Changed = True
                ElseIf btnCancel.Clicked Then
                    Changed = True
                ElseIf btnDelete.Clicked Then
                    If Delete Then Changed = True
                End If
            End If
            
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCFilterForm" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If Not Active Then Exit Sub
            %>
            <table class="form">
                <tr>
                    <th class="formCaption" colspan="2"><%= TR("Define a filter") %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="2"><% cRights.Render %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Filter name") %></th>
                    <td nowrap class="formField"><% txtFilterName.Render : vldFilterName.Render %></td>
                </tr>
                <tr>
                    <td nowrap class="formField" colspan="2"><% ctlProps.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="2"><%= TR("Search around location") %><% hint.RenderHint "Filter.GPSLoc" %></th>
                </tr>
                <tr>
                    <td nowrap class="formField" colspan="2"><% ctlPoint.Render %></td>
                </tr>
                <tr>
                    <td nowrap class="formButtons" colspan="2">
                        <% 
                            btnOk.Render
                            btnCancel.Render
                            Response.Write "&nbsp;"
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCFilterForm(ctlName) 
        Set ctl = New UCFilterForm ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFilterForm = ctl ' TO DO: Change the control name
    End Function

%>