<%
    ' Lists the user's filters
    Class UCFilters ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
            Public CssClassTable
        
        ' CONTROLS
            Private pager, orderer, btnSelect, btnSearch
                    
        ' INDICATORS
            Public Selected, Used
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set btnSelect = Create_CImageButton(Empty)
            btnSelect.AsyncPostBack(Me) = True
            btnSelect.NoLabel = True
            Set btnSearch = Create_CImageButton(Empty)
            btnSearch.AsyncPostBack(Me) = True
            btnSearch.NoLabel = True
            
            btnSelect.Caption = TR("Edit")
            btnSelect.Src = VirtPath("/img/edit.png")
            btnSearch.Caption = TR("Search")
            btnSearch.Src = VirtPath("/img/search.png")
            
            Set orderer = Create_OrdererSet(Empty)
            orderer("FILTER_NAME").Caption = TR("Filter name")
            orderer("MODIFIED").Caption = TR("Modified")
            orderer("CREATED").Caption = TR("Changed")
            
            orderer.AsyncPostBack(Me) = True
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            CssClassTable = "UCSimpleGrid"
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        ' SESSION Preferences
        Public Sub InitSessionPreferences(vars)
            ' TO DO: Set initial values for the session preferences used by this control
            '   example:
            vars("OrdField") = "CREATED"
            vars("OrdDir") = -1
        End Sub
        Public Sub SavePrefs
            SessionPreferences.SetCtlVar Me, "OrdField", orderer.SortField
            SessionPreferences.SetCtlVar Me, "OrdDir", orderer.SortDir
        End Sub
        Public Sub LoadPrefs
            orderer.SortField = ConvertTo(vbString,SessionPreferences.GetCtlVar(Me, "OrdField"))
            orderer.SortDir = ConvertTo(vbLong,SessionPreferences.GetCtlVar(Me, "OrdDir"))
        End Sub
        
        Sub ProcessPage
            If Not IsPostBack Then LoadPrefs
            
            If btnSelect.Clicked Then
                Selected = True
                Id = btnSelect.Value
            ElseIf btnSearch.Clicked Then
                Used = True
                Id = btnSearch.Value
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCFilters" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            Dim r, I
            If Not Active Then Exit Sub
            pager.ItemCount = Database.DB.VExecute("SELECT COUNT(*) FROM CARD_FILTER WHERE NOT DELETED AND OWNER_USER_ID=Parameter('USER_ID') AND " & SQLReadRights,1,1)(1)(1)
            Set r = Database.DB.VExecute("SELECT * FROM CARD_FILTER WHERE NOT DELETED AND OWNER_USER_ID=Parameter('USER_ID') AND " & SQLReadRights & _
                                                    orderer.OrderClause & pager.LimitOffsetClause, 1, 0)
            %>
            <table cellspacing="0" class="<%= CssClassTable %>" width="100%" style="width:100%">
                <tr class="heading">
                    <th class="action">&nbsp;</th>
                    <th class="action">&nbsp;</th>
                    <th><% orderer("FILTER_NAME").Render %></th>
                    <th><% orderer("CREATED").Render %></th>
                    <th><% orderer("MODIFIED").Render %></th>
                </tr>
                <%
                For I = 1 To r.Count
                    Set rec = r(I)
                    If Id <> ConvertTo(vbLong,rec("SID")) Then 
                        If I Mod 2 <> 0 Then rowClass = "odd" Else rowClass = "even"
                    Else
                        rowClass = "selected"
                    End If
                    %>
                    <tr class="<%= rowClass %>">
                        <td nowrap class="action"><% btnSelect.RenderValue(rec("SID")) %></td>
                        <td nowrap class="action"><% btnSearch.RenderValue(rec("SID")) %></td>
                        <td nowrap title="<%= TR("Search with this filter") %>" onclick="<%= btnSearch.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer"><%= HTMLEncode(rec("FILTER_NAME")) %></td>
                        <td nowrap title="<%= TR("Search with this filter") %>" onclick="<%= btnSearch.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer"><%= FormatDateString(rec("CREATED"),PageUIDateTimeFormat) %></td>
                        <td nowrap title="<%= TR("Search with this filter") %>" onclick="<%= btnSearch.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer"><%= FormatDateString(rec("MODIFIED"),PageUIDateTimeFormat) %></td>
                    </tr>
                    <%
                Next
                %>
                <tr class="pager">
                    <th colspan="5"><% pager.Render %></th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCFilters(ctlName) 
        Set ctl = New UCFilters ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCFilters = ctl ' TO DO: Change the control name
    End Function

%>