<%
    ' Template for User Control (composite control containing other controls)
    Class UCGPSList
        
        ' User controls should not preserve state in the query string
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS
            ' List
            Private orderer
            Private btnAddNew, btnDel, btnEdit
            ' Form
            Private gpsPoint ' UCGPSCoordinate
            Private txtName, txtOrd, btnOk, btnCancel
            Private vldName, vldOrd
        
        ' Internal properties
        Private results
        
        Sub Init
            Rendered = False
            
            Set gpsPoint = New UCGPSCoordinate        
            
            ' Form
            Set txtName = Create_CText(Empty)
            txtName.SkinId = "Long"
            Set vldName = Create_TextValidator(txtName,128,False,0,128,Empty)
            vldName.Group = Me.Name
            Set txtOrd = Create_CText(Empty)
            txtOrd.SkinId = "Short"
            Set vldOrd = Create_NumericValidator(txtOrd,3,False,vbLong,0,999)
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            
            ' List
            Set orderer = Create_OrdererSet(Empty)
            orderer.ShowLabels = True
            orderer("LATITUDE").Caption = TR("Latitude")
            orderer("LONGITUDE").Caption = TR("Longitude")
            orderer("NAME").Caption = TR("Name")
            orderer("ORD").Caption = TR("Number")
            Set btnAddNew = Create_CButton(Empty)
            btnAddNew.Caption = TR("New")
            btnAddNew.SkinId = "Gray"
            Set btnDel = Create_CButton(Empty)
            btnDel.Caption = TR("Delete")
            btnDel.SkinId = "Red"
            Set btnEdit = Create_CButton(Empty)
            btnEdit.Caption = TR("Edit")
            btnEdit.SkinId = "Yellow"
            
            Set results = CreateCollection
            
            CssClass = "UCSimpleGrid"
            
        End Sub
        
        Sub ProcessPage
            Dim r
            
            If btnAddNew.Clicked Then
                Active = True
                EditId = 0
                txtName.Value = ""
                txtOrd.Value = ConvertTo(vbLong, Database.DB.VExecute("SELECT CASE WHEN MAX(ORD) ISNULL THEN 0 ELSE MAX(ORD) END AS M FROM BORDER_POINT WHERE CARD_SID=$cid",1,1,CurrentCardId)(1)(1)) + 1
                gpsPoint.Latitude = 0
                gpsPoint.Longitude = 0
            ElseIf btnDel.Clicked Then
                If Database.DB.BeginTransaction Then
                On Error Resume Next
                    
                    Database.DB.VExecute "DELETE FROM BORDER_POINT WHERE CARD_SID=$cid",1,0,CurrentCardId
                
                    If Database.CompleteTransaction Then
                        GlobalInfoMessage = TR("The border point has been deleted successfuly")
                    End If
                End If
            ElseIf btnEdit.Clicked Then
                If ConvertTo(vbLong,btnEdit.Value) <> 0 Then
                Set r = Database.DB.VExecute("SELECT * FROM BORDER_POINT WHERE CARD_SID=$cid AND ID=$id",1,1,CurrentCardId,ConvertTo(vbLong,btnEdit.Value))
                If r.Count > 0 Then
                    Active = True
                    EditId = btnEdit.Value
                    txtName.Value = ConvertTo(vbString, r(1)("NAME"))
                    txtOrd.Value = ConvertTo(vbLong, r(1)("ORD"))
                    gpsPoint.Latitude = ConvertTo(vbDouble, r(1)("LATITUDE"))
                    gpsPoint.Longitude = ConvertTo(vbDouble, r(1)("LONGITUDE"))
                Else
                    GlobalInfoMessage = TR("Cannot open the selected border point")
                End If
            End If
            ElseIf btnOk.Clicked Then
                If Validate(Me.Name) Then
                    If Database.BeginTransaction Then
                    On Error Resume Next
                        Database.FailureValue(Me, "EditId") = EditId
                        If EditId <> 0 Then
                            Database.DB.VExecute "UPDATE BORDER_POINT SET NAME=$name, ORD=$ord, LATITUDE=$lat, LONGITUDE=$lon WHERE CARD_SID=$cid AND ID=$id", 1, 0, _
                                                NullConvertTo(vbString, txtName.Value), ConvertTo(vbLong, txtOrd.Value), _
                                                    gpsPoint.Latitude, gpsPoint.Longitude, _
                                                    CurrentCardId, EditId
                            EditId = 0
                        Else
                            Database.DB.VExecute "INSERT INTO BORDER_POINT (NAME,ORD,LATITUDE,LONGITUDE,CARD_SID) VALUES ($name, $ord, $lat, $lon, $cid)",1, 0, _
                                                NullConvertTo(vbString, txtName.Value), ConvertTo(vbLong, txtOrd.Value), _
                                                    gpsPoint.Latitude, gpsPoint.Longitude, _
                                                    CurrentCardId
                            EditId = 0
                            
                        End If
                        
                        If Database.CompleteTransaction Then
                            Active = False
                        End If
                    End If
                End If
            ElseIf btnCancel.Clicked Then
                Active = False
                EditId = 0
            End If
            
            Set results = Database.DB.VExecute("SELECT * FROM BORDER_POINT WHERE CARD_SID=$cid" & orderer.OrderClause, 1, 0, CurrentCardId)
        End Sub
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                EditId = ConvertTo(vbLong, Failure("EditId"))
            End If
        End Function
        
        ' Post Variables ===============
        Public Property Get EditId
            EditId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"E"))
        End Property
        Public Property Let EditId(v)
            PostVariables.SetCtlVar Me, "E", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class
            ClassType = "UCGPSList" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            RenderList
        End Sub
        
        Private Sub RenderForm
            %>
            
            <tr class="selected">
                <td nowrap>&nbsp;</td>
                <td nowrap>&nbsp;</td>
                <td nowrap><% txtName.Render : vldName.Render %></td>
                <td nowrap><% txtOrd.Render : vldOrd.Render %></td>
                <td nowrap colspan="2">
                    <%
                        btnOk.Render
                        btnCancel.Render
                    %>
                </td>
            </tr>
            <tr class="selected">
                <td nowrap colspan="6"><% gpsPoint.Render %></td>
            </tr>
            <%
        End Sub
        
        Private Sub RenderList
            Dim nRec, rec
            %>
            <table <%= StyleAndCssString(CssClass,Style) %>>
                <tr class="heading">
                    <th nowrap><% orderer("LATITUDE").Render %></th>
                    <th nowrap><% orderer("LONGITUDE").Render %></th>
                    <th nowrap><% orderer("NAME").Render %></th>
                    <th nowrap><% orderer("ORD").Render %></th>
                    <th nowrap colspan="2">&nbsp;</th>
                </tr>
                
                <% For nRec = 1 to results.Count 
                    Set rec = results(nRec)
                    If Active And EditId = ConvertTo(vbLong, rec("ID")) Then
                        RenderForm
                    Else
                %>
                
                    <tr class="<%= IfThenElse(nRec Mod 2,"even","odd") %>" onclick="<%= btnEdit.GetAsyncPostBack(Me,rec("ID")) %>" style="cursor: pointer;">
                        <td nowrap><%= DisplayGPSCoordinate(rec("LATITUDE"), "Latitude") %></td>
                        <td nowrap><%= DisplayGPSCoordinate(rec("LONGITUDE"), "Longitude") %></td>
                        <td nowrap><%= HTMLEncode(rec("NAME")) %></td>
                        <td nowrap><%= HTMLEncode(rec("ORD")) %></td>
                        <td nowrap colspan="2">
                            <%
                                btnEdit.RenderValue(rec("ID"))
                                btnDel.RenderValue(rec("ID"))
                            %>
                        </td>
                    </tr>
                <% End If %>
                
                <% Next %>
                <tr class="pager">
                    <th nowrap colspan="6">
                        <% 
                            If Active And EditId = 0 Then
                                RenderForm
                            Else
                                btnAddNew.Render
                            End If
                        %>
                    </th>
                </tr>
            </table>
            <% 
            orderer.Render
        End Sub
        
    
    End Class

    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCGPSList(ctlName) 
        Set ctl = New UCGPSList ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCGPSList = ctl ' TO DO: Change the control name
    End Function

%>