<%

    ' Session("GPSCoordinateFormat") = 2

    Const GPSCOORDINATE_DMS     =   0
    Const GPSCOORDINATE_DM      =   1
    Const GPSCOORDINATE_DDEC    =   2
    
    
    ' Some routines we might need to use here and there
    ' Convert any form to double decimal degree
    Function GPSReadDMS(d,m,s,sign)
        Dim c
        GPSReadDMS = (ConvertTo(vbDouble,d) + (ConvertTo(vbDouble,m) * 1.0 + (ConvertTo(vbDouble,s)/60.0)) / 60.0) * sign
    End Function
    Function GPSReadDM(d,m,sign)
        GPSReadDM = (ConvertTo(vbDouble,d) + ConvertTo(vbDouble,m) / 60.0) * sign
    End Function
    Function GPSReadD(d,sign)
        GPSReadD = ConvertTo(vbDouble,d) * sign
    End Function
    ' Convert to text(s)
    Sub PutMarks(c,sign)
        If sign < 0 Then 
            c("Latitude") = "S" 
            c("Longitude") = "W" 
        Else 
            c("Latitude") = "N"
            c("Longitude") = "E" 
        End If            
    End Sub
    Function GPSToDMS(ByVal v)
        Dim d,m,s,sign
        sign = 1
        If v < 0 Then 
            sign = -1
            v = -v
        End If
        d = ConvertTo(vbLong,Int(v))
        m = ConvertTo(vbLong,Int((v - d) * 60))
        s = ConvertTo(vbDouble,((v - d) * 60 - m) * 60)
        Set su = Server.CreateObject("newObjects.utilctls.StringUtilities")
        Set c = CreateCollection
        PutMarks c, sign
        c.Root = su.Sprintf("%02d %02d %07.4f",d,m,s)
        c("d") = su.Sprintf("%02d",d)
        c("m") = su.Sprintf("%02d",m)
        c("s") = su.Sprintf("%07.4f",s)
        c("sign") = sign
        Set GPSToDMS = c
    End Function
    Function GPSToDM(ByVal v)
        Dim d,m,sign
        sign = 1
        If v < 0 Then 
            sign = -1
            v = -v
        End If
        d = ConvertTo(vbLong,Int(v))
        m = ConvertTo(vbDouble,(v - d) * 60)
        Set su = Server.CreateObject("newObjects.utilctls.StringUtilities")
        Set c = CreateCollection
        PutMarks c, sign
        c.Root = su.Sprintf("%02d %09.6f",d,m)
        c("d") = su.Sprintf("%02d",d)
        c("m") = su.Sprintf("%09.6f",m)
        c("sign") = sign
        Set GPSToDM = c
    End Function
    Function GPSToD(v)
        Dim d,sign
        sign = 1
        If v < 0 Then 
            sign = -1
            v = -v
        End If
        d = ConvertTo(vbDouble,v)
        Set su = Server.CreateObject("newObjects.utilctls.StringUtilities")
        Set c = CreateCollection
        PutMarks c, sign
        c.Root = su.Sprintf("%011.8f",d,m)
        c("d") = su.Sprintf("%011.8f",d,m)
        c("sign") = sign
        Set GPSToD = c
    End Function
    Function DisplayGPSCoordinate(d,sig)
        Dim ft, o
        ft = ConvertTo(vbLong,Session("GPSCoordinateFormat"))
        Select Case ft
            Case GPSCOORDINATE_DMS 
                Set o = GPStoDMS(d)
            Case GPSCOORDINATE_DM  
                Set o = GPStoDM(d)
            Case GPSCOORDINATE_DDEC
                Set o = GPStoD(d)
            Case Else
                Err.Raise 1, "UCGPSCoordinate", "Invalid FormatType"
        End Select
        DisplayGPSCoordinate = o.Root & o(sig)
    End Function
    


    ' Template for User Control (composite control containing other controls)
    Class UCGPSCoordinate
        
        ' User controls should not preserve state in the query string
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS =======================
        Private txtADeg, txtAMin, txtASec, txtBDeg, txtBMin, txtBSec      ' Format 0, 1, 2 - Only the needed fields are used
        Private rdNS, rdEW
        Private btnGoogle, btnYahoo, btnMS
        
        Public ReadOnly
       
        Sub Class_Initialize
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            ' Controls
            Set txtADeg = Create_CText(Empty)
            Set txtBDeg = Create_CText(Empty)
            Set txtAMin = Create_CText(Empty)
            Set txtBMin = Create_CText(Empty)
            Set txtASec = Create_CText(Empty)
            Set txtBSec = Create_CText(Empty)
            
            Set rdNS = Create_CRadioList(Empty)
            rdNS.AddItem 1,"N"
            rdNS.AddItem -1,"S"
            
            Set rdEW = Create_CRadioList(Empty)
            rdEW.AddItem 1, "E"
            rdEW.AddItem -1, "W"
            
            Set btnGoogle = Create_CButton(Empty)
            btnGoogle.Caption = "Google"
            Set btnYahoo = Create_CButton(Empty)
            btnYahoo.Caption = "Yahoo"
            Set btnMS = Create_CButton(Empty)
            btnMS.Caption = "MS Live"
            
            If Not IsPostBack Then
                ' Init the form mode from the session preferences
                ' We need to do that earlier in order to allow macimum freedom to the page when to set the coordinates
                FormatType = ConvertTo(vbLong,Session("GPSCoordinateFormat"))
            End If
            
        End Sub
        
        Sub ProcessPage
            Dim ft, a, b
            If IsPostBack Then
                ft = ConvertTo(vbLong,Session("GPSCoordinateFormat"))
                If ft <> FormatType Then
                    ' Convert current values gracefuly
                    ft = FormatType ' The old format type
                    a = Latitude
                    b = Longitude
                    FormatType = ConvertTo(vbLong,Session("GPSCoordinateFormat"))
                    Latitude = a
                    Longitude = b
                End If
                
                If btnGoogle.Clicked Then
                    ' ClientScripts.Block("MapOpener") = "window.open('http://maps.google.com/?ll=" & ConvertTo(vbString,Latitude) & "," & ConvertTo(vbString,Longitude) & "',null,'width:800;height:480;');"
                ElseIf btnYahoo.Clicked Then
                    ClientScripts.RegisterFile "YahooMap", "http://api.maps.yahoo.com/ajaxymap?v=3.8&appid=TqJG3tLV34G7u8NxrgSiLYSHZAOg.cpP0LcC.ExZSnc4S9FTht1IAAaOz8BthHx2jdtr1Q--"
                ElseIf btnMS.Clicked Then
                    ClientScripts.RegisterFile "MSMap", "http://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.1"
                    ClientScripts.RegisterInitializer "MSMap", "initMSMap()"
                End If
                
            End If
        End Sub
        
        ' Post Variables
        Private Property Get FormatType
            FormatType = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"FT"))
        End Property
        Private Property Let FormatType(v)
            PostVariables.SetCtlVar Me, "FT", ConvertTo(vbLong,v)
        End Property
        
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        ' Set/Get coordinate and distribute to controls
        Public Property Get Latitude
            Select Case FormatType
                Case GPSCOORDINATE_DMS 
                    Latitude = GPSReadDMS(txtADeg.Value,txtAMin.Value,txtASec.Value,ConvertTo(vbLong,rdNS.SelectedValue))
                Case GPSCOORDINATE_DM  
                    Latitude = GPSReadDM(txtADeg.Value,txtAMin.Value,ConvertTo(vbLong,rdNS.SelectedValue))
                Case GPSCOORDINATE_DDEC
                    Latitude = GPSReadD(txtADeg.Value,ConvertTo(vbLong,rdNS.SelectedValue))
                Case Else
                    Err.Raise 1, "UCGPSCoordinate", "Invalid FormatType"
            End Select
        End Property
        Public Property Let Latitude(v)
            Dim c
            Select Case FormatType
                Case GPSCOORDINATE_DMS 
                    Set c = GPStoDMS(v)
                    txtADeg.Value = c("d")
                    txtAMin.Value = c("m")
                    txtASec.Value = c("s")
                Case GPSCOORDINATE_DM  
                    Set c = GPStoDM(v)
                    txtADeg.Value = c("d")
                    txtAMin.Value = c("m")
                Case GPSCOORDINATE_DDEC
                    Set c = GPStoD(v)
                    txtADeg.Value = c("d")
                Case Else
                    Err.Raise 1, "UCGPSCoordinate", "Invalid FormatType"
            End Select
            rdNS.SelectedValue = c("sign")
        End Property
        Public Property Get Longitude
            Select Case FormatType
                Case GPSCOORDINATE_DMS 
                    Longitude = GPSReadDMS(txtBDeg.Value,txtBMin.Value,txtBSec.Value,ConvertTo(vbLong,rdEW.SelectedValue))
                Case GPSCOORDINATE_DM  
                    Longitude = GPSReadDM(txtBDeg.Value,txtBMin.Value,ConvertTo(vbLong,rdEW.SelectedValue))
                Case GPSCOORDINATE_DDEC
                    Longitude = GPSReadD(txtBDeg.Value,ConvertTo(vbLong,rdEW.SelectedValue))
                Case Else
                    Err.Raise 1, "UCGPSCoordinate", "Invalid FormatType"
            End Select
        End Property
        Public Property Let Longitude(v)
            Dim c
            Select Case FormatType
                Case GPSCOORDINATE_DMS 
                    Set c = GPStoDMS(v)
                    txtBDeg.Value = c("d")
                    txtBMin.Value = c("m")
                    txtBSec.Value = c("s")
                Case GPSCOORDINATE_DM  
                    Set c = GPStoDM(v)
                    txtBDeg.Value = c("d")
                    txtBMin.Value = c("m")
                Case GPSCOORDINATE_DDEC
                    Set c = GPStoD(v)
                    txtBDeg.Value = c("d")
                Case Else
                    Err.Raise 1, "UCGPSCoordinate", "Invalid FormatType"
            End Select
            rdEW.SelectedValue = c("sign")
        End Property
        
        Public Property Get Values(n)
            If UCase(n) = "LATITUDE" Then
                Values = Latitude
            ElseIf UCase(n) = "LONGITUDE" Then
                Values = Longitude
            End If
        End Property
        Public Property Let Values(n,v)
            If UCase(n) = "LATITUDE" Then
                Latitude = v
            ElseIf UCase(n) = "LONGITUDE" Then
                Longitude = v
            End If
        End Property
        
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class
            ClassType = "UCGPSCoordinate" 
        End Property
        Public Property Get Protocols
            Protocols = "PControl,PIndexedValues"
        End Property
        
        
        Public Sub Render
            Select Case FormatType
                Case GPSCOORDINATE_DMS 
                    RenderDMS
                Case GPSCOORDINATE_DM  
                    RenderDM
                Case GPSCOORDINATE_DDEC
                    RenderD
                Case Else
                    Response.Write "Error: Incorrect FormatType specified"
            End Select
            Response.Write "<br/>"
            btnGoogle.Render
            btnYahoo.Render
            btnMS.Render
            If btnYahoo.Clicked Then
                RenderYahooMap
            ElseIf btnGoogle.Clicked Then
                %>
                <br/>
                <a target="_blank" href="<%= "http://maps.google.com/?ll=" & ConvertTo(vbString,Latitude) & "," & ConvertTo(vbString,Longitude) %>">       .</a>
                <%
            ElseIf btnMS.Clicked Then
                RenderMSMap
            End If
        End Sub
        
        Private Sub RenderDMS
            txtADeg.Style = "width: 20pt;"
            txtADeg.MaxLength = 2
            txtAMin.Style = "width: 20pt;"
            txtAMin.MaxLength = 2
            txtASec.Style = "width: 40pt;"
            txtASec.MaxLength = 7
            %>
                Latitude <% txtADeg.Render %>&#176; <% txtAMin.Render %>&#39; <% txtASec.Render %>&#34; <% rdNS.Render %>
            <%
            txtBDeg.Style = "width: 20pt;"
            txtBDeg.MaxLength = 2
            txtBMin.Style = "width: 20pt;"
            txtBMin.MaxLength = 2
            txtBSec.Style = "width: 40pt;"
            txtBSec.MaxLength = 7
            %>
                Longitude <% txtBDeg.Render %>&#176; <% txtBMin.Render %>&#39; <% txtBSec.Render %>&#34; <% rdEW.Render %>
            <%
        End Sub
        
        Private Sub RenderDM
            txtADeg.Style = "width: 20pt;"
            txtADeg.MaxLength = 2
            txtAMin.Style = "width: 60pt;"
            txtAMin.MaxLength = 9
            %>
                Latitude <% txtADeg.Render %>&#176; <% txtAMin.Render %>&#39; <% rdNS.Render %>
            <%
            txtBDeg.Style = "width: 20pt;"
            txtBDeg.MaxLength = 2
            txtBMin.Style = "width: 60pt;"
            txtBMin.MaxLength = 9
            %>
                Longitude <% txtBDeg.Render %>&#176; <% txtBMin.Render %>&#39; <% rdEW.Render %>
            <%
        End Sub
        
        Private Sub RenderD
            txtADeg.Style = "width: 80pt;"
            txtADeg.MaxLength = 11
            %>
                Latitude <% txtADeg.Render %>&#176; <% rdNS.Render %>
            <%
            txtBDeg.Style = "width: 80pt;"
            txtBDeg.MaxLength = 11
            %>
                Longitude <% txtBDeg.Render %>&#176; <% rdEW.Render %>
            <%
        End Sub
        Sub RenderYahooMap
        %>
        <br/>
        <div id="yahoomap" style="width:100%;height:300"></div>
        <script type="text/javascript">  
            // Create a map object  
            var map = new YMap(document.getElementById('yahoomap'));  
          
            // Add map type control  
            map.addTypeControl();  
          
            // Set map type to either of: YAHOO_MAP_SAT, YAHOO_MAP_HYB, YAHOO_MAP_REG  
            map.setMapType(YAHOO_MAP_HYB);  
            
            var place = new YGeoPoint(<%= ConvertTo(vbString,Latitude) & "," & ConvertTo(vbString,Longitude) %>);
            map.addMarker(place, null);
            map.addZoomShort();
            map.addPanControl();
            
            // var mapsize = new YSize(yahoomap.style.width,yahoomap.style.height);
            var mapsize = new YSize(600,300);
            // Display the map centered on a geocoded location  
            map.drawZoomAndCenter(place, 6);  
            map.resizeTo(mapsize)
        </script> 
        <%
        End Sub
        
        Sub RenderMSMap
        %>
        <br/>
        <div id="mslivemap" style="position:relative; width:100%; height:300px;"></div>
        <script type="text/javascript">
              var map = null;
              var pinid = 0;
                    
              function GetMap() {
                 map = new VEMap('mslivemap');
                 map.LoadMap(new VELatLong(<%= ConvertTo(vbString,Latitude) & "," & ConvertTo(vbString,Longitude) %>), 10 ,'h' ,false);
                 map.SetZoomLevel(8);
              }
              
              function AddPushpin() {
                  var shape = new VEShape(VEShapeType.Pushpin, map.GetCenter());
                  shape.SetTitle('<%= JSEscape(TR("The point")) %>');
                  // shape.SetDescription('This is shape number '+pinid);
                  pinid++;
                  map.AddShape(shape);
              }
              function initMSMap() {
                GetMap();
                AddPushpin();
              }

              </script>
        <%
        End Sub
        
        
  ' http://maps.google.com/?ll=51.455558,-2.605047      
  ' Yahoo ID: TqJG3tLV34G7u8NxrgSiLYSHZAOg.cpP0LcC.ExZSnc4S9FTht1IAAaOz8BthHx2jdtr1Q--
    End Class

%>