<%
    ' Group selection and management control
    Class UCGroupSel
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS
        Private txtName, txtDescription
        Private vldName, vldDescription
        Private lstGroup, btnReload
        Private btnEdit, btnAddNew
        Private btnOk, btnCancel, btnDelete
        
        ' FORM ADD ONS
        Private cServices, cAccessDefaults, cNotify, cQuotas, cDeltaQuotas
        
        ' TO DO: Declare indicator properties e.g.
        ' Public Changed
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
        
            Set cServices = Create_UCUserServices(Empty)
            cServices.IsGroup = True
            Set cAccessDefaults = Create_UCAccessDefaults(Empty)
            cAccessDefaults.IsGroup = True
            Set cNotify = Create_UCNotify(Empty)
            cNotify.IsGroup = True
            Set cQuotas = New UCQuotas
            cQuotas.IsGroup = True
            Set cDeltaQuotas = New UCQuotas
            cDeltaQuotas.IsGroup = True
            cDeltaQuotas.IsDelta = True
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            Set txtName = Create_CText(Empty)
            txtName.SkinId = "Normal"
            Set vldName = Create_TextValidator(txtName,32,True,4,32,"^[a-zA-Z0-9\.\-\_\ ]*$")
            vldName.Group = Me.Name
            vldName.Message = TR("The user group must have a name 4-32 symbols long composed of latin letters, numbers and the symbols .-_ and space.")
            
            Set txtDescription = Create_CTextArea(Empty)
            Set vldDescription = Create_UCValidator(txtDescription, Me, "Description")
            
            Set lstGroup = Create_CList(Empty)
            lstGroup.SkinId = "PanelSelect"
            FillGroups
            
            Set btnReload = Create_CImageButton(Empty)
            btnReload.SkinId = "PanelReload"
            btnReload.AsyncPostBack(Me) = True
            
            Set lstGroup.AsyncPostBack(Me) = btnReload
            
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PanelEdit"
            btnEdit.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CImageButton(Empty)
            btnAddNew.SkinId = "PanelNew"
            btnAddNew.AsyncPostBack(Me) = True
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you want to delete this group?")
            
            ClientScripts.EnableAsyncLibrary
            
            CssClass = "PanelListForm"
        End Sub
        
        Private Sub FillGroups
            lstGroup.Items.Clear
            lstGroup.AddItem "", ""
            lstGroup.AddSQLiteItems Database.DB.Execute("SELECT ID, NAME FROM S_GROUP WHERE NOT DELETED ORDER BY NAME"), "ID", "NAME"
        End Sub
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
            End If
        End Function
        
        Public Function InitialFormState
            cServices.Active = False
            cAccessDefaults.Active = False
            cNotify.Active = False
            cQuotas.Active = False
            cDeltaQuotas.Active = False
        End Function
        
        Sub ProcessPage
            Dim r, sid, newId
            If IsPostBack Then
                If Not EditMode Then
                    GroupId = ConvertTo(vbLong, lstGroup.SelectedValue)
                End If
                
                If btnEdit.Clicked And IsAdmin Then
                    ' Loading with the page default language
                    Set r = Database.DB.VExecute("SELECT * FROM S_GROUP WHERE ID=$ID",1,1,Id)
                    If r.Count > 0 Then
                        Set r = r(1)
                        Id = r("ID") ' Just in case make sure we set it
                        txtName.Value = ConvertTo(vbString,r("NAME"))
                        txtDescription.Value = ConvertTo(vbString,r("DESCRIPTION"))
                        InitialFormState
                        EditMode = True
                    Else
                        message = TR("The item cannot be found.")
                    End If
                ElseIf btnAddNew.Clicked And IsAdmin Then
                    Id = 0
                    InitialFormState
                    EditMode = True
                    txtName.Value = ""
                    txtDescription.Value = ""
                ElseIf btnOk.Clicked And IsAdmin Then
                    If Validate(Me.Name) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                        Err.Clear
                            Database.FailureValue(Me,"Id") = Id
                            
                            If Id = 0 Then
                                Set r = Database.DB.VExecute("INSERT INTO S_GROUP (SID, NAME, DESCRIPTION) VALUES ($SID, $NAME, $DESCRIPTION)",1,0, _
                                                                NullConvertTo(vbLong, GetSID(0)), _
                                                                NullConvertTo(vbString, txtName.Value), NullConvertTo(vbString, txtDescription.Value) )
                                ' Init supporting tables - the defaults are in the database
                                newId = r.Info
                                Database.DB.VExecute "INSERT INTO GROUP_DELTA_QUOTAS (GROUP_ID) VALUES ($GROUP_ID)", 1, 0, ConvertTo(vbLong,newId)
                                Database.DB.VExecute "INSERT INTO GROUP_QUOTAS (GROUP_ID) VALUES ($GROUP_ID)", 1, 0, ConvertTo(vbLong,newId)
                                Database.DB.VExecute "INSERT INTO GROUP_NOTIFY (GROUP_ID) VALUES ($GROUP_ID)", 1, 0, ConvertTo(vbLong,newId)
                                Database.DB.VExecute "INSERT INTO GROUP_SERVICES (GROUP_ID) VALUES ($GROUP_ID)", 1, 0, ConvertTo(vbLong,newId)
                                Database.DB.VExecute "INSERT INTO GROUP_ACCESSDEFAULTS (GROUP_ID) VALUES ($GROUP_ID)", 1, 0, ConvertTo(vbLong,newId)
                            Else
                                Database.DB.VExecute "UPDATE S_GROUP SET NAME=$NAME, DESCRIPTION=$DESCRIPTION WHERE ID=$ID", 1, 0, _
                                                        NullConvertTo(vbString, txtName.Value), NullConvertTo(vbString, txtDescription.Value), _
                                                        Id
                                newId = Id                        
                            End If
                            Id = newId
                            If Database.CompleteTransaction Then
                                EditMode = False
                                ' Reload the list
                                FillGroups
                                lstGroup.SelectedValue = GroupId
                            End If
                        On Error Goto 0
                        End If
                    Else
                        Database.InvalidateTransaction
                    End If
                ElseIf btnDelete.Clicked And IsAdmin Then
                    If Id <> 0 Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                        Err.Clear
                            Database.FailureValue(Me,"Id") = Id
                            Database.DB.VExecute "UPDATE S_GROUP SET DELETED=-1 WHERE ID=$GROUP_ID",1,0, Id
                            Id = 0
                            If Database.CompleteTransaction Then
                                EditMode = False
                            End If
                        On Error Goto 0
                        End If
                    End If
                ElseIf btnCancel.Clicked Then
                    EditMode = False
                End If
            End If
        End Sub
        
        
        ' PROPERTIES
        Public Property Let Auto(v)
            If v Then
                Set lstGroup.AsyncPostBack = btnReload
            Else
                Set lstGroup.AsyncPostBack = False
            End If
        End Property
        
        Public Property Get Id
            If Not EditMode Then
                Id = ConvertTo(vbLong, lstGroup.SelectedValue)
            Else
                Id = GroupId
            End If
        End Property
        Public Property Let Id(v)
            lstGroup.SelectedValue = ConvertTo(vbLong, v)
            GroupId = ConvertTo(vbLong, v)
        End Property
        
        
        ' POST VARIABLES
        Public Property Get GroupId
            GroupId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let GroupId(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong, v)
            cServices.Id = v
            cAccessDefaults.Id = v
            cNotify.Id = v
            cQuotas.ParentId = v
            cDeltaQuotas.ParentId = v
        End Property
        Public Property Get EditMode
            EditMode = ConvertTo(vbBoolean, PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let EditMode(v)
            Dim b
            b = ConvertTo(vbBoolean, v)
            PostVariables.SetCtlVar Me, "M", b
            lstGroup.SelectedValue = GroupId
        End Property
        
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCGroupSel" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>" >
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            ' TO DO: Render the control
            If EditMode Then
                RenderForm
            Else
                RenderSelector
            End IF
        End Sub
        
        Private Sub RenderSelector
            %>
            <table class="SelectorBar" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <% If IsAdmin Then %>
                    <td nowrap><% btnAddNew.Render %></td>
                    <% 
                        If Id <> 0 Then 
                            %><td nowrap class="border"><img class="border" src="<%= SysImage("pixel") %>" alt=""/></td><%
                            %><td nowrap><% btnEdit.Render %></td><%
                        End If
                    %>
                    <% End If %>
                    <td nowrap><% lstGroup.Render %></td>
                    <td nowrap><% btnReload.Render %></td>
                    <td nowrap width="100%" style="width: 100%;">&nbsp;</td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
        %>
            <table class="form" >
                <tr>
                    <th colspan="2" class="formCaption" nowrap><%= TR("User group") %></th>
                </tr>
                <tr>
                    <td colspan="2" class="formButtons">
                        <%
                            btnOk.Render
                            btnCancel.Render
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Group name") %></th>
                    <td class="formField"><% txtName.Render : vldName.Render %></td>
                </tr>
                <tr>
                    <th colspan="2" nowrap class="formLabel"><%= TR("Description") %><% vldDescription.Render %></th>
                </tr>
                <tr>
                    <td colspan="2" class="formField"><% txtDescription.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formCaption" colspan="2"><%= TR("Additional settings") %></th>
                </tr>
                <tr>
                    <td class="formField" colspan="2">
                        <% cServices.Render %>
                        <% cAccessDefaults.Render %>
                        <% cNotify.Render %>
                        <% cQuotas.Render %>
                        <% cDeltaQuotas.Render %>
                    </td>
                </tr>
            </table>
        <%
        End Sub
    
    End Class

%>