<%
    Class UCImageForm ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public ImageWidth
        
        ' CONTROLS
        Private lstType, vldType ' The image type
        Private txtCaption, vldCaption
        Private fileImage, vldImage, vldImageRequired ' File upload 
        Private binder
        Private imageStore, imageCache
        Private cRights
        Private btnOk, btnCancel, btnDelete
        
        ' INDICATORS
        Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set imageCache = New CBinaryCache
            imageCache.DatabaseFile = ImageCache_DatabaseFile
            
            ' INIT CONTAINED USER CONTROLS
            Set cRights = Create_UCObjectRights(Empty)
            cRights.Table = "IMAGE"
            
            ' INIT CONTAINED WEB CONTROLS
            Set lstType = Create_CList(Empty)
            lstType.AddItem "", ""
            lstType.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME FROM [IMAGE_TYPE] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & SQLReadRights & _
                                                       " ORDER BY NAME",1,0,PageUILanguage), "SID", "NAME"
            
            Set fileImage = Create_CFile(Empty)
            Set vldType = Create_RequiredValidator(lstType,Empty,True)
            vldType.Group = Me.Name
            vldType.Message = TR("The image type is required.")
            Set vldImage = Create_CValidatorFor(Empty, fileImage, "ValidateUpload")
            vldImage.MaxLength = 5294304
            vldImage.Group = Me.Name
            vldImage.Message = TR("The uploaded file is too big. The acceptable size is up to 5 MB.")
            Set vldImageRequired = Create_CValidatorFor(Empty, fileImage, "ValidateRequired")
            vldImageRequired.Required = True
            vldImageRequired.Group = Me.Name & "R"
            vldImageRequired.Message = TR("You must upload an image.")
            
            Set txtCaption = Create_UCMultiLangText(Empty)
            txtCaption.Style = "width: 100%;"
            txtCaption.SkinId = "Gray"
            Set vldCaption = Create_TextValidator(txtCaption,MaxCaptionSize,False,0,MaxCaptionSize,Empty)
            vldCaption.Group = Me.Name
            vldCaption.Message = TR("The caption can be up to 255 characters long.")
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.ConfirmationText = TR("Do you really want to delete this image?")
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl lstType, vbLong, "IMAGE_TYPE_SID", vbLong, "Default", "Default"
            binder.BindControl txtCaption, vbString, "NAME", vbString, "Default", "Default"
            binder.BindPostVariable Me, "W", vbLong, "WIDTH", vbLong
            binder.BindPostVariable Me, "H", vbLong, "HEIGHT", vbLong
            binder.BindPostVariable Me, "CT", vbString, "CONTENT_TYPE", vbString
            binder.BindPostVariable Me, "SP", vbString, "PATH", vbString
            
            
            Set imageStore = Create_CFileStore(MapPath(ImageStore_Path),ImageStore_NumDirs)
            imageStore.DoNotAddTimePortion = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            ImageWidth = 400
            
            CssClass = "UCImageForm"
        End Sub
        
        Public Sub InitSessionPreferences(vars)
        End Sub
        Public Sub SavePrefs
        End Sub
        Public Sub LoadPrefs
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            
            ' Response.Write "Load image: " & sid
            Set r = binder.ItemForEdit(sid, "IMAGE")
            
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            Id = sid
            txtCaption.Language = PageUILanguage
            cRights.Id = Id
            Load = True
        End Function
        Public Function Save
            Dim r, rType
            Dim w, h, ct, img, I, s, fext
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                Err.Clear
                    Database.FailureValue(Me,"Id") = Id
                    Database.FailureValue(Me,"ContentType") = ContentType
                    Database.FailureValue(Me,"FileStorePath") = FileStorePath
                    Database.FailureValue(Me,"Width") = Width
                    Database.FailureValue(Me,"Height") = Height
                    
                    
                    Set r = binder.ItemForWrite(Id, "IMAGE")
                    
                    If Not r Is Nothing Then
                        If fileImage.IsUploaded Then
                            Id = r(1)("SID")
                            Set rType = Database.DB.VExecute("SELECT * FROM IMAGE_TYPE WHERE SID=$SID AND LANGUAGE=$LANGUAGE", 1, 1, NullConvertTo(vbLong,lstType.SelectedValue), PageUILanguage)
                            If rType.Count > 0 Then
                                Set rType = rType(1)
                                w = ConvertTo(vbLong, rType("WIDTH"))
                                h = ConvertTo(vbLong, rType("HEIGHT"))
                                ct = ConvertTo(vbString, rType("CONTENT_TYPE"))
                                ' Now get the image and convert it as specified
                                img = fileImage.Image(w, h, ct, True)
                                If Not IsNull(img) Then
                                    Width = fileImage.ImageWidth
                                    Height = fileImage.ImageHeight
                                    ContentType = ct
                                    fext = ConvertTo(vbString, rType("FILE_EXTENSION"))
                                    If Len(fext) = 0 Then fext = fileImage.FileNameExtension
                                    FileStorePath = imageStore.StoreData(Id, img, fext)
                                        
                                    If txtCaption.Values.Count = 0 Then
                                        For I = LBound(SupportedLanguages) To UBound(SupportedLanguages)
                                            s = fileImage.FileName & " (" & FileSizeString(fileImage.ContentLength) & ")"
                                            txtCaption.LanguageValue(SupportedLanguages(I)) = s
                                        Next
                                    End If
                                    
                                    binder.WriteTo r
                                    Id = binder.WriteItem(r, "IMAGE")
                                    IndexImage Id
                                    imageCache.Remove Id
                                Else
                                    Database.CancelTransaction TR("Image conversion failed")
                                End If
                            Else
                                vldType.IsValid = False
                                Database.InvalidateTransaction
                                vldType.Message = TR("The specified image type cannot be found! This is an internal error, contact the support please.")
                            End If
                            
                        Else
                            If IsNull(NullConvertTo(vbString,binder.Value(r,"PATH"))) Then
                                ' Response.Write Id & " " & binder.Value(r,"PATH") & " " & ConvertTo(vbLong, Database.DB.VExecute("SELECT COUNT(*) FROM IMAGE_DATA WHERE SID=$SID AND DATA NOTNULL",1,1,Id)(1)(1))
                                vldImageRequired.IsValid = False
                                Database.InvalidateTransaction
                            Else
                                binder.WriteTo r
                                Id = binder.WriteItem(r,"IMAGE")
                                IndexImage Id
                                imageCache.Remove Id
                            End If
                        End IF
                    End If
                    If Database.CompleteTransaction Then
                        Active = False
                        Changed = True
                        cRights.Id = Id
                        Save = True
                    End If
                    On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
            
        End Function
        
        Public Function Delete
            Dim oldId
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = Id
                    Database.FailureValue(Me,"ContentType") = ContentType
                    Database.FailureValue(Me,"FileStorePath") = FileStorePath
                    Database.FailureValue(Me,"Width") = Width
                    Database.FailureValue(Me,"Height") = Height
                    oldId = Id
                    Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, id
                    binder.DeleteItem Id, "IMAGE"
                    Id = 0
                    If Database.CompleteTransaction Then
                        EditMode = False
                        cRights.Id = Id
                        Selected = True
                        imageCache.Remove oldId
                    End If
                On Error Goto 0
                End If
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                ContentType = Failure("ContentType")
                FileStorePath = Failure("FileStorePath")
                Width = Failure("Width")
                Height = Failure("Height")
                cRights.Id = Id
            End If
        End Function
        
        Sub ProcessPage
            If btnOk.Clicked Then
                If Save Then Changed = True
            ElseIf btnDelete.Clicked Then
                If Delete Then Changed = True
            ElseIf btnCancel.Clicked Then
                Changed = True
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"ID"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "ID", ConvertTo(vbLong,v)
            cRights.Id = v
        End Property
        Public Property Get Width
            Width = ConvertTo(vbLong, PostVariables.GetCtlVar(Me,"W"))
        End Property
        Public Property Let Width(v)
            PostVariables.SetCtlVar Me, "W", ConvertTo(vbLong, v)
        End Property
        Public Property Get Height
            Height = ConvertTo(vbLong, PostVariables.GetCtlVar(Me,"H"))
        End Property
        Public Property Let Height(v)
            PostVariables.SetCtlVar Me, "H", ConvertTo(vbLong, v)
        End Property
        Public Property Get ContentType
            ContentType = ConvertTo(vbString, PostVariables.GetCtlVar(Me,"CT"))
        End Property
        Public Property Let ContentType(v)
            PostVariables.SetCtlVar Me, "CT", ConvertTo(vbString, v)
        End Property
        Public Property Get FileStorePath
            FileStorePath = ConvertTo(vbString, PostVariables.GetCtlVar(Me,"SP"))
        End Property
        Public Property Let FileStorePath(v)
            PostVariables.SetCtlVar Me, "SP", ConvertTo(vbString, v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCImageForm" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            %>
            <table class="form">
                <tr>
                    <th nowrap class="label" colspan="2"><% cRights.Render %></th>
                </tr>
                <tr>
                    <% If Id <> 0 Then %>
                        <th nowrap class="label"><%= TR("Change image") %></th>
                    <% Else %>
                        <th nowrap class="label"><%= TR("Choose image") %></th>
                    <% End If %>
                    <td class="field"><% fileImage.Render : vldImage.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Image type") %></th>
                    <td class="field"><% lstType.Render : vldType.Render %></td>
                </tr>
                
                <tr>
                    <td nowrap class="buttons" colspan="2">
                        <% 
                            If Id = 0 Then btnOk.Caption = TR("Upload")
                            btnOk.Render
                            btnCancel.Render
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
                <tr>
                    <% If Id <> 0 Then %>
                        <th nowrap class="label"><%= TR("Caption") %><% vldCaption.Render %></th>
                        <td class="field" style="text-align: right">
                        <%
                            Response.Write TR("Width") & ": " & Width & ", " & TR("Height") & ": " & Height
                        %>
                        </td>
                    <% Else %>
                        <th nowrap colspan="2" class="label"><%= TR("Caption") & " " & TR("(if left empty the file name will be used)") %><% vldCaption.Render %></th>
                    <% End If %>
                    
                </tr>
                <tr>
                    <td nowrap class="field" colspan="2"><% txtCaption.Render %></td>
                </tr>
                <tr>
                    <td colspan="2" valign="top" align="center">
                        <img width="<%= ImageWidth %>" src="<%= VirtPath("/image.asp") & "?image=" & Id %>" alt="" />
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCImageForm(ctlName) 
        Set ctl = New UCImageForm ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCImageForm = ctl ' TO DO: Change the control name
    End Function

%>