<%
    ' Image selector with various filters
    ' Constructor
    Function Create_UCImageList(ctlName) 
        Set ctl = New UCImageList ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCImageList = ctl ' TO DO: Change the control name
    End Function
    Class UCImageList
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' PROPERTIES
        Public Columns
        Public Rows, ListRows
        Public ShowDeleted, OnlyEditable ' Show deleted images, show only those that the user can edit
        
        ' CONTROLS
        Private orderer, pager
        Private txtCaption, vldCaption
        Private lstOwnerFilter
        Private lstType ' Filter by type
        Private btnReload, btnCancel
        
        Private btnImage ' The image button used for image showing
        Private btnChangeViewType
        
        ' Options
        Private ckShowCaptions, ckShowDates, ckShowImageType, ckNotUsed
        
        ' INDICATORS
        Public Selected
        
        ' TO DO: Declare fields you need internally for the control functionality
        Private pOwnership
        
        Sub Init
            Rendered = False
            
            Set lstType = Create_CList(Empty)
            lstType.AddItem "", ""
            lstType.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME FROM [IMAGE_TYPE] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & SQLReadRights & _
                                                       " ORDER BY NAME",1,0,PageUILanguage), "SID", "NAME"
            
            Set ckShowCaptions = Create_CCheckBox(Empty)
            ckShowCaptions.Caption = TR("Show captions")
            Set ckShowDates = Create_CCheckBox(Empty)
            ckShowDates.Caption = TR("Show date (modified)")
            Set ckShowImageType = Create_CCheckBox(Empty)
            ckShowImageType.Caption = TR("Show image type")
            Set ckNotUsed = Create_CCheckBox(Empty)
            ckNotUsed.Caption = TR("Only unused")
            
            Set txtCaption = Create_CText(Empty)
            txtCaption.SkinId = "FilterWide"
            Set vldCaption = Create_TextValidator(txtCaption,255,False,0,255,Empty)
            vldCaption.Group = Me.Name
            
            pOwnership = 2
            Set lstOwnerFilter = Create_CList(Empty)
            lstOwnerFilter.AddItem 0, TR("Your own")
            lstOwnerFilter.AddItem 1, TR("Your group's own")
            lstOwnerFilter.AddItem 2, TR("All accessible")
            
            Set btnImage = Create_CImageButton(Empty)
            btnImage.SkinId = "ImageThumb"
            btnImage.NoLabel = True
            
            ' Set btnReload = Create_CImageButton(Empty)
            Set btnReload = Create_CButton(Empty)
            btnReload.Caption = TR("Reload")
            btnReload.SkinId = "Blue"
            btnReload.AsyncPostBack(Me) = True
            
            Set btnChangeViewType = Create_CButton(Empty)
            btnChangeViewType.Caption = TR("Change view")
            btnChangeViewType.AsyncPostBack(Me) = True
            
            Set orderer = Create_OrdererList(Empty)
            orderer("NAME").Caption = TR("Caption")
            orderer("WIDTH").Caption = TR("Width")
            orderer("HEIGHT").Caption = TR("Height")
            orderer("MODIFIED").Caption = TR("Date modified")
            orderer("CREATED").Caption = TR("Date created")
            
            Set orderer.AsyncPostBack(Me) = btnReload
            Set txtCaption.AsyncPostBack(Me) = btnReload
            Set lstOwnerFilter.AsyncPostBack(Me) = btnReload
            Set ckShowCaptions.AsyncPostBack(Me) = btnReload
            Set ckShowDates.AsyncPostBack(Me) = btnReload
            Set ckShowImageType.AsyncPostBack(Me) = btnReload
            Set lstType.AsyncPostBack(Me) = btnReload
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Close")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            
            RegisterForPreRender Me
            
            Columns = ImageBrowsers_Columns
            Rows = ImageBrowsers_Rows
            ListRows = ImageBrowsers_ListRows
            ShowDeleted = False
        End Sub
        
        Public Property Get OwnershipLimit
            OwnershipLimit = pOwnership
        End Property
        Public Property Let OwnershipLimit(v)
            pOwnership = ConvertTo(vblong, v)
            lstOwnerFilter.Items.Clear
            lstOwnerFilter.AddItem 0, TR("Your own")
            If pOwnership > 0 Then
                lstOwnerFilter.AddItem 1, TR("Your group's own")
                If pOwnership > 1 Then
                    lstOwnerFilter.AddItem 2, TR("All accessible")
                End If
            End If
        End Property
        
        Private Function GetImageLink(imgId)
            If ViewType = "L" Then
                GetImageLink = VirtPath("/image.asp") & "?image=" & imgId & "&th=" & ImageBrowsers_ListThumbnailType
            Else
                GetImageLink = VirtPath("/image.asp") & "?image=" & imgId & "&th=" & ImageBrowsers_ThumbnailType
            End If
        End Function
        Public Sub InitSessionPreferences(vars)
            vars("ShowCaptions") = True
            vars("ShowDates") = True
            vars("ShowImageType") = True
            vars("OwnerFilter") = 0
            vars("SortField") = "MODIFIED"
            vars("SortDir") = -1
            vars("ViewType") = "L"
        End Sub
        Public Sub SavePrefs
            SessionPreferences.SetCtlVar Me, "ShowCaptions", ckShowCaptions.Checked
            SessionPreferences.SetCtlVar Me, "ShowDates", ckShowDates.Checked
            SessionPreferences.SetCtlVar Me, "ShowImageType", ckShowImageType.Checked
            
            SessionPreferences.SetCtlVar Me, "OwnerFilter", lstOwnerFilter.SelectedValue
            SessionPreferences.SetCtlVar Me, "ImageType", ConvertTo(vbLong, lstType.SelectedValue)
            
            SessionPreferences.SetCtlVar Me, "SortField", orderer.SortField
            SessionPreferences.SetCtlVar Me, "SortDir", orderer.SortDir
            
            SessionPreferences.SetCtlVar Me, "ViewType", ViewType
        End Sub
        Public Sub LoadPrefs
            
            ckShowCaptions.Checked = ConvertTo(vbBoolean,SessionPreferences.GetCtlVar(Me, "ShowCaptions"))
            ckShowDates.Checked = ConvertTo(vbBoolean,SessionPreferences.GetCtlVar(Me, "ShowDates"))
            ckShowImageType.Checked = ConvertTo(vbBoolean, SessionPreferences.GetCtlVar(Me, "ShowImageType"))
            
            lstOwnerFilter.SelectedValue = ConvertTo(vbLong, SessionPreferences.GetCtlVar(Me, "OwnerFilter"))
            lstType.SelectedValue = SessionPreferences.GetCtlVar(Me, "ImageType")
            
            orderer.SortField = ConvertTo(vbString, SessionPreferences.GetCtlVar(Me, "SortField"))
            orderer.SortDir = ConvertTo(vbLong, SessionPreferences.GetCtlVar(Me, "SortDir"))
            
            ViewType = ConvertTo(vbString, SessionPreferences.GetCtlVar(Me, "ViewType"))
        End Sub
        
        
        Sub ProcessPage
            If btnImage.Clicked Then
                Id = ConvertTo(vbLong, btnImage.Value)
                Selected = True
            ElseIf btnCancel.Clicked Then
                Selected = True
            ElseIf btnChangeViewType.Clicked Then
                If ViewType = "L" Then
                    ViewType = "I"
                Else
                    ViewType = "L"
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"ID"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "ID", ConvertTo(vbLong,v)
        End Property
        Public Property Get ViewType
            ViewType = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"V"))
        End Property
        Public Property Let ViewType(v)
            PostVariables.SetCtlVar Me, "V", ConvertTo(vbString,v)
        End Property
        
        Public Property Get Value
            Value = Id
            If Id = 0 Then Value = Empty
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCImageList" 
        End Property
        
        Sub PreRender(param)
            If ViewType = "L" Then
                pager.PageSize = ListRows
            Else
                pager.PageSize = Columns * Rows
            End If
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            SavePrefs
            If ViewType = "L" Then
                RenderListView
            Else
                RenderIconView
            End If
        End Sub
        
        Private Function GetResults()
            Dim sSearchCaption, sql, params, sWhich, sRights, r, t
            Dim idlistPos, idlistNeg
            Set params = CreateDictionary
            params.Missing = Null
            params("LANGUAGE") = PageUILanguage
            sSearchCaption = ""
            
            If Validate(Me.Name) And Len(txtCaption.Value) > 0 Then
                sSearchCaption = txtCaption.Value
            End If
            
            Select Case ConvertTo(vbLong, lstOwnerFilter.SelectedValue)
                Case 1
                    sWhich = "I.OWNER_GROUP_ID=Parameter('GROUP_ID')"
                Case 2
                    sWhich = "1=1"
                Case Else
                    sWhich = "I.OWNER_USER_ID=Parameter('USER_ID')"
            End Select
            
            t = ConvertTo(vbLong, lstType.SelectedValue)
            If t <> 0 Then
                sWhich = sWhich & " AND I.IMAGE_TYPE_SID=" & t
            End If
            
            
            If OnlyEditable Then
                sRights = SQLWriteRightsTable("I")
            Else
                sRights = SQLReadRightsTable("I")
            End If
            
            idlistPos = KeywordIDList(sSearchCaption, True, False)
            idlistNeg = KeywordIDList(sSearchCaption, False, True)
            
            If idlistPos <> "0" Then
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM IMAGE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                    sWhich & " AND " & sRights & " AND I.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                    " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            Else
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM IMAGE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                    sWhich & " AND " & sRights & " AND I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            End If
            If ViewType = "L" Then
                pager.PageSize = ListRows
            Else
                pager.PageSize = Columns * Rows
            End If
            'Response.Write sql
            'Response.End
            If idlistPos <> "0" Then
                Set r = Database.DB.CExecute("SELECT I.*, (SELECT COUNT(*) FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ") AND OBJECT_SID=I.SID) AS SEARCH_RANK " & _
                                             " FROM IMAGE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                                sWhich & " AND " & sRights & " AND I.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                                " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            Else
                Set r = Database.DB.CExecute("SELECT I.*, 0 AS SEARCH_RANK " & _
                                             " FROM IMAGE I WHERE I.LANGUAGE=$LANGUAGE AND " & IfThenElse(ShowDeleted,"1=1","NOT I.DELETED") & " AND " & _
                                                sWhich & " AND " & sRights & " AND " & _
                                                " I.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            End If
            Set GetResults = r
        End Function
        
        Public Sub RenderListView
            Dim r, I, J, K, rec, elementCss, bPutBr
            Set r = GetResults
            %>
            <div <%= StyleAndCssString(CssClass,Style) %>>
            <table class="ImageListViewSelect" cellspacing="1">
                <tr>
                    <th nowrap class="formCaption" colspan="2">
                        <%= TR("Choose an image from the inventory") %>
                    </th>
                </tr>
                <tr>
                    <th nowrap colspan="2">
                        <table class="ImageBrowserfilter">
                            <tr>
                                <th nowrap>
                                    <%= TR("Caption") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% txtCaption.Render : vldCaption.Render %>
                                </td>
                            </tr>
                            <tr>
                                <th nowrap>
                                    <%= TR("Image type") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% lstType.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Ownership") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% lstOwnerFilter.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Show") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% ckShowCaptions.Render %> <br/>
                                    <% ckShowDates.Render %> <br/>
                                    <% ckShowImageType.Render %><br/>
                                    <% ckNotUsed.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Order by") %>
                                </th>
                                <th nowrap colspan="1">
                                    <% orderer.Render %>
                                </th>
                                <td nowrap colspan="1" class="formField" style="text-align: right;">
                                    <% btnReload.Render : btnChangeViewType.Render : btnCancel.Render %>
                                </td>
                            </tr>                
                        </table>                        
                    </th>
                </tr>
                
                <% For I = 1 To r.Count
                    %>
                    <tr>
                        <% 
                        Set rec = r(I)
                        btnImage.Src = GetImageLink(rec("SID")) ' VirtPath("image.asp") & "?image=" & rec("SID") & "&th=1"
                        btnImage.Caption = rec("NAME")
                        If Id = ConvertTo(vbLong, rec("SID")) Then elementCss = "selected" Else elementCss = "element"
                        bPutBr = False
                        %>
                        <td class="<%= elementCss %>"><% btnImage.RenderValue(rec("SID")) %></td>
                        <td class="<%= elementCss & "text" %>" onclick="<%= btnImage.GetAsyncPostBack(Me,rec("SID")) %>" style="cursor: pointer;">
                            <% 
                            If ckShowCaptions.Checked Then
                                Response.Write "<strong>" & HTMLEncode(rec("NAME")) & "</strong>"
                            End If
                            Response.Write "&nbsp;(" & ConvertTo(vbString,rec("WIDTH")) & " x " & ConvertTo(vbString,rec("HEIGHT")) & ")"
                            bPutBr = True
                            If ckShowDates.Checked Then
                                If bPutBr Then Response.Write "<br/>"
                                Response.Write TR("Modified") & ": <em>" & FormatDateString(rec("MODIFIED"), Empty) & "</em>&nbsp;"
                                Response.Write TR("Created") & ": <em>" & FormatDateString(rec("CREATED"), Empty) & "</em>"
                                bPutBr = True
                            End If
                            If ckShowImageType.Checked Then
                                If bPutBr Then Response.Write "<br/>"
                                Response.Write Nomenclature("IMAGE_TYPE", rec("IMAGE_TYPE_SID")).Name
                                bPutBr = True
                            End If
                            %>
                        </td>
                    </tr>
                    <% 
                Next 
                %>
                <tr>
                    <td colspan="<%= Columns %>" class="pager">
                        <% pager.Render %>
                    </td>
                </tr>
            </table>
            </div>
            <%
        End Sub
        Public Sub RenderIconView
            Dim r, I, J, K, rec, elementCss, bPutBr
            
            Set r = GetResults
            %>
            <div <%= StyleAndCssString(CssClass,Style) %>>
            <table class="ImageIconViewSelect" cellspacing="1">
                <tr>
                    <th nowrap class="formCaption" colspan="<%= Columns %>">
                        <%= TR("Choose an image from the inventory") %>
                    </th>
                </tr>
                <tr>
                    <th nowrap colspan="<%= Columns %>">
                        <table class="ImageBrowserfilter">
                            <tr>
                                <th nowrap>
                                    <%= TR("Caption") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% txtCaption.Render : vldCaption.Render %>
                                </td>
                            </tr>
                            <tr>
                                <th nowrap>
                                    <%= TR("Image type") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% lstType.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Ownership") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% lstOwnerFilter.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Show") %>
                                </th>
                                <td nowrap class="formField" colspan="2">
                                    <% ckShowCaptions.Render %> <br/>
                                    <% ckShowDates.Render %> <br/>
                                    <% ckShowImageType.Render %><br/>
                                    <% ' ckNotUsed.Render %>
                                </td>
                            </tr>                
                            <tr>
                                <th nowrap>
                                    <%= TR("Order by") %>
                                </th>
                                <th nowrap colspan="1">
                                    <% orderer.Render %>
                                </th>
                                <td nowrap colspan="1" class="formField" style="text-align: right;">
                                    <% btnReload.Render : btnChangeViewType.Render : btnCancel.Render %>
                                </td>
                            </tr>                
                        </table>                        
                    </th>
                </tr>
                
                <% For I = 1 To Rows 
                    If ((I - 1) * Columns + 1) <= r.Count Then
                        %>
                        <tr>
                            <% 
                            For J = 1 To Columns
                                K = (I - 1) * Columns + J
                                If K <= r.Count Then
                                    Set rec = r(K)
                                    btnImage.Src = GetImageLink(rec("SID")) ' VirtPath("image.asp") & "?image=" & rec("SID") & "&th=1"
                                    btnImage.Caption = rec("NAME")
                                    If Id = ConvertTo(vbLong, rec("SID")) Then elementCss = "selected" Else elementCss = "element"
                                    bPutBr = False
                                    %>
                                    <td class="<%= elementCss %>" onclick="<%= btnImage.GetAsyncPostBack(Me,rec("SID")) %>" style="cursor: pointer;">
                                        <% 
                                        btnImage.RenderValue(rec("SID")) 
                                        %>
                                    </td>
                                    <%                    
                                Else
                                    Response.Write "<td class=""empty"">&nbsp;</td>" & vbCrLf
                                End If
                            Next 
                            %>    
                        </tr>
                        <tr>
                            <% 
                            For J = 1 To Columns
                                K = (I - 1) * Columns + J
                                If K <= r.Count Then
                                    Set rec = r(K)
                                    If Id = ConvertTo(vbLong, rec("SID")) Then elementCss = "selected" Else elementCss = "element"
                                    bPutBr = False
                                    %>
                                    <td class="<%= elementCss & "text" %>">
                                        <% 
                                        If ckShowCaptions.Checked Then
                                            Response.Write "<strong>" & HTMLEncode(rec("NAME")) & "</strong>"
                                            bPutBr = True
                                        End If
                                        If ckShowDates.Checked Then
                                            If bPutBr Then Response.Write "<br/>"
                                            Response.Write TR("Modified") & ": <em>" & FormatDateString(rec("MODIFIED"), Empty) & "</em><br/>"
                                            Response.Write TR("Created") & ": <em>" & FormatDateString(rec("CREATED"), Empty) & "</em>"
                                            bPutBr = True
                                        End If
                                        If ckShowImageType.Checked Then
                                            If bPutBr Then Response.Write "<br/>"
                                            Response.Write Nomenclature("IMAGE_TYPE", rec("IMAGE_TYPE_SID")).Name
                                            bPutBr = True
                                        End If
                                        If bPutBr Then Response.Write "<br/>"
                                        Response.Write ConvertTo(vbLong, rec("WIDTH")) & " x " & ConvertTo(vbLong, rec("HEIGHT"))
                                        %>
                                    </td>
                                    <%                    
                                Else
                                    Response.Write "<td class=""empty"">&nbsp;</td>" & vbCrLf
                                End If
                            Next 
                            %>
                        </tr>
                        <% 
                    End If
                Next 
                %>
                <tr>
                    <td colspan="<%= Columns %>" class="pager">
                        <% pager.Render %>
                    </td>
                </tr>
            </table>
            </div>
            <%
        End Sub
    
    End Class

%>