<%
    ' Lists the incomplete cards of the user or group
    Class UCIncompleteCards
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public MaxCards
        
        ' CONTROLS
        Private lstWhich, btnReload, btnCard, pager
        
        ' INDICATORS
        Public SelectedId
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set btnReload = Create_CButton(Empty)
            btnReload.SkinId = "Blue"
            btnReload.Caption = TR("Refresh")
            btnReload.AsyncPostBack(Me) = True
            
            Set btnCard = Create_CImageButton(Empty)
            btnCard.src = VirtPath("/img/opencard.gif")
            btnCard.Caption = TR("Open for editing")
            btnCard.NoLabel = True
            btnCard.AsyncPostBack(Me) = True
            
            Set lstWhich = Create_CList(Empty)
            lstWhich.AddItem "0", TR("Your own")
            lstWhich.AddItem "1", TR("Your group's")
            Set lstWhich.AsyncPostBack(Me) = btnReload
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            MaxCards = 10
            
            CssClass = "UCSimpleGrid"
        End Sub
        
        Sub ProcessPage
            If IsPostBack Then
                If btnCard.Clicked Then
                    SelectedId = ConvertTo(vbLong,btnCard.Value)
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = SelectedId
        End Property
        
        Public Property Get ClassType
            ClassType = "UCIncompleteCards" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            Dim r, sWhich, I
            If ConvertTo(vbLong,lstWhich.SelectedValue = 1) Then
                sWhich = "C.OWNER_USER_ID=" & CurrentUser.Id
            Else
                sWhich = "C.OWNER_GROUP_ID=" & CurrentUser.GroupId
            End If
            pager.ItemCount = Database.DB.VExecute("SELECT COUNT(*) " & _
                                        " FROM CARD C " & _
                                        " WHERE NOT C.DELETED AND " & SQLAccessRightsTable("C",FR_WRITE) & " AND " & sWhich & " AND " & _
                                        " C.LANGUAGE=$LANGUAGE AND NOT C.COMPLETED",1,0, PageUILanguage)(1)(1)
            Set r = Database.DB.VExecute("SELECT C.*, " & _
                                        " (SELECT NAME FROM LOCATION WHERE SID=C.LOCATION_SID) AS LOCATION_NAME " & _
                                        " FROM CARD C " & _
                                        " WHERE NOT C.DELETED AND " & SQLAccessRightsTable("C",FR_WRITE) & " AND " & sWhich & " AND " & _
                                        " C.LANGUAGE=$LANGUAGE AND NOT C.COMPLETED ORDER BY C.MODIFIED DESC " & pager.LimitOffsetClause,1,0, PageUILanguage)
            %>
            <table <%= StyleAndCssString(CssClass,Style) %>>
                <tr class="filter">
                    <th class="filter" colspan="3">
                        <% btnReload.Render %>
                        <% lstWhich.Render %>
                        <% hint.RenderHint "INCOMPLETE" %>
                    </th>
                </tr>
                <%
                 If r.Count > 0 Then
                     For I = 1 To r.Count
                     %>
                     <tr class="<%= IfThenElse(I Mod 2,"even","odd") %>">
                        <td class="icon"><% btnCard.RenderValue(r(I)("SID")) %></td>
                        <td class="text" onclick="<%= btnCard.GetAsyncPostBack(Me,r(I)("SID")) %>" style="cursor: pointer;">
                            <%= TR("Object") & " <b>" & ConvertTo(vbString,r(I)("OBJECT_NUMBER")) & "</b>" %><br/>
                            <%= TR("Location") & " " & HTMLEncode(r(I)("LOCATION_NAME")) %><br/>
                            <%= TR("Created") & " " & FormatDateString(r(I)("CREATED"),PageUIDateTimeFormat) %><br/>
                            <%= TR("Modified") & " " & FormatDateString(r(I)("MODIFIED"),PageUIDateTimeFormat) %>
                        </td>
                     </tr>
                     <%
                     Next
                     %>
                     <tr class="pager">
                        <td colspan="2"><% pager.Render %></td>
                     </tr>
                     <%
                Else
                    %>
                    <tr class="even">
                        <td colspan="2">
                            <%= TR("No unfinished cards") %>
                        </td>
                    </tr>
                    <%
                End If
                %>
            </table>
            <%            
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCIncompleteCards(ctlName) 
        Set ctl = New UCIncompleteCards ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCIncompleteCards = ctl ' TO DO: Change the control name
    End Function

%>