<%
    Class UCLogin
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        Public CssClassForm
        Public StyleForm
        
        ' CONTROLS
        Private txtLogin, pasPass, btnLogin, btnLogoff, ckSave
        Private vldLogin, vldPass
        
        ' TO DO: Declare indicator properties e.g.
        ' Public Changed
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
            ' TO DO: Initialize any user controls contained in this control e.g.
            ' Set myUserControl = New UCMyUserControl
            
            Me.Name = NewCtlName()
            ' RegisterUserControl Me - This control is processed explicitly
            ClientId = NewClientId()
            Rendered = False
            
            Set txtLogin = Create_CText(Empty)
            txtLogin.SkinId = "Short"
            Set vldLogin = Create_TextValidator(txtLogin,128,True,4,128,"^[a-zA-Z0-9\@\.\-\_]*$")
            vldLogin.Group = Me.Name
            vldLogin.Message = TR("The login must be your user name or the e-mail address whith which you are registered.")
            
            Set pasPass = Create_CPass(Empty)
            pasPass.SkinId = "Short"
            Set vldPass = Create_TextValidator(pasPass,16,True,4,16,"^[a-zA-Z0-9\@\.\-\_\=\~\$\%\^\&\*\(\)]*$")
            vldPass.Group = Me.Name
            vldPass.Message = TR("The password can contain only letters, numbers and the symbols @.-_=~%^&*()")
            
            Set ckSave = Create_CCheckBox(Empty)
            ckSave.Caption = TR("Remember me")
            
            Set btnLogin = Create_CButton(Empty)
            btnLogin.Caption = TR("Log in")
            btnLogin.SkinId = "Green"
            
            Set btnLogoff = Create_CButton(Empty)
            btnLogoff.Caption = TR("Log off")
            btnLogoff.SkinId = "Orange"
            
            CssClassForm = "UCLogin"
            
        End Sub
        
        ' Returns a redirection virtual path if something is done and the current page processing cannot continue
        Function MasterProcessPage
            MasterProcessPage = Empty
            If Not IsPostBack Then
                txtLogin.Value = "root"
            End If
            ' Response.Write "UCLogin::ProcessPage<hr/>"
            ' Response.Write Self & "...<hr/>"
            If btnLogin.Clicked Then
                If Validate(Me.Name) Then
                    If LogOn(txtLogin.Value, pasPass.Value, txtLogin.Value, ckSave.Checked) Then
                        MasterProcessPage = Empty
                        ' Response.Write "[" & Self & "]"
                    Else
                        message = TR("Login incorrect.")
                    End If
                End If
            ElseIf btnLogoff.Clicked Then
                LogOff
            End If
        End Function
        Sub ProcessPage
            If Not IsPostBack Then
                txtLogin.Value = "root"
            End If
            
        End Sub
        
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCLogin" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>" <%= ClientScripts.RenderControlEventHandlers(Me) %>>
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            If IsLoggedOn Then
            %>
            <table <%= StyleAndCssString(CssClassForm,StyleForm) %>>
                <tr>
                    <th colspan="2" class="caption">
                        <%= TR("Logged in") %>
                    </th>
                </tr>
                <tr>
                    <td nowrap class="label">
                        <img src="<%= VirtPath("/img/user-white.gif") %>" border="0" alt="<%= TR("User") %>" />
                    </td>
                    <td nowrap class="field" style="width: 100%">
                        <%= CurrentUser.DisplayName %>
                    </td>
                </tr>
                <% If IsAdmin Then %>
                <tr>
                    <td nowrap class="label">
                        <img src="<%= VirtPath("/img/admin-white.gif") %>" border="0" alt="<%= TR("Administration") %>" />
                    </td>
                    <td nowrap class="field" style="width: 100%">
                        <a href="<%= VirtPath("/admin") %>"><%= TR("Configuration") %></a>
                    </td>
                </tr>
                <% End If %>
                <tr>
                    <td nowrap class="label">&nbsp;</td>
                    <td nowrap class="button" style="width: 100%">
                        <% btnLogoff.Render %>
                    </td>
                </tr>
            </table>
            <%
            Else
            %>
            <table <%= StyleAndCssString(CssClassForm,StyleForm) %>>
                <tr>
                    <th colspan="2" class="caption">
                        <%= TR("Log in") %><% hint.RenderHint "LOGON" %>
                    </th>
                </tr>
                <tr>
                    <td nowrap class="label">
                        <%= TR("Login") %>
                    </td>
                    <td nowrap class="field">
                        <% txtLogin.Render : vldLogin.Render %>
                    </td>
                </tr>
                <tr>
                    <td nowrap class="label">
                        <%= TR("Password") %>
                    </td>
                    <td nowrap class="field">
                        <% pasPass.Render : vldPass.Render %>
                    </td>
                </tr>
                <tr>
                    <td nowrap class="label">&nbsp;</td>
                    <td nowrap class="button">
                        <% btnLogin.Render %>
                    </td>
                </tr>
            </table>
            <%
            End If
        End Sub
    
    End Class

%>