<%
    ' A control acting as thread by automatically reloading through ajax
    Class UCLongTask ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
            Public WorkerProc ' Must return True when finished
            Public Caption, Description
            Public IconStart, IconStop, IconPause, IconProgress
            Public Report
        
        ' CONTROLS
        
        ' INDICATORS
        Public Started, Finished, Paused
        
        ' INTERNAL
        Private StatusMessage
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            RegisterForPrerender Me
        End Sub
        
        Sub Clear
            Current = 0
            Parameters.Clear
            NumSteps = 0
            Active = False
            RegisterForPartialRender Me
        End Sub
        Sub Start
            If IsNotObject(WorkerProc) Then Err.Raise 1,"UCLongTask","WorkerProc is not set"
            Active = True
            Current = 0
            StatusMessage = TR("Starting ...")
            Started = True
            RegisterForPartialRender Me
        End Sub
        Sub Cancel
            Active = False
            StatusMessage = TR("Stopped")
            RegisterForPartialRender Me
        End Sub
        
        Sub ProcessPage
            If IsPostBack Then
                
                If Active Then
                    ' Do processing
                    If WorkerProc(Me) Then 
                        Active = False
                        Current = 0
                        Finished = True
                        StatusMessage = TR("Task finished")
                    End If
                End If
                
            End If
        End Sub
        
        ' POST VARIABLES
            ' Current step
            Public Property Get Current
               Current = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"C"))
            End Property
            Public Property Let Current(v)
               PostVariables.SetCtlVar Me, "C", ConvertTo(vbLong,v)
            End Property
            Public Property Get NumSteps
               NumSteps = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"S"))
            End Property
            Public Property Let NumSteps(v)
               PostVariables.SetCtlVar Me, "S", ConvertTo(vbLong,v)
            End Property
            ' Processing active
            Public Property Get Active
                Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
            End Property
            Public Property Let Active(v)
                PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
            End Property
            ' User parameters
            Public Property Get Parameters
                Set Parameters = PostVariables.CtlPostCollection(Me,"P")
            End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            ' TO DO: If you want to attach validators to this user control this property will be used by all the standard validator procedures
            '   return whatever is appropriate for validation. For example if this control enables the user to select something and you want to attach
            '   a "required validator" you need to return Empty when nothing is selected and something else (a database Id of the item for example) otherwise.
            '   While the Value is not declared as default (to leave the option usable for other purposes) it is intended for library usage. It may be needed
            '   for future functionality enhancements - be careful to implement it as described.
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCLongTask" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            If Active Then
                ClientScripts.RegisterEventHandlerEx Me, "$asyncupdate", "StaticAsyncPostBack", "'" & CurrentFormName & "','" & Name & "','" & ClientId & "'", "UCLongTaskReload", "load"
            End If
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            Dim w
            %>
            <table class="form">
                <tr>
                    <th class="caption"><%= Caption %></th>
                </tr>
                <tr>
                    <td class="field"><%= Description %></td>
                </tr>
                <% If Active Then %>
                <tr>
                    <td class="field">
                        <%= TR("Progress") & ": " & Current %>
                        <% If NumSteps > 0 Then %>
                            <%= " " & TR("of") & " " & NumSteps %>
                        <% End If %>
                    </td>
                </tr>
                <% End If %>
                <% If Len(StatusMessage) > 0 Then %>
                <tr>
                    <td class="status"><%= HTMLEncode(StatusMessage) %></td>
                </tr>
                <% End If %>
                <% If Len(Report) > 0 Then %>
                <tr>
                    <td class="report"><%= Report %></td>
                </tr>
                <% End If %>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCLongTask(ctlName) 
        Set ctl = New UCLongTask ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCLongTask = ctl ' TO DO: Change the control name
    End Function

%>