<%
    ' Advanced template for User Control (composite control containing other controls)
    ' For ASP-CTL version 1.A and later
    ' This template is for async enabled user control
    Class UCMultiLangTextArea
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
        Private LanguageSwitch, txtText
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            Set LanguageSwitch = New UCLanguage
            LanguageSwitch.AsyncPostBack(Me) = True
            LanguageSwitch.Label = "&nbsp;"
            LanguageSwitch.Style = "width:100%;"
            Set txtText = Create_CTextAreaLang(Empty)
            txtText.SkinId = SkinId
            Set LanguageSwitch.LanguageControl = txtText
            txtText.Style = "width: 100%;"
        End Sub
        
        
        Public Property Get SkinId
            SkinId = txtText.SkinId
        End Property
        Public Property Let SkinId(v)
            txtText.SkinId = v
            LanguageSwitch.SkinId = v
        End Property
        Public Property Get Language
            Language = LanguageSwitch.Language
        End Property
        Public Property Let Language(v)
            LanguageSwitch.Language = v
            txtText.Language = v
        End Property
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If LanguageSwitch.LanguageChanged Then
                    txtText.Language = LanguageSwitch.Language
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = txtText.Value
        End Property
        Public Property Let Value(v)
            txtText.Value = v
        End Property
        Public Property Get LanguageValue(lang)
            LanguageValue = txtText.LanguageValue(lang)
        End Property
        Public Property Let LanguageValue(lang,v) ' Defaults to the current Language
            txtText.LanguageValue(lang) = v
        End Property
        Public Property Get Values
            Set Values = txtText.Values
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCMultiLangTextArea" 
        End Property
        Public Property Get Protocols
            Protocols = "PControl,PValues,PLanguageControl"
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
            ' PreRender is most often needed by controls that generate a lot of client side javascript code.
            ' This is the place where they can safely assume the processing is finished and any bindings between the client code and server elements
            ' can be determined without risk that they might change later.
        End Sub
        
        Public Sub Render
            ' Renders the client side container for the control
            ' TO DO: Change the code if needed - e.g. use span, table or something else more appropriate if div is not suitable
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            %>
            <table width="100%" cellpadding="0" cellspacing="0" <%= StyleAndCssString(CssClass,Style) %>>
                <tr>
                    <td><% LanguageSwitch.Render %></td>
                </tr>
                <tr>
                    <td><% txtText.Render %></td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCMultiLangTextArea(ctlName) 
        Set ctl = New UCMultiLangTextArea ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCMultiLangTextArea = ctl ' TO DO: Change the control name
    End Function

%>