<%
    ' Holds the current selections from a single nomenclature, allows the user to delete/change certain selection
    ' Needs the selection to be supplied from the outside.
    '
    ' the Nomenclature property is set to a keyword denoting the Nomenclature tables - both the nomenclature and the
    ' CARD_<Nomenclature> storage.
    Class UCMultiNom
        
        ' User controls should not preserve state in the query string
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' Controls
        Private btnDelete, btnChange, btnAddNew, btnOk, btnCancel
        Private txtComments
        Private vldComments
        Private EditControl ' As UCSelectGrafNom - The nomenclature selection control - automatically used by this one, must be set! 
        Private pager, orderer
        Private binder
        Private results
        
        ' Indicators
        Public Changed ' The Id of the entry to change (ChangeId - The Id of the entry in the REL table, ChangeNomId - the Id of the nomenclature there)
        
        ' Parameters
        Public ShowDeleted
        Public ShowComments
        
        Sub Init
            Rendered = False
            Set EditControl = Create_UCTreeNomReadOnly(Empty)
            EditControl.AsyncPostBack(EditControl) = True
            EditControl.Width = 300
            EditControl.Height = 200
            Set vldEditControl = Create_RequiredValidator(EditControl,Empty,True)
            vldEditControl.Group = Me.Name
            vldEditControl.Message = TR("You must select something.")
            
            Set txtComments = Create_UCMultiLangText(Empty)
                txtComments.SkinId = "Gray"
            Set vldComments = Create_UCValidator(txtComments,Me,"NomComment")
            
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            Set btnChange = Create_CButton(Empty)
            btnChange.Caption = TR("Change")
            btnChange.SkinId = "Yellow"
            btnChange.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CButton(Empty)
            btnAddNew.Caption = TR("New")
            btnAddNew.SkinId = "Gray"
            btnAddNew.AsyncPostBack(Me) = True
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            Set orderer = Create_OrdererSet(Empty)
            orderer.ShowLabels = True
            orderer("NAME").Caption = TR("Name")
            orderer("CODE").Caption = TR("Code")
            orderer("COMMENTS").Caption = TR("Comment")
            orderer.AsyncPostBack(Me) = True
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.SimpleMode = True
            SetupBinder
            
            ShowDeleted = False
            
            Set results = CreateCollection
            
            Changed = False
            
            CssClass = "UCSimpleGrid"
        End Sub
        
        Private Sub SetupBinder
            binder.ClearBindings
            binder.BindControl EditControl, vbLong, RelField, vbLong, "Default", "Default"
            binder.BindControl txtComments, vbString, "COMMENTS", vbString, "Default", "Default"
            binder.BindPostVariable Me , "C" ,vbLong , "CARD_SID" , vbLong
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            Set r = binder.ItemForEdit(sid,RelTable)
            If r Is Nothing Then Exit Function
            If ConvertTo(vbLong,sid) = 0 Then binder.Binding("CARD_SID").Disabled = True
            binder.ReadFrom r
            binder.Binding("CARD_SID").Disabled = False
            EditingId = sid
            txtComments.Language = PageUILanguage
            Active = True
            EditControl.Active = True
            Load = True
        End Function
        Public Function Save
            Dim r
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = EditingId
                    Set r = binder.ItemForWrite(EditingId, RelTable)
                    If Not r Is Nothing Then
                        binder.WriteTo r
                        EditingId = binder.WriteItem(r,RelTable)
                    End If
                    If Database.CompleteTransaction Then
                        Changed = True
                        Active = False
                        EditingId = 0
                        Save = True
                    End If
                On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
        End Function
        Public Function Delete
            Delete = False
            If EditingId <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = EditingId
                    binder.DeleteItem EditingId, RelTable
                    EditingId = 0
                    If Database.CompleteTransaction Then
                        Active = False
                        Changed = True
                        Delete = True
                    End If
                On Error Goto 0
                End If
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                EditingId = ConvertTo(vbLong, Failure("Id"))
            End If
        End Function
        
        Sub ProcessPage
            Dim id ' A temporary variable for identifiers
            Dim r, I ' Temporary results
            
            If Not IsPostBack Then
                EditControl.Active = False
            End If
            
            If btnAddNew.Clicked Then
                If Not Load(0) Then
                    Database.AddError TR("Failed to create new record")
                End If
            ElseIf btnChange.Clicked Then
                If Not Load(ConvertTo(vbLong,btnChange.Value)) Then
                    Database.AddError TR("Failed to load the record for editing")
                End If
            ElseIf btnOk.Clicked Then
                If Save Then
                    Changed = True
                    Active = False
                End If
            ElseIf btnCancel.Clicked Then
                Active = False
                EditingId = 0
                EditControl.Active = False
            ElseIf btnDelete.Clicked Then
                If Delete Then
                    Active = False
                    Changed = True
                End If
            End If
            
            ' Generate the results for showing
            ' Response.Write "SELECT COUNT(*) FROM V" & RelTable & " WHERE CARD_ID=$CardId AND ($ShowDel OR NOT DELETED)<hr>"
            pager.ItemCount = Database.DB.VExecute("SELECT COUNT(*) FROM " & RelTable & " WHERE CARD_SID=$CardId AND LANGUAGE=$LANGUAGE",1,1,CardId,PageUILanguage)(1)(1)
            Set results = Database.DB.VExecute("SELECT R.*, N.NAME AS NAME, N.CODE AS CODE FROM " & RelTable & " R, " & Nomenclature & _
                                        " N WHERE CARD_SID=$CardId AND R.LANGUAGE=$LANGUAGE AND N.LANGUAGE=$LANGUAGE AND N.SID=R." & RelField & _
                                        orderer.OrderClause & pager.LimitOffsetClause, 1, 0,_
                                        CardId, PageUILanguage)
            
        End Sub
        
        ' Post Variables ===============================
        
        Public Property Get CardId
            CardId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"C"))
        End Property
        Public Property Let CardId(v)
            PostVariables.SetCtlVar Me, "C", ConvertTo(vbLong,v)
        End Property
        Public Property Get Nomenclature
            Nomenclature = EditControl.Nomenclature
        End Property
        Public Property Let Nomenclature(v)
            EditControl.Nomenclature = v ' No need to keep it twice
            SetupBinder
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        ' Can be 0 - adding new, <> 0 Editing an existing entry
        Public Property Get EditingId
            EditingId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"E"))
        End Property
        Private Property Let EditingId(v)
            PostVariables.SetCtlVar Me, "E", ConvertTo(vbLong,v)
        End Property
        
        ' End Post Variables ===============================
        
        ' Helpers based on the post variables
        Private Property Get RelTable
            RelTable = "CARD_" & Nomenclature & "_REL"
        End Property
        Private Property Get RelField
            RelField = Nomenclature & "_SID"
        End Property
        
        Public Property Get ClassType
            ClassType = "UCMultiNom" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            Dim nRec, rec, rowClass
            %>
            <table <%= StyleAndCssString(CssClass,Style) %>>
                <tr class="heading">
                    <th nowrap width="20%"><% orderer("CODE").Render %></th>
                    <th nowrap width="40%"><% orderer("NAME").Render %></th>
                    <th nowrap width="40%"><% orderer("COMMENTS").Render %></th>
                    <th nowrap>&nbsp;</th>
                </tr>
                <% 
                For nRec = 1 To results.Count 
                    Set rec = results(nRec)
                    If EditingId <> ConvertTo(vbLong,rec("SID")) Then 
                        If nRec Mod 2 <> 0 Then rowClass = "odd" Else rowClass = "even"
                    Else
                        rowClass = "selected"
                    End If
                    If Active And EditingId = ConvertTo(vbLong, rec("SID")) Then
                    %>
                    <tr class="caption">
                            <th colspan="4" nowrap><%= TR("Edit entry") %></th>
                        </tr>
                    <tr class="editrow">
                        <td colspan="3" width="100%">
                        <%
                        EditControl.Render
                        If ShowComments Then
                            %><%= TR("Comment") %> <% txtComments.Render : vldComments.Render %><%
                        End If
                        %>
                        </td>
                        <td>
                            <% btnOk.Render %><br/>
                            <% btnDelete.Render %><br/>
                            <% btnCancel.Render %><br/>
                        </td>
                    </tr>
                    <%
                    Else
                    %>
                    <tr class="<%= rowClass %>" onclick="<%= btnChange.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer">
                        <td nowrap width="20%"><%= HTMLEncode(rec("CODE")) %></td>
                        <td nowrap width="40%"><%= HTMLEncode(rec("NAME")) %></td>
                        <td width="40%"><%= HTMLEncode(Elipsis(rec("COMMENTS"), 80)) %></td>
                        <td nowrap><% btnChange.RenderValue(rec("SID")) %></td>
                    </tr>
                    <%
                    End If
                Next
                %>
                <tr class="pager">
                    <th colspan="4"><% pager.Render %></th>
                </tr>
                <% If Active And EditingId = 0 Then %>
                    <tr class="caption">
                        <th colspan="4" nowrap><%= TR("Add new entry") %></th>
                    </tr>
                    <tr class="editrow">
                        <td colspan="3">
                        <%
                        EditControl.Render
                        If ShowComments Then
                            %><%= TR("Comment") %> <% txtComments.Render : vldComments.Render %><%
                        End If
                        %>
                        </td>
                        <td>
                            <% btnOk.Render %><br/>
                            <% btnCancel.Render %><br/>
                        </td>
                    </tr>
                <% ElseIf Not Active Then %>
                    <tr class="pager">
                        <td colspan="4"><% btnAddNew.Render %></td>
                    </tr>
                <% End If %>
            </table>
            <%
            orderer.Render
        End Sub
    
    End Class

    ' Constructor
    Function Create_UCMultiNom(ctlName) 
        Set ctl = New UCMultiNom ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCMultiNom = ctl ' TO DO: Change the control name
    End Function

%>