<!-- #include file="uc-userselector.asp" -->
<%
    UCObjectRights_RGROUP = TR("Visible by the owner group")
    UCObjectRights_RALL   = TR("Visible for everybody")
    UCObjectRights_NOT_RGROUP = TR("Not visible for the owner group")
    UCObjectRights_NOT_RALL = TR("Not visible for everybody")
    
    Class UCObjectRights
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public Table
        
        ' CONTROLS
        Private btnOpen, btnClose, btnOk, btnCancel
        Private lstUser, lstGroup, lstAll, ckApplyToChildren
        Private usrSel, grpSel
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        Private binder
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            Set usrSel = New UCUserSelector
            If Not IsAdmin Then usrSel.ReadOnly = True
                
            Set grpSel = Create_CList(Empty)
            grpSel.NoChecks = True
            
            ' INIT CONTAINED WEB CONTROLS
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.SkinId = "Orange"
            btnCancel.Caption = TR("Cancel")
            btnCancel.AsyncPostBack(Me) = True
            
            Set lstUser = Create_CList(Empty)
            With lstUser
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            Set lstGroup = Create_CList(Empty)
            With lstGroup
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            Set lstAll = Create_CList(Empty)
            With lstAll
                .AddItem "0", TR("none")
                .AddItem "1", TR("use")
                .AddItem "3", TR("read")
                .AddItem "7", TR("read/write")
            End With
            
            Set ckApplyToChildren = Create_CCheckBox(Empty)
            ckApplyToChildren.Caption = TR("Apply to children")
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl lstUser, vbLong, "R_USER", vbLong, "Default", "Default"
            binder.BindControl lstGroup, vbLong, "R_GROUP", vbLong, "Default", "Default"
            binder.BindControl lstAll, vbLong, "R_ALL", vbLong, "Default", "Default"
            binder.BindControl grpSel, vbLong, "OWNER_GROUP_ID", vbLong, "Default", "Default"
            binder.BindControl usrSel, vbLong, "OWNER_USER_ID", vbLong, "Default", "Default"
             
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Private Sub FillGroups
            grpSel.Items.Clear
            grpSel.AddItem "", ""
            grpSel.AddSQLiteItems Database.DB.Execute("SELECT ID, NAME FROM S_GROUP WHERE NOT DELETED ORDER BY NAME"), "ID", "NAME"
        End Sub
        
        Function Load
            Dim r
            Load = False
            If Id <> 0 Then
                Set r = binder.ItemForEdit(Id, Table)
                If r Is Nothing Then Exit Function
                binder.ReadFrom r
                Load = True
            Else
                lstUser.SelectedValue = CurrentUser.R_USER
                lstGroup.SelectedValue = CurrentUser.R_GROUP
                lstAll.SelectedValue = CurrentUser.R_ALL
                Load = True
            End If
        End Function
        Function Save
            Dim r
            Save = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                    If Not IsAdmin Then
                        binder("R_USER").Disabled = Not CurrentUser.IsServiceAllowed("RUSER")
                        binder("R_GROUP").Disabled = Not CurrentUser.IsServiceAllowed("RGROUP")
                        binder("R_ALL").Disabled = Not CurrentUser.IsServiceAllowed("RALL")
                        binder("OWNER_USER_ID").Disabled = True
                        binder("OWNER_GROUP_ID").Disabled = True
                    End If
                    Set r = binder.ItemForWrite(Id, Table)
                    If Not r Is Nothing Then
                        If CurrentUser.CanWriteRecord(r) Then
                            binder.WriteTo r
                            binder.WriteItem r, Table
                        End If
                    End If
                    If Database.CompleteTransaction Then
                        Save = True
                    End If
                End If
            Else
                CurrentUser.R_USER = ConvertTo(vbLong, lstUser.SelectedValue)
                If IsAdmin Or CurrentUser.IsServiceAllowed("RGROUP") Then
                    CurrentUser.R_GROUP = ConvertTo(vbLong, lstGroup.SelectedValue)
                End If
                If IsAdmin Or CurrentUser.IsServiceAllowed("RALL") Then
                    CurrentUser.R_ALL = ConvertTo(vbLong, lstAll.SelectedValue)
                End If
                UpdateCurrentUser
                Save = True
            End If
        End Function
        Sub ProcessPage
            If IsPostBack Then
                If btnOpen.Clicked And Not Active Then
                    If Load Then
                        Active = True
                    End If
                ElseIf btnOk.Clicked Then
                    If Save Then
                        Active = False
                    End If
                ElseIf btnCancel.Clicked Or btnClose.Clicked Then
                    Active = False
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
           Active = False
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCObjectRights" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            RenderSlim
            If Active Then
                RenderForm
            End If
        End Sub
        
        Private Sub RenderSlim
            Dim r
            %>
            <table class="<%= IfThenElse(Active,"SelectorBarActive","SelectorBar") %>" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Active,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%
                        If Id <> 0 Then
                            Response.Write TR("Edit access rights")
                        Else
                            Response.Write TR("Change default access rights")
                        End If
                    %></td>
                    <td nowrap><% 
                        If Not Active Then
                            btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                        hint.RenderHint "OBJECTRIGHTS"
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            Dim rinfo
            Set rinfo = GetDatabaseItemSysInfo(Id, Table)
            If Id <> 0 Then
            If IsAdmin Then FillGroups
            %>
            <table class="form" >
                <tr>
                    <th class="formCaption" colspan="4"><%= TR("Ownership and access rights") %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Owner user") %></th>
                    <% If IsAdmin Then %>
                        <td nowrap class="formField"><% usrSel.Render %></td>
                    <% Else %>
                        <td nowrap class="formField"><%= HTMLEncode(rinfo("OWNER_USER_LOGIN")) %></td>
                    <% End If %>
                    <th nowrap class="formLabel"><%= TR("Owner group") %></th>
                    <% If IsAdmin Then %>
                        <td nowrap class="formField"><% grpSel.Render %></td>
                    <% Else %>
                        <td nowrap class="formField"><%= HTMLEncode(rinfo("OWNER_GROUP_NAME")) %></td>
                    <% End If %>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Created") %></th>
                    <td nowrap class="formField"><%= FormatDateString(rinfo("CREATED"),PageUIDateTimeFormat) %></td>
                    <th nowrap class="formLabel"><%= TR("Modified") %></th>
                    <td nowrap class="formField"><%= FormatDateString(rinfo("MODIFIED"),PageUIDateTimeFormat) %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Modified by") %></th>
                    <td nowrap class="formField" colspan="3"><%= HTMLEncode(rinfo("MODIFY_USER_LOGIN")) %></td>
                </tr>
                <tr>
                    <th class="formCaption" colspan="4"><%= TR("Access rights") %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Owner user") %></th>
                    <td nowrap class="formField" colspan="3">
                        <%
                        If IsAdmin Or CurrentUser.IsServiceAllowed("RUSER") Then
                            lstUser.Render
                        Else
                            Response.Write HTMLEncode(RightsDisplayText(rinfo("R_GROUP"),False))
                        End If
                        %>
                    </td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Owner group") %></th>
                    <td nowrap class="formField" colspan="3">
                        <% 
                            If IsAdmin Or CurrentUser.IsServiceAllowed("RGROUP") Then
                                lstGroup.Render
                            Else
                                Response.Write HTMLEncode(RightsDisplayText(rinfo("R_GROUP"),False))
                            End If
                        %>
                    </td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Everyone") %></th>
                    <td nowrap class="formField" colspan="3">
                        <% 
                            If IsAdmin Or CurrentUser.IsServiceAllowed("RALL") Then
                                lstAll.Render
                            Else
                                Response.Write HTMLEncode(RightsDisplayText(rinfo("R_ALL"),False))
                            End If
                        %>
                    </td>
                </tr>
                <tr>
                    <td nowrap class="formButtons" colspan="4">
                        <% 
                            btnOk.Render
                            btnCancel.Render
                            Response.Write "<br/>"
                            ckApplyToChildren.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
            Else
            %>
            <table class="form" >
                <tr>
                    <th class="formCaption" colspan="4"><%= TR("Access rights applied when new entries are created") %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Owner user") %></th>
                    <td nowrap class="formField" colspan="3">
                        <% lstUser.Render %>
                    </td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Owner group") %></th>
                    <td nowrap class="formField" colspan="3">
                        <% 
                            If IsAdmin Or CurrentUser.IsServiceAllowed("RGROUP") Then
                                lstGroup.Render
                            Else
                                Response.Write HTMLEncode(RightsDisplayText(CurrentUser.R_GROUP,False))
                            End If
                        %>
                    </td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Everyone") %></th>
                    <td nowrap class="formField" colspan="3">
                        <% 
                            If IsAdmin Or CurrentUser.IsServiceAllowed("RALL") Then
                                lstAll.Render
                            Else
                                Response.Write HTMLEncode(RightsDisplayText(CurrentUser.R_ALL,False))
                            End If
                        %>
                    </td>
                </tr>
                <tr>
                    <td nowrap class="formButtons" colspan="4">
                        <% 
                            btnOk.Render
                            btnCancel.Render
                            Response.Write "<br/>"
                            ckApplyToChildren.Render
                        %>
                    </td>
                </tr>
            </table>
            <%    
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCObjectRights(ctlName) 
        Set ctl = New UCObjectRights ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCObjectRights = ctl ' TO DO: Change the control name
    End Function

%>