<%
    Function Create_UCPersons(ctlName) 
        Set ctl = New UCPersons ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCPersons = ctl ' TO DO: Change the control name
    End Function
    
    ' Entity list
    Class UCPersons
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        Public CssClassTable
        
        ' CONTROLS
        Private txtFiltName, btnReload, btnSelect
        Private vldFiltName
        Private orderer, pager
        
        ' PROPERTIES
        Public Users
        
        ' INDICATORS
        Public Selected
        
        Public Sub Init
            Set txtFiltName = Create_CText(Empty)
            txtFiltName.SkinId = "FilterFull"
            Set vldFiltName = Create_UCValidator(txtFiltName,Me,"SearchField")
            
            Set btnReload = Create_CButton(Empty)
            btnReload.Caption = TR("Search")
            btnReload.AsyncPostBack(Me) = True
            
            Set btnSelect = Create_CImageButton(Empty)
            btnSelect.AsyncPostBack(Me) = True
            
            Set orderer = Create_OrdererSet(Empty)
            orderer("NAME1").Caption = TR("First name")
            orderer("NAME2").Caption = TR("Middle name")
            orderer("NAME3").Caption = TR("Last name")
            orderer("TITLE").Caption = TR("Title")
            orderer("SEARCH_RANK").Caption = TR("Search rank")
            
            orderer.AsyncPostBack(Me) = True
            Set pager = Create_ButtonPager(Empty)
            pager.AsyncPostBack(Me) = True
            
            CssClassTable = "UCSimpleGrid"
        End Sub
        
        Sub ProcessPage
            If btnSelect.Clicked Then
                Selected = True
                Id = btnSelect.Value
            ElseIf btnReload.Clicked Then
                orderer.SortField = "SEARCH_RANK"
                orderer.SortDir = -1
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        
        Public Property Get NameFilter
            NameFilter = Empty
            If Validate(Me.Name) Then
                NameFilter = ConvertTo(vbString, txtFiltName.Value)
            End If
        End Property
        Public Property Let NameFilter(v)
            txtFiltName.Value = ConvertTo(vbString, v)
        End Property
        
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCPersons" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            Dim I, r, rec, sql, rowClass, code, s, idlistPos, idlistNeg, params
            
            Set params = CreateDictionary
            params.Missing = Null
            params("LANGUAGE") = PageUILanguage
            
            idlistPos = KeywordIDList(NameFilter, True, False)
            idlistNeg = KeywordIDList(NameFilter, False, True)
            
            If idlistPos <> "0" Then
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM PERSON P WHERE P.LANGUAGE=$LANGUAGE AND NOT P.DELETED AND " & _
                                    SQLReadRightsTable("P") & " AND P.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                    " P.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            Else
                pager.ItemCount = Database.DB.CExecute("SELECT COUNT(*) FROM PERSON P WHERE P.LANGUAGE=$LANGUAGE AND NOT P.DELETED AND " & _
                                    SQLReadRightsTable("P") & " AND P.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))", params, 1, 1)(1)(1)
            End If
            
            If idlistPos <> "0" Then
                Set r = Database.DB.CExecute("SELECT P.*, (SELECT COUNT(*) FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ") AND OBJECT_SID=P.SID) AS SEARCH_RANK " & _
                                             " FROM PERSON P WHERE P.LANGUAGE=$LANGUAGE AND NOT P.DELETED AND " & _
                                                SQLReadRightsTable("P") & " AND P.SID IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistPos & ")) AND " & _
                                                " P.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            Else
                Set r = Database.DB.CExecute("SELECT P.*, P.SID AS SEARCH_RANK " & _
                                             " FROM PERSON P WHERE P.LANGUAGE=$LANGUAGE AND NOT P.DELETED AND " & _
                                                SQLReadRightsTable("P") & " AND " & _
                                                " P.SID NOT IN (SELECT OBJECT_SID FROM OBJECT_KEYWORD WHERE KEYWORD_ID IN (" & idlistNeg & "))" & _
                                                orderer.OrderClause & pager.LimitOffsetClause, params)
            End If
            
            %>
            <table cellspacing="0" class="<%= CssClassTable %>" width="100%" style="width:100%">
                <tr class="filter">
                    <th nowrap><%= TR("Find") %></th>
                    <% If idlistPos <> "0" Then %>
                        <th nowrap colspan="4"><% txtFiltName.Render : vldFiltName.Render %></th>
                    <% Else %>
                        <th nowrap colspan="3"><% txtFiltName.Render : vldFiltName.Render %></th>
                    <% End If %>
                    <th nowrap style="width:100%;text-align:right;"><% btnReload.Render %></th>
                </tr>
                <tr class="heading">
                    <th>&nbsp;</th>
                    <th><% orderer("TITLE").Render %></th>
                    <th><% orderer("NAME1").Render %></th>
                    <th><% orderer("NAME2").Render %></th>
                    <th><% orderer("NAME3").Render %></th>
                    <% If idlistPos <> "0" Then %>
                    <th><% orderer("SEARCH_RANK").Render %></th>
                    <% End If %>
                </tr>
                <%
                btnSelect.NoLabel = True
                For I = 1 To r.Count
                    Set rec = r(I)
                    If Id <> ConvertTo(vbLong,rec("SID")) Then 
                        If I Mod 2 <> 0 Then rowClass = "odd" Else rowClass = "even"
                    Else
                        rowClass = "selected"
                    End If
                    btnSelect.Caption = TR("Click to select")
                    btnSelect.Src = VirtPath("/img/user-on.gif")
                    %>
                    <tr class="<%= rowClass %>" onclick="<%= btnSelect.GetAsyncPostBack(Me,ConvertTo(vbLong,rec("SID"))) %>" style="cursor:pointer">
                        <td nowrap><% btnSelect.RenderValue(rec("SID")) %></td>
                        <td nowrap><%= HTMLEncode(rec("TITLE")) %></td>
                        <td nowrap><%= HTMLEncode(rec("NAME1")) %></td>
                        <td nowrap><%= HTMLEncode(rec("NAME2")) %></td>
                        <td nowrap><%= HTMLEncode(rec("NAME3")) %></td>
                        <% If idlistPos <> "0" Then %>
                        <td nowrap><%= HTMLEncode(rec("SEARCH_RANK")) %></td>
                        <% End If %>
                    </tr>
                    <%
                Next
                %>
                <tr class="pager">
                    <th colspan="6"><% pager.Render %></th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class

%>