<%

    ' Quotas for the user template (in groups) or an user
    ' This control diplays both quotas and delta quotas
    Class UCQuotas
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS
        Private colQFields, colQValidators, colLabels
        Private txtDays, vldDays
        Private btnSave, btnOpen, btnClose, btnRemove
        
        ' Properties
        Public IsGroup ' is this for a group or an user
        Public IsDelta ' is this delta quotas or total quotas (totals have one more field)
        Public ShowRemove
        
        ' TO DO: Declare indicator properties e.g.
        ' Public Changed
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            Dim arr, I, f, vld, arrLabels
            arr = Split(UCQuotas_QFields,",")
            arrLabels = Split(UCQuotas_QLabels,",")
            Set colQFields = CreateCollection
            Set colQValidators = CreateCollection
            Set colLabels = CreateCollection
            For I = LBound(arr) To UBound(arr)
                Set f = Create_CText(Empty)
                f.SkinId = "Short"
                Set vld = Create_NumericValidator(f,5,False,vbLong,-1,10000)
                vld.Group = Me.Name
                vld.Message = TR("The quota limits can be from 0 to 10000.")
                Set colQValidators(arr(I)) = vld
                Set colQFields(arr(I)) = f
                colLabels(arr(I)) = arrLabels(I)
            Next
            
            Set txtDays = Create_CText(Empty)
            txtDays.SkinId = "Short"
            Set vldDays = Create_NumericValidator(txtDays,2,True,vbLong,1,10)
            vldDays.Group = Me.Name
            vldDays.Message = TR("The control period for the delta quotas can be between 1 and 10 days.")
            
            Set btnSave = Create_CButton(Empty)
            btnSave.Caption = TR("Save")
            btnSave.AsyncPostBack(Me) = True
            btnSave.SkinId = "Green"
            Set btnRemove = Create_CButton(Empty)
            btnRemove.Caption = TR("Remove")
            btnRemove.AsyncPostBack(Me) = True
            btnRemove.SkinId = "Red"
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
        End Sub
        
        Public Function Load(pid,isgrp,isdlt)
            Dim r, I
            Load = False
            If Not IsAdmin Then 
                Database.AddError TR("Access denied. (this form is accessible only for administrators)")
                Exit Function
            End If
            If isgrp Then
                If isdlt Then
                    Set r = Database.DB.VExecute("SELECT * FROM GROUP_DELTA_QUOTAS WHERE GROUP_ID=$pid",1,1,NullConvertTo(vbLong,pid))
                Else
                    Set r = Database.DB.VExecute("SELECT * FROM GROUP_QUOTAS WHERE GROUP_ID=$pid",1,1,NullConvertTo(vbLong,pid))
                End If
            Else
                If isdlt Then
                    Set r = Database.DB.VExecute("SELECT * FROM USER_DELTA_QUOTAS WHERE USER_ID=$pid",1,1,NullConvertTo(vbLong,pid))
                Else
                    Set r = Database.DB.VExecute("SELECT * FROM USER_QUOTAS WHERE USER_ID=$pid",1,1,NullConvertTo(vbLong,pid))
                End If
            End If
            ParentId = pid
            If r.Count = 0 Then
                For I = 1 To colQFields.Count
                    colQFields(I).Value = 0
                Next
                txtDays.Value = 1
                IsGroup = isgrp
                IsDelta = isdlt
                ' Load = True
            Else
                Set r = r(1)
                For I = 1 To colQFields.Count
                    colQFields(I).Value = ConvertTo(vbLong, r(colQFields.Key(I)))
                Next
                If Not isdlt Then
                    txtDays.Value = ConvertTo(vbLong, r("DAYS"))
                    If txtDays.Value = 0 Then txtDays.Value = 1
                End If
                IsGroup = isgrp
                IsDelta = isdlt
                Load = True
            End If
        End Function
        Private Function InsQuery
            Dim s, I, flds, prms, arr
            s = "INSERT INTO "
            flds = ""
            prms = ""
            For I = 1 To colQFields.Count
                If Len(flds) > 0 Then 
                    flds = flds & ","
                    prms = prms & ","
                End If
                flds = flds & colQFields.Key(I)
                prms = prms & "$" & colQFields.Key(I)
            Next
            If IsGroup Then
                If IsDelta Then
                    s = s & "GROUP_DELTA_QUOTAS (GROUP_ID," & flds & ") VALUES ($GROUP_ID," & prms & ")"
                Else
                    s = s & "GROUP_QUOTAS (GROUP_ID," & flds & ",DAYS) VALUES ($GROUP_ID," & prms & ",$DAYS)"
                End If
            Else
                If IsDelta Then
                    s = s & "USER_DELTA_QUOTAS (USER_ID," & flds & ") VALUES ($USER_ID," & prms & ")"
                Else
                    s = s & "USER_QUOTAS (USER_ID," & flds & ",DAYS) VALUES ($USER_ID," & prms & ",$DAYS)"
                End If
            End If
            InsQuery = s
        End Function
        Public Function Save
            Dim params, I
            Save = False
            vldDays.Disabled = Me.IsDelta
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                Err.Clear
                    Set params = CreateCollection
                    params.Missing = Null
                    For I = 1 To colQFields.Count
                        params(colQFields.Key(I)) = ConvertTo(vbLong, colQFields(I).Value)
                    Next
                    params("DAYS") = NullConvertTo(vbLong, txtDays.Value)
                    
                    params("GROUP_ID") = ParentId
                    params("USER_ID") = ParentId
                    Database.DB.CExecute InsQuery, params
                    
                    If Database.CompleteTransaction Then
                        Save = True
                    End If
                End If
            Else
                Database.InvalidateTransaction
            End If
        End Function
        Function Remove
            Dim tbl
            Remove = False
            If ParentId <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    If IsGroup Then 
                        tbl = IfThenElse(IsDelta,"GROUP_DELTA_QUOTAS","GROUP_QUOTAS")
                    Else
                        tbl = IfThenElse(IsDelta,"USER_DELTA_QUOTAS","USER_QUOTAS")
                    End If
                    Database.DB.VExecute "DELETE FROM " & tbl & " WHERE " & IfThenElse(IsGroup,"GROUP_ID","USER_ID") & "=$ID", 1, 0, ParentId
                    If Database.CompleteTransaction Then
                        Remove = True
                    End If
                End If
            End If
        End Function
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If btnSave.Clicked Then
                    If Save Then
                        Active = False
                    End If
                ElseIf btnRemove.Clicked Then
                    If Remove Then Active = False
                ElseIf btnOpen.Clicked Or btnClose.Clicked Then
                    If Active Then
                        Active = False
                    Else
                        Loaded = Load(ParentId, IsGroup, IsDelta)
                        Active = True
                    End If
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        ' Depending on IsGroup this is an user or group id
        Public Property Get ParentId
            ParentId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"PI"))
        End Property
        Public Property Let ParentId(v)
            PostVariables.SetCtlVar Me, "PI", ConvertTo(vbLong,v)
            Active = False
        End Property
        Public Property Get Loaded
            Loaded = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"L"))
        End Property
        Public Property Let Loaded(v)
            PostVariables.SetCtlVar Me, "L", ConvertTo(vbBoolean,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        Public Property Get Value
            Value = ParentId
        End Property
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCQuotas" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
            ' SavePrefs ' If you are using session preferences this is the best place to save them.
        End Sub
        Public Sub RenderPartial
            If ParentId <> 0 Then
                If Active Then
                    RenderSlim
                    RenderForm
                Else
                    RenderSlim
                End If
            End If
        End Sub
        Private Sub RenderSlim
            Dim sbarClass
            If Active Then sbarClass = "SelectorBarActive" Else sbarClass = "SelectorBar"
            %>
            <table class="<%= sbarClass %>" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Mode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%
                        If IsDelta Then
                            Response.Write TR("Speed limit (new items per control period)") 
                        Else
                            Response.Write TR("Quota (maximum items in the database)") 
                        End If
                    %></td>
                    <td nowrap><% 
                        If Not Active Then
                            btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Public Sub RenderForm
            Dim I
            %>
            <table class="form">
                <tr>
                    <th class="formCaption" colspan="2"><%
                        If IsGroup Then
                            If IsDelta Then
                                Response.Write TR("Speed limit (new items per control period)")
                            Else
                                Response.Write TR("Quota (maximum items in the database)")
                            End If
                        Else
                            If IsDelta Then
                                Response.Write TR("Speed limit (new items per control period)")
                            Else
                                Response.Write TR("Quota (maximum items in the database)")
                            End If
                        End If
                    %></th>
                </tr>
                <%
                For I = 1 To colQFields.Count
                %>
                <tr>
                    <th nowrap class="formLabel"><%= TR(colLabels(I)) %></th>
                    <td class="formField"><% colQFields(I).Render : colQValidators(I).Render %></td>
                </tr>
                <%
                Next
                If Not IsDelta Then
                %>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Control period") %></th>
                    <td class="formField"><% txtDays.Render : vldDays.Render %><br/>
                        <%= TR("The control period for the delta quotas 1-10 days") %>
                        </td>
                </tr>
                <%
                End If
                %>
                <tr>
                    <td colspan="2" class="formButtons">
                        <%
                            btnSave.Render
                            If ShowRemove And Loaded Then btnRemove.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class

%>