<%
    ' Simple nomenclatures
    
    Function Create_UCSimpleNom(ctlName) 
        Set ctl = New UCSimpleNom ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCSimpleNom = ctl ' TO DO: Change the control name
    End Function
    
    Class UCSimpleNom
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        
        ' CONTROLS
        Private lstNom, btnReload, btnAddNew, btnEdit
        ' Edit
        Private txtCode, vldCode, txtName, vldName
        Private binder
        Private cRights
        Private btnOk, btnCancel, btnDelete
        Private cIcon
        
        
        ' OPTIONAL SETTINGS
        Public ShowCode ' Show code field
        Public HideReload ' Hides the reload button
        
        ' REQUIRED SETTINGS
        Public NomenclatureName ' Caption of the form
        
        ' INDICATORS
        Public Selected
        
        Sub Init
            Set cRights = Create_UCObjectRights(Empty)
            Rendered = False
            cRights.Table = Nomenclature
            
            Set lstNom = Create_CList(Empty)
            lstNom.SkinId = "PanelSelect"
            lstNom.AddItem "", ""

            Set btnReload = Create_CImageButton(Empty)
            btnReload.SkinId = "PanelReload"
            btnReload.AsyncPostBack(Me) = True
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PanelEdit"
            btnEdit.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CImageButton(Empty)
            btnAddNew.SkinId = "PanelNew"
            btnAddNew.AsyncPostBack(Me) = True
            
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you want to delete this entry?")
            
            Set txtCode = Create_CText(Empty)
            txtCode.SkinId = "Normal"
            Set vldCode = Create_UCValidator(txtCode, Me, "NomenclatureCode")
            Set txtName = Create_UCMultiLangText(Empty)
            txtName.SkinId = "Gray"
            txtName.Style = "width: 100%;"
            Set vldName = Create_UCValidator(txtName, Me, "NomenclatureName")
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl txtCode, vbString, "CODE", vbString, "Default", "Default"
            binder.BindControl txtName, vbString, "NAME", vbString, "Default", "Default"
            
            Set lstNom.AsyncPostBack(Me) = btnReload
            FillNomenclature
            
            CssClass = "UCControl"
        End Sub
        
        Private pWithIcon
        Public Property Get WithIcon
            If pWithIcon And IsObject(cIcon) Then
                WithIcon = True
            Else
                WithIcon = False
            End If
        End Property
        Public Property Let WithIcon(v)
            If v Then
                If IsNotObject(cIcon) Then
                    Set cIcon = Create_UCImageDlg(Me.Name & "_Icon") 
                    binder.BindControl cIcon, vbLong, "IMAGE_SID", vbLong, "Default", "Default"
                    UserControlProcessLast Me
                End If
            Else
                binder.UnBind "IMAGE_SID"
            End If
            pWithIcon = v
        End Property
        
        Private Sub FillNomenclature
            If Len(Nomenclature) = 0 Then Exit Sub
            lstNom.Items.Clear
            lstNom.AddItem "", ""
            If ShowCode Then
                lstNom.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME || ' (' || CODE || ')' AS CAPTION FROM [" & Nomenclature & "] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & _
                                                           SQLReadRights & " ORDER BY CAPTION",1,0,PageUILanguage), "SID", "CAPTION"
            Else
                lstNom.AddSQLiteItems Database.DB.VExecute("SELECT SID, NAME AS CAPTION FROM [" & Nomenclature & "] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & _
                                                           SQLReadRights & " ORDER BY CAPTION",1,0,PageUILanguage), "SID", "CAPTION"
            End If                                                       
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            Set r = binder.ItemForEdit(sid,Nomenclature)
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            Id = sid
            txtName.Language = PageUILanguage
            cRights.Id = Id
            EditMode = True
            Load = True
        End Function
        Public Function LoadByCode(cd)
            Dim r
            Set r = Database.DB.Vexecute("SELECT SID FROM [" & Nomenclature & "] WHERE CODE=? AND " & SQLReadRights & " LIMIT 1", 1, 1, ConvertTo(vbString, cd))
            If r.Count > 0 Then
                LoadByCode = Load(r(1)("SID"))
            Else
                LoadByCode = Load(0)
                txtCode.Value = cd
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                cRights.Id = Id
            End If
        End Function
        
        Public Property Let Code(v)
            txtCode.Value = v
        End Property
        Public Property Get Code
            Code = txtCode.Value
        End Property
        
        Sub ProcessPage
            Dim r
            If IsPostBack Then
                If btnEdit.Clicked Then
                    Load Id
                ElseIf btnAddNew.Clicked Then
                    Load 0
                ElseIf btnOk.clicked Then
                    If Validate(Me.Name) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            Set r = binder.ItemForWrite(Id, Nomenclature)
                            If Not r Is Nothing Then
                                binder.WriteTo r
                                Id = binder.WriteItem(r,Nomenclature)
                            End If
                            If Database.CompleteTransaction Then
                                FillNomenclature
                                lstNom.SelectedValue = Id
                                cRights.Id = Id
                                Selected = True
                                EditMode = False
                            End If
                        On Error Goto 0
                        End If
                    Else
                        Database.InvalidateTransaction ' This control has its own buttons, Just in case
                    End If
                ElseIf btnDelete.Clicked Then
                    If ElementId <> 0 Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            binder.DeleteItem Id, Nomenclature
                            Id = 0
                            If Database.CompleteTransaction Then
                                EditMode = False
                                cRights.Id = Id
                                Selected = True
                            End If
                        On Error Goto 0
                        End If
                    End If
                ElseIf btnCancel.Clicked Then
                    EditMode = False
                    lstNom.SelectedValue = Id
                    Selected = True
                ElseIf btnReload.Clicked Then
                    Selected = True
                End If
            End If
        End Sub
        
        ' PROPERTIES
        
        ' POST VARIABLES
        Public Property Get Nomenclature
            Nomenclature = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"N"))
        End Property
        Public Property Let Nomenclature(v)
            PostVariables.SetCtlVar Me, "N", ConvertTo(vbString, v)
            FillNomenclature
            cRights.Table = ConvertTo(vbString, v)
        End Property
        Public Property Get ElementId
            ElementId = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let ElementId(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong, v)
        End Property
        Public Property Get Id
            If Not EditMode Then
                Id = ConvertTo(vbLong,lstNom.SelectedValue)
            Else
                Id = ElementId
            End If
        End Property
        Public Property Let Id(v)
            lstNom.SelectedValue = ConvertTo(vbLong, v)
            ElementId = ConvertTo(vbLong, v)
        End Property
        Public Property Get EditMode
            EditMode = ConvertTo(vbBoolean, PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let EditMode(v)
            b = ConvertTo(vbBoolean, v)
            PostVariables.SetCtlVar Me, "M", b
        End Property
        
        Public Property Get Value
            Value = Id
            If Id = 0 Then Value = Empty
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        Public Property Get ClassType
            ClassType = "UCSimpleNom" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> Id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            If EditMode Then
                RenderForm
            Else
                RenderSelector
            End IF
        End Sub
        
        Private Sub RenderSelector
            %>
            <table class="<%= IfThenElse(EditMode,"SelectorBarActive","SelectorBar") %>">
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap><% btnAddNew.Render %></td>
                    <% 
                        If Id <> 0 Then 
                            %><td nowrap><% btnEdit.Render %></td><%
                        End If
                    %>
                    <td nowrap><% lstNom.Render %></td>
                    <% If Not HideReload Then %>
                        <td nowrap><% btnReload.Render %></td>                        
                    <% End If %>
                    <td nowrap width="100%">&nbsp;</td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            %>
                <table class="form">
                    <tr>
                        <th class="formCaption" colspan="2"><%= TR("Editing") & " " & IfThenElse(NomenclatureName <> "",NomenclatureName, Nomenclature) %></th>
                    </tr>
                    <tr>
                        <th nowrap class="formLabel" colspan="2"><% cRights.Render %></th>
                    </tr>
                    <tr>
                        <th nowrap class="formLabel"><%= TR("Caption") %><% vldName.Render %></th>
                        <td nowrap class="formField"><% txtName.Render %></td>
                    </tr>
                    <tr>
                        <th nowrap class="formLabel" colspan="1"><%= TR("Application code") %></th>
                        <td nowrap class="formField" colspan="1"><% txtCode.Render : vldCode.Render %></td>
                    </tr>
                    <% If WithIcon Then %>
                    <tr>
                        <th nowrap class="formLabel" colspan="1"><%= TR("Image (icon)") %></th>
                        <td nowrap class="formField" colspan="1"><% cIcon.Render %></td>
                    </tr>
                    <% End If %>
                    <tr>
                        <td nowrap class="formButtons" colspan="2">
                            <% 
                                btnOk.Render
                                btnCancel.Render
                                Response.Write "&nbsp;"
                                If Id <> 0 Then btnDelete.Render
                            %>
                        </td>
                    </tr>
                </table>
            <%
        End Sub
    
    End Class

%>