<%
    ' Simple nomenclatures
    Const UCSimpleNomEx_Slim    = 0
    Const UCSimpleNomEx_List    = 1
    Const UCSimpleNomEx_Form    = 2
    
    Function Create_UCSimpleNomEx(ctlName) 
        Set ctl = New UCSimpleNomEx ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCSimpleNomEx = ctl ' TO DO: Change the control name
    End Function
    
    Class UCSimpleNomEx
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        Public BarCssClass, BarActiveCssClass
        
        ' CONTROLS
        Private btnAddNew, btnEdit, btnItem, btnClear
        Private btnOpen ' As CImageButton - Change to active state (full view)
        Private btnClose ' As CImageButton - Change to inactive state (selection indicator only)
        ' Edit
        Private txtCode, vldCode, txtName, vldName, txtBody, vldBody
        Private binder
        Private cRights
        Private btnOk, btnCancel, btnDelete
        Private cIcon
        
        ' OPTIONAL SETTINGS
        Public ShowCode, ShowBody ' Show code field
        
        ' REQUIRED SETTINGS
        Public NomenclatureName ' Caption of the form
        
        ' INDICATORS
        Public Selected
        
        Sub Init
            Set cRights = Create_UCObjectRights(Empty)
            Rendered = False
            cRights.Table = Nomenclature
            
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PanelEdit"
            btnEdit.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CImageButton(Empty)
            btnAddNew.SkinId = "PanelNew"
            btnAddNew.AsyncPostBack(Me) = True
            Set btnItem = Create_CImageButton(Empty)
            btnItem.NoLabel = True
            btnItem.AsyncPostBack(Me) = True
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.AsyncPostBack(Me) = True
            btnOk.SkinId = "Green"
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.AsyncPostBack(Me) = True
            btnCancel.SkinId = "Orange"
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you want to delete this entry?")
            btnDelete.SkinId = "Red"
            
            Set txtCode = Create_CText(Empty)
            txtCode.SkinId = "Normal"
            Set vldCode = Create_UCValidator(txtCode, Me, "NomenclatureCode")
            
            Set txtName = Create_UCMultiLangText(Empty)
            txtName.SkinId = "Gray"
            txtName.Style = "width: 100%;"
            Set vldName = Create_UCValidator(txtName, Me, "NomenclatureName")
            
            Set txtBody = Create_UCMultiLangTextArea(Empty)
            txtBody.SkinId = "Gray"
            txtBody.Style = "width: 100%;"
            Set vldBody = Create_UCValidator(txtBody, Me, "NomenclatureBody")
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            Set btnClear = Create_CImageButton(Empty)
            btnClear.SkinId = "PanelClear"
            btnClear.AsyncPostBack(Me) = True
            
            Set binder = Create_CRecordBinder("LANGUAGE")
            binder.BindControl txtCode, vbString, "CODE", vbString, "Default", "Default"
            binder.BindControl txtName, vbString, "CAPTION", vbString, "Default", "Default"
            binder.BindControl txtBody, vbString, "BODY", vbString, "Default", "Default"
            
            CssClass = "SimpleNomEx"
            BarCssClass = "SelectorBarEx"
            BarActiveCssClass = "SelectorBarActiveEx"
        End Sub
        
        Private pWithIcon
        Public Property Get WithIcon
            If pWithIcon And IsObject(cIcon) Then
                WithIcon = True
            Else
                WithIcon = False
            End If
        End Property
        Public Property Let WithIcon(v)
            If v Then
                If IsNotObject(cIcon) Then
                    Set cIcon = Create_UCImageDlg(Me.Name & "_Icon") 
                    binder.BindControl cIcon, vbLong, "IMAGE_SID", vbLong, "Default", "Default"
                    UserControlProcessLast Me
                End If
            Else
                binder.UnBind "IMAGE_SID"
            End If
            pWithIcon = v
        End Property
        
        Public Function Load(sid)
            Dim r
            Load = False
            Set r = binder.ItemForEdit(sid,Nomenclature)
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            Id = sid
            txtName.Language = PageUILanguage
            txtBody.Language = PageUILanguage
            cRights.Id = Id
            EditMode = UCSimpleNomEx_Form
            Load = True
        End Function
        Public Function LoadByCode(cd)
            Dim r
            Set r = Database.DB.Vexecute("SELECT SID FROM [" & Nomenclature & "] WHERE CODE=? AND " & SQLReadRights & " LIMIT 1", 1, 1, ConvertTo(vbString, cd))
            If r.Count > 0 Then
                LoadByCode = Load(r(1)("SID"))
            Else
                LoadByCode = Load(0)
                txtCode.Value = cd
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                cRights.Id = Id
            End If
        End Function
        
        Public Property Let Code(v)
            txtCode.Value = v
        End Property
        Public Property Get Code
            Code = txtCode.Value
        End Property
        
        Sub ProcessPage
            Dim r
            If IsPostBack Then
                If btnOpen.Clicked Then
                    EditMode = UCSimpleNomEx_List
                ElseIf btnClose.Clicked Then
                    EditMode = UCSimpleNomEx_Slim
                    Selected = True
                ElseIf btnClear.Clicked Then
                    Id = 0
                    EditMode = UCSimpleNomEx_Slim
                    Selected = True
                ElseIf btnEdit.Clicked Then
                    Load Id
                ElseIf btnAddNew.Clicked Then
                    Load 0
                ElseIf btnOk.clicked Then
                    If Validate(Me.Name) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            Set r = binder.ItemForWrite(Id, Nomenclature)
                            If Not r Is Nothing Then
                                binder.WriteTo r
                                Id = binder.WriteItem(r,Nomenclature)
                            End If
                            If Database.CompleteTransaction Then
                                cRights.Id = Id
                                Selected = True
                                EditMode = UCSimpleNomEx_Slim
                            End If
                        On Error Goto 0
                        End If
                    Else
                        Database.InvalidateTransaction ' This control has its own buttons, Just in case
                    End If
                ElseIf btnDelete.Clicked Then
                    If Id <> 0 Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            binder.DeleteItem Id, Nomenclature
                            Id = 0
                            If Database.CompleteTransaction Then
                                EditMode = UCSimpleNomEx_Slim
                                cRights.Id = Id
                                Selected = True
                            End If
                        On Error Goto 0
                        End If
                    End If
                ElseIf btnCancel.Clicked Then
                    EditMode = UCSimpleNomEx_Slim
                    Selected = True
                ElseIf btnItem.Clicked Then
                    Id = btnItem.Value
                    EditMode = UCSimpleNomEx_Slim
                    Selected = True
                End If
            End If
        End Sub
        
        ' PROPERTIES
        
        ' POST VARIABLES
        Public Property Get Nomenclature
            Nomenclature = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"N"))
        End Property
        Public Property Let Nomenclature(v)
            PostVariables.SetCtlVar Me, "N", ConvertTo(vbString, v)
            cRights.Table = ConvertTo(vbString, v)
        End Property
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong, v)
        End Property
        Public Property Get EditMode
            EditMode = ConvertTo(vbLong, PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let EditMode(v)
            PostVariables.SetCtlVar Me, "M", ConvertTo(vbLong, v)
        End Property
        
        Public Property Get Value
            Value = Id
            If Id = 0 Then Value = Empty
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        Public Property Get ClassType
            ClassType = "UCSimpleNomEx" 
        End Property
        
        Public Sub Render
            %>
            <div Id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        
        Public Sub RenderPartial
            RenderSelector
            If EditMode = UCSimpleNomEx_Form Then
                RenderForm
            ElseIf EditMode = UCSimpleNomEx_List Then
                RenderList
            End IF
        End Sub
        
        Private Sub RenderSelector
            Dim text, desc, r, imgId, imgSrc
            imgId = 0
            If Id <> 0 Then
                Set r = Database.DB.VExecute("SELECT N.* FROM " & _
                                             Nomenclature & " N WHERE N.SID=$Id AND N.LANGUAGE=$LANGUAGE",1,1,Id,PageUILanguage)
                If r.Count > 0 Then
                    text = ConvertTo(vbString,ConvertTo(vbString,r(1)("CAPTION")))
                    imgId = ConvertTo(vbLong,r(1)("IMAGE_SID"))
                Else
                    text = TR("(error: the item is no longer in the database)")
                End If
            Else
                text = TR("(no selection)")
            End If
            If imgId <> 0 Then
                imgSrc = VirtPath("/image.asp") & "?th=4&image=" & imgId
            ElseIf Id <> 0 Then
                imgSrc = SysImage("pixel")
            Else
                imgSrc = VirtPath("/usercontrols/nomenclature/question-nom.gif")
            End If
            
            %>
            <table class="<%= IfThenElse(EditMode,BarActiveCssClass,BarCssClass) %>">
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td class="iconSlot" style="text-align:center;vertical-align:middle;cursor:pointer;" 
                        onclick="<%= IfThenElse(EditMode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"
                        ><img src="<%= imgSrc %>" alt="" /></td>
                    <td nowrap class="panelBtn"><% btnAddNew.Render %></td>
                    <% 
                        If Id <> 0 Then 
                            %><td nowrap class="panelBtn"><% btnEdit.Render %></td><%
                            %><td nowrap class="panelBtn"><% btnClear.Render %></td><%
                        End If
                    %>
                    <% If EditMode > 0 Then %>
                        <td nowrap onclick="<%= btnClose.GetAsyncPostBack(Me,0) %>" style="cursor:pointer;">
                            <%= HTMLEncode(text) %></td>
                        <td nowrap class="panelBtn"><% btnClose.Render %></td>
                    <% Else %>
                        <td nowrap onclick="<%= btnOpen.GetAsyncPostBack(Me,0) %>" style="cursor:pointer;">
                            <%= HTMLEncode(text) %></td>
                        <td nowrap class="panelBtn"><% btnOpen.Render %></td>
                    <% End If %>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            %>
                <table class="form">
                    <tr>
                        <th class="caption" colspan="2"><%= TR("Editing") & " " & IfThenElse(NomenclatureName <> "",NomenclatureName, Nomenclature) %></th>
                    </tr>
                    <tr>
                        <th nowrap class="label" colspan="2"><% cRights.Render %></th>
                    </tr>
                    <tr>
                        <th nowrap class="label"><%= TR("Caption") %><% vldName.Render %></th>
                        <td nowrap class="field"><% txtName.Render %></td>
                    </tr>
                    <% If ShowBody Then %>
                    <tr>
                        <th nowrap class="label"><%= TR("Details") %><% vldBody.Render %></th>
                        <td nowrap class="field"><% txtBody.Render %></td>
                    </tr>
                    <% End If %>
                    <tr>
                        <th nowrap class="label" colspan="1"><%= TR("Application code") %></th>
                        <td nowrap class="field" colspan="1"><% txtCode.Render : vldCode.Render %></td>
                    </tr>
                    <% If WithIcon Then %>
                    <tr>
                        <th nowrap class="label" colspan="1"><%= TR("Image (icon)") %></th>
                        <td nowrap class="field" colspan="1"><% cIcon.Render %></td>
                    </tr>
                    <% End If %>
                    <tr>
                        <td nowrap class="buttons" colspan="2">
                            <% 
                                btnOk.Render
                                btnCancel.Render
                                Response.Write "&nbsp;"
                                If Id <> 0 Then btnDelete.Render
                            %>
                        </td>
                    </tr>
                </table>
            <%
        End Sub
        Public Sub RenderList
            Dim r, I, css
            Set r = Database.DB.VExecute("SELECT * FROM [" & Nomenclature & "] WHERE NOT DELETED AND LANGUAGE=$LANGUAGE AND " & _
                                         SQLReadRights & " ORDER BY CAPTION",1,0,PageUILanguage)
            %>
            <div <%= StyleAndCssString(CssClass,Style) %>>
            <table class="<%= CssClass & "Table" %>">
                <%
                For I = 1 To r.Count
                    If Id = ConvertTo(vbLong, r(I)("SID")) Then css = "selected" Else css = "element"
                    btnItem.Src = VirtPath("/image.asp") & "?th=4&image=" & ConvertTo(vbLong,r(I)("IMAGE_SID"))
                    %>
                    <tr class="<%= css %>">
                        <td class="icon"><% btnItem.RenderValue r(I)("SID") %></td>
                        <td class="text" onclick="<%= btnItem.GetAsyncPostBack(Me,r(I)("SID")) %>" style="cursor:pointer;"><%= HTMLEncode(r(I)("CAPTION")) %></td>
                    </tr>
                    <%
                Next
                %>
            </table>
            </div>
            <%
        End Sub
    
    End Class

%>