<%
    Function Create_UCTreeNom(ctlName) 
        Set ctl = New UCTreeNom ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCTreeNom = ctl ' TO DO: Change the control name
    End Function
    Function Create_UCTreeNomReadOnly(ctlName) 
        Set ctl = New UCTreeNom ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        ctl.ReadOnly = True
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCTreeNomReadOnly = ctl ' TO DO: Change the control name
    End Function

    Class UCTreeNom
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' TO DO: Declare control/user control variables e.g.
        Private btnFolder ' As CImageButton - The item buttons
        Private btnPlus ' As CImageButton - The open category button (a plus sign)
        Private btnMinus ' As CImageButton - The close category button (a minus sign)
        Private btnDot ' As CImageButton - The category button for a category with no sub-categories (a dot)
        Private btnOpen ' As CImageButton - Change to active state (full view)
        Private btnClose ' As CImageButton - Change to inactive state (selection indicator only)
        Private btnEdit, btnAddNew, btnClear
        Private btnOk, btnCancel, btnDelete
        Private txtCode, vldCode, txtName, vldName
        Private cRights
        Private cParent, vldParent
        
        Private binder
        
        ' TO DO: Declare indicator properties e.g.
        Public Selected ' As vbBoolean - An item has been selected
        
        ' TO DO: Declare fields you need internally for the control functionality
        Public StepPixels
        Public Width
        Public Height
        Public PanelCssClass
        
        Public AlwaysOpen
        Public ReadOnly
        
        ' We shall see about these
        ' Public IdField ' The name of the item id field
        ' Public ParentIdField ' The name of the parent id field
        
        Sub Init
            Rendered = False
            
            If Not ReadOnly Then
                Set cRights = Create_UCObjectRights(Empty)
                cRights.Table = Nomenclature
                Set cParent = Create_UCTreeNomReadOnly(Empty)
                cParent.Nomenclature = Nomenclature
                Set vldParent = Create_UCValidator(cParent, Me, Empty)
                vldParent.Message = TR("The parent cannot be the same item")
                
                Set btnEdit = Create_CImageButton(Empty)
                btnEdit.SkinId = "PanelEdit"
                Set btnAddNew = Create_CImageButton(Empty)
                btnAddNew.SkinId = "PanelNew"
                
                Set txtCode = Create_CText(Empty)
                txtCode.SkinId = "Normal"
                Set vldCode = Create_UCValidator(txtCode, Me, "NomenclatureCode")
                Set txtName = Create_UCMultiLangText(Empty)
                txtName.SkinId = "Gray"
                txtName.Style = "width: 100%;"
                Set vldName = Create_UCValidator(txtName, Me, "NomenclatureName")
                
                Set btnOk = Create_CButton(Empty)
                btnOk.Caption = TR("Ok")
                Set btnCancel = Create_CButton(Empty)
                btnCancel.Caption = TR("Cancel")
                Set btnDelete = Create_CButton(Empty)
                btnDelete.Caption = TR("Delete")
                btnDelete.ConfirmationText = TR("Do you really want to remove this item?")
                
                Set binder = Create_CRecordBinder("LANGUAGE")
                binder.BindControl txtCode, vbString, "CODE", vbString, "Default", "Default"
                binder.BindControl txtName, vbString, "NAME", vbString, "Default", "Default"
                binder.BindControl cParent, vbLong, "PARENT_SID", vbLong, "Default", "Default"
            End If
            
            
            ' TO DO: Create/initialize all the contained controls you use here e.g.
            Set btnFolder = Create_CImageButton(Empty)
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            
            Set btnPlus = Create_CImageButton(Empty)
            btnPlus.Src = ASPCTLPath & "img/treeplus.gif"
            Set btnMinus = Create_CImageButton(Empty)
            btnMinus.Src = ASPCTLPath & "img/treeminus.gif"
            Set btnDot = Create_CImageButton(Empty)
            btnDot.Src = ASPCTLPath & "img/treenode.gif"
            
            Set btnClear = Create_CImageButton(Empty)
            btnClear.SkinId = "PanelClear"
            
            ClientScripts.EnableAsyncLibrary
            
            ' TO DO: Perform additional initialization tasks if any
            StepPixels = 16
            SelectedId = 0
            PanelCssClass = "dropDownSelector"
        End Sub
        
        Public Function Load(sid)
            Dim r
            Load = False
            If ReadOnly Then Exit Function
            Set r = binder.ItemForEdit(sid,Nomenclature)
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            Id = sid
            txtName.Language = PageUILanguage
            cRights.Id = Id
            EditMode = True
            Load = True
        End Function
        Public Function LoadByCode(cd)
            Dim r
            Set r = Database.DB.Vexecute("SELECT SID FROM [" & Nomenclature & "] WHERE CODE=? AND LANGUAGE=$LANGUAGE AND " & _
                                         SQLReadRights & " LIMIT 1", 1, 1, ConvertTo(vbString, cd), PageUILanguage)
            If r.Count > 0 Then
                LoadByCode = Load(r(1)("SID"))
            Else
                LoadByCode = Load(0)
                txtCode.Value = cd
            End If
        End Function
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
                cRights.Id = Id
            End If
        End Function
        
        Sub ProcessPage
            Dim r
            If btnOpen.Clicked Then
                EditMode = False
                Active = True
            ElseIf btnClose.Clicked Then
                Active = False
                EditMode = False
                Selected = True
            ElseIf btnPlus.Clicked Then
                Id = btnPlus.Value
                Selected = True
            ElseIf btnMinus.Clicked Then
                ' Move the selection to the parent
                Set r = Database.DB.VExecute("SELECT PARENT_SID FROM " & Nomenclature & " WHERE SID=$Id AND LANGUAGE=$LANGUAGE", _
                                             1,1,ConvertTo(vbLong,btnMinus.Value), PageUILanguage)
                If r.Count > 0 Then
                    Id = ConvertTo(vbLong,r(1)(1))
                Else
                    Id = 0
                End If
                Selected = True
            ElseIf btnFolder.Clicked Then
                Id = ConvertTo(vbLong,btnFolder.Value)
                Selected = True
                EditMode = False
                Active = False
            ElseIf Not ReadOnly Then
                If btnEdit.Clicked Then
                    Load Id
                ElseIf btnAddNew.Clicked Then
                    Load 0
                ElseIf btnOk.clicked Then
                    If Id = cParent.Id And Id <> 0 Then vldParent.IsValid = False
                    If Validate(Me.Name) And vldParent.IsValid Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            Set r = binder.ItemForWrite(Id, Nomenclature)
                            If Not r Is Nothing Then
                                binder.WriteTo r
                                Id = binder.WriteItem(r,Nomenclature)
                            End If
                            If Database.CompleteTransaction Then
                                FillNomenclature
                                cRights.Id = Id
                                Selected = True
                                EditMode = False
                                Active = False
                            End If
                        On Error Goto 0
                        End If
                    Else
                        Database.InvalidateTransaction ' This control has its own buttons, Just in case
                    End If
                ElseIf btnDelete.Clicked Then
                    If Id <> 0 Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            Database.FailureValue(Me,"Id") = Id
                            binder.DeleteItem Id, Nomenclature
                            Id = 0
                            If Database.CompleteTransaction Then
                                EditMode = False
                                cRights.Id = Id
                                Selected = True
                                Active = False
                            End If
                        On Error Goto 0
                        End If
                    End If
                ElseIf btnCancel.Clicked Then
                    EditMode = False
                    Active = False
                    Selected = True
                End If
            End If
        End Sub
        
        Public Property Get Nomenclature
            Nomenclature = ConvertTo(vbString,PostVariables.GetCtlVar(Me,"N"))
        End Property
        Public Property Let Nomenclature(v)
            PostVariables.SetCtlVar Me, "N", ConvertTo(vbString, v)
            If Not ReadOnly Then 
                cRights.Table = ConvertTo(vbString, v)
                cParent.Nomenclature = ConvertTo(vbString, v)
            End If
        End Property
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get EditMode
            EditMode = ConvertTo(vbBoolean, PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let EditMode(v)
            b = ConvertTo(vbBoolean, v)
            PostVariables.SetCtlVar Me, "M", b
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        Public Property Get Value
            Value = Id
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
       
        Public Property Get ClassType
            ClassType = "UCTreeNom" 
        End Property
        
        Public Property Let AsyncPostBack(ctl,v)
            btnOpen.AsyncPostBack(ctl) = v
            btnFolder.AsyncPostBack(ctl) = v
            btnDot.AsyncPostBack(ctl) = v
            btnClose.AsyncPostBack(ctl) = v
            btnPlus.AsyncPostBack(ctl) = v
            btnMinus.AsyncPostBack(ctl) = v
            If Not ReadOnly Then
                btnEdit.AsyncPostBack(Me) = v
                btnAddNew.AsyncPostBack(Me) = v
                btnOk.AsyncPostBack(Me) = v
                btnCancel.AsyncPostBack(Me) = v
                btnDelete.AsyncPostBack(Me) = v
                cParent.AsyncPostBack(cParent) = v
            End If
        End Property
        Public Property Get AsyncPostBack(ctl)
            AsyncPostBack = btnOpen.AsyncPostBack(ctl)
        End Property
        
        Private pTree
        Private Property Get Tree
            Dim curId ' The currently processed id
            curId = Id
            Dim r, node
            Set pTree = CreateCollection
            ' Get the children of the selected node
            Set r = Database.DB.VExecute("SELECT T.*, (SELECT COUNT(SID) FROM " & Nomenclature & " WHERE PARENT_SID=T.SID AND LANGUAGE=$LANGUAGE) AS CHILDREN_COUNT FROM " & _
                                Nomenclature & " T WHERE coalesce(T.PARENT_SID,0)=$SID AND LANGUAGE=$LANGUAGE ORDER BY T.NAME",1,0,PageUILanguage, curId)
            r.Info = 0
            pTree.Add "", r
            Do
                If curId <> 0 Then
                    ' Extract siblings
                    Set r = Database.DB.VExecute("SELECT T.*, (SELECT COUNT(SID) FROM " & Nomenclature & " WHERE PARENT_SID=T.SID AND LANGUAGE=$LANGUAGE) AS CHILDREN_COUNT FROM " & _
                                         Nomenclature & " T WHERE T.LANGUAGE=$LANGUAGE AND coalesce(T.PARENT_SID,0) IN (SELECT coalesce(PARENT_SID,0) FROM " & _
                                         Nomenclature & " WHERE SID=$SID AND LANGUAGE=$LANGUAGE) ORDER BY T.NAME",1,0,PageUILanguage, curId)
                    r.Info = curId
                    pTree.Add "", r
                    If r.Count > 0 Then curId = ConvertTo(vbLong,r(1)("PARENT_SID")) Else curId = 0
                End If
            Loop While curId <> 0
            Set Tree = pTree
        End Property
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            If Not EditMode And (Active Or AlwaysOpen) Then
                RenderSlim
                RenderTree
            ElseIf EditMode Then
                RenderSlim
                RenderForm
            Else
                RenderSlim
            End If
        End Sub
    
        Private Sub RenderSlim
            Dim text, desc, r
            If Id <> 0 Then
                Set r = Database.DB.VExecute("SELECT * FROM " & Nomenclature & " WHERE SID=$Id AND LANGUAGE=$LANGUAGE",1,1,Id,PageUILanguage)
                If r.Count > 0 Then
                    text = ConvertTo(vbString,ConvertTo(vbString,r(1)("NAME"))) & IfThenElse(IsNull(r(1)("CODE")),""," (" & ConvertTo(vbString,r(1)("CODE")) & ")")
                Else
                    text = TR("(error: the item is no longer in the database)")
                End If
            Else
                text = TR("(no selection)")
            End If
            %>
            <table class="<%= IfThenElse(EditMode Or Active,"SelectorBarActive","SelectorBar") %>">
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <% If Not ReadOnly Then %>
                    <td nowrap><% btnAddNew.Render %></td>
                        <% 
                        If Id <> 0 Then 
                            %><td nowrap><% btnEdit.Render %></td><%
                        End If
                        %>
                    <% End If %>
                    <td nowrap width="100%"><%= HTMLEncode(Id & ": " & text) %></td>
                    <% If Active Or EditMode Then %>
                        <td nowrap><% btnClose.Render %></td>
                    <% Else %>
                        <td nowrap><% btnOpen.Render %></td>
                    <% End If %>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderBranch(t, nNode)
            If nNode < 1 Then Exit Sub
            Dim currentNode, currentId, I
            Set currentNode = t(nNode)
            currentId = ConvertTo(vbLong,currentNode.Info)
            %>
                <div nowrap style="padding-left: 0px;margin-left: <%= StepPixels %>px">
                    <% 
                        For I = 1 To currentNode.Count
                            btnFolder.Caption = currentNode(I)("NAME")
                            If ConvertTo(vbLong,currentNode(I)("SID")) = SelectedItemId Then
                                btnFolder.CssClass = "TreeItemSelected"
                            Else
                                btnFolder.CssClass = "TreeItem"
                            End If
                            If currentId = currentNode(I)("SID") Then
                                If currentNode(I)("CHILDREN_COUNT") > 0 Then 
                                    btnMinus.RenderValue(currentNode(I)("SID"))
                                Else
                                    btnDot.RenderValue(currentNode(I)("SID"))
                                End If
                                Response.Write "&nbsp;"
                                btnFolder.Src = SysImage("open")
                                btnFolder.RenderValue(currentNode(I)("SID"))
                                Response.Write "<br/>" & vbCrLf
                                RenderBranch t, nNode - 1
                            Else
                                If currentNode(I)("CHILDREN_COUNT") > 0 Then 
                                    btnPlus.RenderValue(currentNode(I)("SID"))
                                Else
                                    btnDot.RenderValue(currentNode(I)("SID"))
                                End If
                                Response.Write "&nbsp;"
                                btnFolder.Src = SysImage("folder")
                                btnFolder.RenderValue(currentNode(I)("SID"))
                                Response.Write "<br/>" & vbCrLf
                            End If
                        Next
                    %>
                </div>
            <%
        End Sub
        Private Sub RenderTree
            Dim t
            Set t = Tree
            %>
            <div <%= StyleAndCssString(PanelCssClass,"text-align: left; overflow-y:auto;overflow-x:auto;width:" & Width & "px;height:" & Height & "px;") %> >
                <% RenderBranch tree, t.Count %>
            </div>
            <%
        End Sub
        Private Sub RenderForm
            %>
            <table class="form">
                <tr>
                    <th class="formCaption" colspan="2"><%= TR("Editing") & " " & IfThenElse(NomenclatureName <> "",NomenclatureName, Nomenclature) %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="2"><% cRights.Render %></th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Caption") %><% vldName.Render %></th>
                    <td nowrap class="formField"><% txtName.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="1"><%= TR("Application code") %></th>
                    <td nowrap class="formField" colspan="1"><% txtCode.Render : vldCode.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel" colspan="1"><%= TR("Parent") %></th>
                    <td nowrap class="formField" colspan="1"><% cParent.Render %></td>
                </tr>
                
                <tr>
                    <td nowrap class="formButtons" colspan="2">
                        <% 
                            btnOk.Render
                            btnCancel.Render
                            Response.Write "&nbsp;"
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
        End Sub
        
    End Class

%>