<%
    ' Select/Show an user data (short version - for now)
    ' NOTES:
    '   The selected user id is kept into the ucUserList
    Const UCUserSel_Mode_Slim = 0
    Const UCUserSel_Mode_List = 1
    Const UCUserSel_Mode_Form = 2
    Class UCUserSel
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS
        Private btnOpen, btnClose
        Private btnEdit, btnAddNew, btnClear
        Private btnLoadFromTheGroup
        
        ' CONTROLS - EDIT FORM
        Private txtLogin, txtEmail, txtPass
        Private vldLogin, vldEmail, vldPass
        Private ucGroup
        Private vldGroup
        Private ckLocked, ckCopyGroupSettings, btnLoadSettingFromGroup, btnClearOwnSettings
        Private lstLevel ' User levels
        Private btnOk, btnCancel, btnDelete
        Private ucUserList
        
        ' FORM ADD ONS
        Private cServices, cAccessDefaults, cNotify, cQuotas, cDeltaQuotas
        
        ' PROPERTIES - PARAMETERS
        Public ReadOnly ' Shows the selection - changes are not allowed - for message reply for instance
        Public Hide
        
        ' TO DO: Declare indicator properties e.g.
        Public Selected
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
            ' On Error Resume Next
            Set ucUserList = New UCSimpleGrid
            ucUserList.Variable("HASMAIL") = 0
            ucUserList.Variable("ADMINONLY") = 0
            ucUserList.ListQuery = "SELECT * FROM USER WHERE NOT DELETED AND "
            ucUserList.CountQuery = "SELECT COUNT(*) FROM USER WHERE NOT DELETED AND "
            ucUserList.ShowFilters = True
            ucUserList.IDField = "ID"
            ucUserList.ButtonsOnLeft = True
            Set ucUserList.Database = Database.DB
            ucUserList.AddField "LOGIN", "Login", True, SimpleGrid_Text, Empty
            ucUserList.AddField "LEVEL", "Level", True, SimpleGrid_Text, Empty
            ucUserList.AddField "EMAIL", "e-mail", True, SimpleGrid_Text, Empty
            ucUserList.SkinId = "UserList"
            
            ' ucUserList.CssClass = "SimpleGrid"
            ucUserList.SelectSkinId = "UserSelect"
            
            Set ucGroup = New UCGroupSel
            
            Set cServices = Create_UCUserServices(Empty)
            cServices.ShowRemove = True
            Set cAccessDefaults = Create_UCAccessDefaults(Empty)
            cAccessDefaults.ShowRemove = True
            Set cNotify = Create_UCNotify(Empty)
            cNotify.ShowRemove = True
            Set cQuotas = New UCQuotas
            cQuotas.ShowRemove = True
            Set cDeltaQuotas = New UCQuotas
            cDeltaQuotas.ShowRemove = True
            cDeltaQuotas.IsDelta = True
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            ' Edit controls
            Set txtLogin = Create_CText(Empty)
            txtLogin.SkinId = "Normal"
            Set vldLogin = Create_TextValidator(txtLogin,32,True,4,32,"^[a-zA-Z0-9\.\-\_]*$")
            vldLogin.Group = Me.Name
            vldLogin.Message = TR("The login may contain latin letters, numbers and the symbols .-_")
            Set txtEmail = Create_CText(Empty)
            txtEmail.SkinId = "Long"
            Set vldEmail = Create_TextValidator(txtEmail,128,True,4,128,"^[a-zA-Z0-9\@\.\-\_]*$")
            vldEmail.Group = Me.Name
            vldEmail.Message = TR("The email address is incorrect or missing.")
            Set txtPass = Create_CPass(Empty)
            txtPass.SkinId = "Normal"
            Set vldPass = Create_TextValidator(txtPass,16,True,4,16,"^[a-zA-Z0-9\@\.\-\_\=\~\$\%\^\&\*\(\)]*$")
            vldPass.Group = Me.Name
            vldPass.Message = TR("The password can contain only letters, numbers and the symbols @.-_=~%^&*()")
            
            Set vldGroup = Create_RequiredValidator(ucGroup,Empty,True)
            vldGroup.Group = Me.Name
            vldGroup.Message = TR("The group is required")
            
            Set ckLocked = Create_CCheckBox(Empty)
            ckLocked.Caption = TR("Locked out")
            Set ckCopyGroupSettings = Create_CCheckBox(Empty)
            ckCopyGroupSettings.Caption = TR("Copy all the settings from the group specified")
            Set lstLevel = Create_CList(Empty)
            lstLevel.AddItem "0",TR("Regular user")
            lstLevel.AddItem "1",TR("Group administrator")
            lstLevel.AddItem "2",TR("Omnigroup (belongs to all groups)")
            lstLevel.AddItem "100", TR("Administrator (superuser)")
            
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PanelEdit"
            btnEdit.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CImageButton(Empty)
            btnAddNew.SkinId = "PanelNew"
            btnAddNew.AsyncPostBack(Me) = True
            Set btnClear = Create_CImageButton(Empty)
            btnClear.SkinId = "PanelClear"
            btnClear.AsyncPostBack(Me) = True
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.ConfirmationText = TR("Do you really want to remove this user account?")
            btnDelete.AsyncPostBack(Me) = True
            
            Set btnLoadSettingFromGroup = Create_CButton(Empty)
            btnLoadSettingFromGroup.Caption = TR("Copy from group")
            btnLoadSettingFromGroup.SkinId = "Red"
            btnLoadSettingFromGroup.ConfirmationText = TR("Do you really want to replace any user specific settings with the group defaults?")
            btnLoadSettingFromGroup.AsyncPostBack(Me) = True
            
            Set btnClearOwnSettings = Create_CButton(Empty)
            btnClearOwnSettings.Caption = TR("Reset")
            btnClearOwnSettings.SkinId = "Red"
            btnClearOwnSettings.ConfirmationText = TR("Do you really want to reset any user specific?")
            btnClearOwnSettings.AsyncPostBack(Me) = True
            
            ClientScripts.EnableAsyncLibrary
            
            ' If Err.Number <> 0 Then
            '    Response.Write "ERROR: " & Err.Description & "<hr/>"
            ' End If
            CssClass = "FormControl"
        End Sub
        
        ' Public Function Load(uid)
        ' End Function
        
        Public Function InitialFormState
            cServices.Active = False
            cAccessDefaults.Active = False
            cNotify.Active = False
            cQuotas.Active = False
            cDeltaQuotas.Active = False
        End Function
        
        Sub ProcessPage
            Dim r, sid, newId, params, oUser
            
            If Mode = UCUserSel_Mode_Form Then
                If btnOk.Clicked And IsAdmin Then
                    If Validate(Me.Name) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                        'Err.Clear
                            Database.FailureValue(Me,"Id") = Id
                            
                            If Id = 0 Then
                                Set oUser = RegisterNewUser(NullConvertTo(vbString, txtLogin.Value), _
                                                            NullConvertTo(vbString, txtPass.Value), _
                                                            NullConvertTo(vbString, txtEmail.Value), _
                                                            NullConvertTo(vbLong, lstLevel.SelectedValue), _
                                                            NullConvertTo(vbLong, ucGroup.Id))
                                If ckCopyGroupSettings.Checked Then
                                    oUser.InitFromGroup
                                End If
                                Id = oUser.Id
                            Else
                                Database.DB.VExecute "UPDATE USER SET LOGIN=$LOGIN, [PASS]=$PASS, [LEVEL]=$LEVEL, EMAIL=$EMAIL, GROUP_ID=$GROUP_ID, " & _
                                                     "FAILURES=(CASE WHEN $LOCKED THEN 10 ELSE 0 END) WHERE ID=$ID", 1, 0, _
                                                        NullConvertTo(vbString, txtLogin.Value), _
                                                        NullConvertTo(vbString, txtPass.Value), _
                                                        NullConvertTo(vbLong, lstLevel.SelectedValue), _
                                                        NullConvertTo(vbString, txtEmail.Value), _
                                                        ucGroup.Id, _
                                                        ConvertTo(vbLong, ckLocked.Checked), _
                                                        Id
                            End If
                            If Err.Number <> 0 Then Database.CancelTransaction Err.Description
                            If Database.CompleteTransaction Then
                                Mode = UCUserSel_Mode_Slim
                                Selected = True
                            End If
                        End If
                    Else
                        Database.InvalidateTransaction ' End processing if the validation fails
                    End If
                ElseIf btnCancel.Clicked Or btnOpen.Clicked Or btnClose.Clicked Then
                    Mode = UCUserSel_Mode_Slim
                ElseIf btnDelete.Clicked Then
                    If Database.BeginTransaction Then
                    On Error Resume Next
                    Err.Clear
                        Database.FailureValue(Me,"Id") = Id
                        Database.DB.VExecute "UPDATE USER SET DELETED=-1 WHERE ID=$USER_ID", 1, 0, Id
                        Id = 0
                        If Database.CompleteTransaction Then
                            Mode = UCUserSel_Mode_Slim
                            Selected = True
                        End If
                        On Error Goto 0
                    End If
                ElseIf btnLoadSettingFromGroup.Clicked And IsAdmin Then
                    Set oUser = New CUser
                    Set oUser.Database = Database
                    If oUser.Load(Id) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            oUser.ClearSpecificSettings
                            oUser.InitFromGroup
                            If Database.CompleteTransaction Then
                                InitialFormState
                                GlobalInfoMessage = TR("A copy of the group default settings has been assigned to this user and his/her advanced settings can be now managed separately from the group.")
                            End If
                        End If
                    End If
                ElseIf btnClearOwnSettings.Clicked And IsAdmin Then
                    Set oUser = New CUser
                    Set oUser.Database = Database
                    If oUser.Load(Id) Then
                        If Database.BeginTransaction Then
                        On Error Resume Next
                            oUser.ClearSpecificSettings
                            If Database.CompleteTransaction Then
                                InitialFormState
                                GlobalInfoMessage = TR("Any existing user specific advanced settings has been removed and will be now inherted from the user's group.")
                            End If
                        End If
                    End If
                End If
            ElseIf Mode = UCUserSel_Mode_List Then
                If btnCancel.Clicked Or btnOpen.Clicked Or btnClose.Clicked Then
                    Mode = UCUserSel_Mode_Slim
                    ucUserList.Active = False
                ElseIf ucUserList.Selected Then
                    Id = ucUserList.Id
                    ucUserList.Active = False
                    Mode = UCUserSel_Mode_Slim
                    OvertakePartialRender Me
                    Selected = True
                End If
            ElseIf btnClear.Clicked Then
                Id = 0
                ucUserList.Active = False
                Mode = UCUserSel_Mode_Slim
                Selected = True
            Else
                ' In slim mode
                If btnOpen.Clicked Then
                    Mode = UCUserSel_Mode_List
                    InitialFormState
                    ucUserList.Active = True
                ElseIf IsAdmin And btnAddNew.Clicked Then
                    Id = 0
                    Mode = UCUserSel_Mode_Form
                    txtLogin.Value = ""
                    txtPass.Value = ""
                    lstLevel.SelectedValue = 0
                    txtEmail.Value = ""
                    ucGroup.Id = 0
                    ckLocked.Checked = False
                    InitialFormState
                ElseIf IsAdmin And btnEdit.Clicked Then
                    Set r = Database.dB.VExecute("SELECT U.*, (FAILURES NOT NULL AND FAILURES >= 5 AND OleDateDiff('m',ATTEMPTED,OleLocalTime()) <= 5) AS LOCKEDOUT FROM USER U " & _
                                                 " WHERE U.ID=$ID",1,1,Id)
                    If r.Count > 0 Then
                        Set r = r(1)
                        txtLogin.Value = ConvertTo(vbString, r("LOGIN"))
                        txtPass.Value = ConvertTo(vbString, r("PASS"))
                        lstLevel.SelectedValue = ConvertTo(vbLong, r("LEVEL"))
                        txtEmail.Value = ConvertTo(vbString, r("EMAIL"))
                        ucGroup.Id = ConvertTo(vbLong, r("GROUP_ID"))
                        ' Check if it is locked
                        ckLocked.Checked = ConvertTo(vbBoolean, r("LOCKEDOUT"))
                        InitialFormState
                        Mode = UCUserSel_Mode_Form
                    End If
                End If
            End If
        End Sub
        
        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                Id = ConvertTo(vbLong, Failure("Id"))
            End If
        End Function
        
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"U"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "U", ConvertTo(vbLong,v)
            cServices.Id = v
            cAccessDefaults.Id = v
            cNotify.Id = v
            cQuotas.ParentId = v
            cDeltaQuotas.ParentId = v
        End Property
        Public Property Get Mode
            Mode = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"M"))
        End Property
        Public Property Let Mode(v)
            Dim m
            m = ConvertTo(vbLong,v)
            If m > UCUserSel_Mode_List Then
                If Not IsAdmin Or ReadOnly Then Exit Property
            End If
            PostVariables.SetCtlVar Me, "M", m
        End Property
        
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCUserSel" 
        End Property
        
        Public Sub Render
            %><div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div><%
        End Sub
        Public Sub RenderPartial
            If Hide Then Exit Sub
            If Mode = UCUserSel_Mode_Form Then
                RenderSlim
                RenderForm
            ElseIf Mode = UCUserSel_Mode_List Then
                RenderSlim
                ucUserList.Render
            Else
                RenderSlim
            End If
            
        End Sub
        
        Private Sub RenderSlim
            Dim r, sUser
            Set r = Database.DB.VExecute("SELECT * FROM USER WHERE ID=$id",1,1,Id)
            If r.Count > 0 Then
                sUser = r(1)("LOGIN")
            Else
                sUser = TR("(not selected)")
            End If
            %>
            <table class="SelectorBar" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <% If IsAdmin And Mode = UCUserSel_Mode_Slim Then %>
                        <td nowrap><% btnAddNew.Render %></td>
                        <% 
                            If Id <> 0 Then 
                                %><td nowrap class="border"><img class="border" src="<%= SysImage("pixel") %>" alt=""/></td><%
                                %><td nowrap><% btnEdit.Render %></td><%
                            End If
                        %>
                    <% End If %>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Mode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%= HTMLEncode(sUser) %></td>
                    <td nowrap><% 
                        If Mode = UCUserSel_Mode_Slim Then
                            If Not ReadOnly Then btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                        If Id <> 0 And Not ReadOnly Then btnClear.Render
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
        Private Sub RenderForm
            If Not IsAdmin Or ReadOnly Then Exit Sub
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="formCaption" colspan="2"><%= TR("User account") %></th>
                </tr>
                <tr>
                    <td colspan="2" class="formButtons">
                        <%
                            btnOk.Render
                            btnCancel.Render
                            If Id <> 0 Then btnDelete.Render
                        %>
                    </th>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Login") %></th>
                    <td class="formField"><% txtLogin.Render : vldLogin.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Password") %></th>
                    <td class="formField"><% txtPass.Render : vldPass.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Email") %></th>
                    <td class="formField"><% txtEmail.Render : vldEmail.Render %></td>
                </tr>
                <tr>
                    <th class="formLabel" nowrap><%= TR("Level") %></th>
                    <td class="formField"><% lstLevel.Render %></td>
                </tr>
                <tr>
                    <th class="formLabel" nowrap><%= TR("Group") %></th>
                    <td class="formField"><% ucGroup.Render : vldGroup.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formCaption" colspan="2"><%= TR("Additional settings") %></th>
                </tr>
                <% If Id <> 0 Then %>
                    <tr>
                        <th class="formLabel" nowrap>&nbsp;</th>
                        <td class="formField"><% ckLocked.Render %></td>
                    </tr>
                    <tr>
                        <th class="formLabel" nowrap>&nbsp;</th>
                        <td class="formField"><% btnLoadSettingFromGroup.Render : btnClearOwnSettings.Render %></td>
                    </tr>
                    <tr>
                        <td class="formField" colspan="2">
                            <% cServices.Render %>
                            <% cAccessDefaults.Render %>
                            <% cNotify.Render %>
                            <% cQuotas.Render %>
                            <% cDeltaQuotas.Render %>
                        </td>
                    </tr>
                <% Else %>
                    <tr>
                        <th class="formLabel" nowrap>&nbsp;</th>
                        <td class="formField"><% ckCopyGroupSettings.Render %><br/>
                            <% RenderStaticTexts "HELP", "USERSETTINGS", False %>
                        </td>
                    </tr>
                <% End If %>
            </table>
            <%
        End Sub
        
    
    End Class

%>