<%
    ' Select/Show an user - select only
    
    Class UCUserSelector
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' CONTROLS
        Private btnOpen, btnClose
        Private btnClear
        
        ' CONTROLS - EDIT FORM
        Private ucUserList
        
        ' FORM ADD ONS
        
        ' PROPERTIES - PARAMETERS
        Public ReadOnly ' Shows the selection - changes are not allowed - for message reply for instance
        Public Hide
        
        ' TO DO: Declare indicator properties e.g.
        Public Selected
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Class_Initialize
            ' On Error Resume Next
            Set ucUserList = New UCSimpleGrid
            ucUserList.Variable("HASMAIL") = 0
            ucUserList.Variable("ADMINONLY") = 0
            ucUserList.ListQuery = "SELECT * FROM USER WHERE NOT DELETED AND "
            ucUserList.CountQuery = "SELECT COUNT(*) FROM USER WHERE NOT DELETED AND "
            ucUserList.ShowFilters = True
            ucUserList.IDField = "ID"
            ucUserList.ButtonsOnLeft = True
            Set ucUserList.Database = Database.DB
            ucUserList.AddField "LOGIN", "Login", True, SimpleGrid_Text, Empty
            ucUserList.AddField "LEVEL", "Level", True, SimpleGrid_Text, Empty
            ucUserList.AddField "EMAIL", "e-mail", True, SimpleGrid_Text, Empty
            ucUserList.SkinId = "UserList"
            
            ' ucUserList.CssClass = "SimpleGrid"
            ucUserList.SelectSkinId = "UserSelect"
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            Set btnClear = Create_CImageButton(Empty)
            btnClear.SkinId = "PanelClear"
            btnClear.AsyncPostBack(Me) = True
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            ClientScripts.EnableAsyncLibrary
            
            ' If Err.Number <> 0 Then
            '    Response.Write "ERROR: " & Err.Description & "<hr/>"
            ' End If
            CssClass = "FormControl"
        End Sub
        
        ' Public Function Load(uid)
        ' End Function
        
        Sub ProcessPage
            If btnClose.Clicked Or btnOpen.Clicked Then
                If ReadOnly Then 
                    Active = False
                Else
                    Active = Not Active
                End If
            ElseIf btnClear.Clicked Then
                Id = 0
                Active = False
            ElseIf ucUserList.Selected Then
                Id = ucUserList.Id
                Active = False
                OvertakePartialRender Me
                Selected = True
            End If
        End Sub
        
        
        ' POST VARIABLES
        Public Property Get Id
            Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"U"))
        End Property
        Public Property Let Id(v)
            PostVariables.SetCtlVar Me, "U", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ucUserList.Active
        End Property
        Public Property Let Active(v)
            ucUserList.Active = v
        End Property
        
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        Public Property Let Value(v)
            Id = v
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCUserSelector" 
        End Property
        
        Public Sub Render
            %><div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div><%
        End Sub
        Public Sub RenderPartial
            If Hide Then Exit Sub
            RenderSlim
            If Active Then
                ucUserList.Render
            End If
            
        End Sub
        
        Private Sub RenderSlim
            Dim r, sUser
            Set r = Database.DB.VExecute("SELECT * FROM USER WHERE ID=$id",1,1,Id)
            If r.Count > 0 Then
                sUser = r(1)("LOGIN")
            Else
                sUser = TR("(not selected)")
            End If
            %>
            <table class="SelectorBar" >
                <tr>
                    <td class="leftSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                    <td nowrap style="width: 100%;cursor:pointer;" onclick="<%= IfThenElse(Mode > 0,btnClose.GetAsyncPostBack(Me,0),btnOpen.GetAsyncPostBack(Me,0)) %>"><%= HTMLEncode(sUser) %></td>
                    <td nowrap><% 
                        If Mode = UCUserSel_Mode_Slim Then
                            If Not ReadOnly Then btnOpen.Render
                        Else
                            btnClose.Render
                        End If
                        If Id <> 0 And Not ReadOnly Then btnClear.Render
                    %></td>
                    <td class="rightSide"><img class="pixel" src="<%= SysImage("pixel") %>" alt=""/></td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class

%>