<%
    ' Template for User Control (composite control containing other controls)
    Class UCVerticalTabMenu
        
        ' User controls should not preserve state in the query string
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' Controls and other stuff
        Private Items
        Public  ActiveCssClass
        Public  ActiveImage
        Public  InactiveImage
        
        Private btnItem
        Public  Clicked
        Public  ClickedItem
        
        Sub Class_Initialize
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False
            
            Set Items = CreateCollection
            ActiveImage = SysImage("open")
            InactiveImage = SysImage("folder")
            
            Clicked = False
            ClickedItem = 0
            
            Set btnItem = Create_CImageButton(Empty)
        End Sub
        
        Sub ProcessPage
            If btnItem.Clicked Then 
                Clicked = True
                ClickedItem = ConvertTo(vbLong,btnItem.Value)
            End If
        End Sub
        
        Function AddItem(url,capt,aicon,nicon)
            Dim o, a, n
            Set o = New UCTabMenuItem
            If IsEmpty(aicon) Then a = ActiveImage Else a = aicon
            If IsEmpty(nicon) Then n = InactiveImage Else n = nicon
            o.Init url,capt,a,n
            Items.Add "", o
        End Function
        
        ' Returns False on success! To indicate no page processing is needed
        Function Redirect
            If Clicked Then
                ASPRedirect = Items(ClickedItem).Url
                Redirect = False
            Else
                Redirect = True
            End If
        End Function
        
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class
            ClassType = "UCVerticalTabMenu" 
        End Property
        
        Public Sub Render
            Dim I
            For I = 1 To Items.Count
                If UCase(Items(I).Url) <> UCase(Self) Then
                    btnItem.Caption = Items(I).Caption
                    btnItem.Src = Items(I).InactiveIcon
                    %><div class="<%= CssClass %>"><% btnItem.RenderValue(I) %></div><%
                Else
                    %><div class="<%= ActiveCssClass %>"><img src="<%= Items(I).ActiveIcon %>"> <strong><%= HTMLEncode(Items(I).Caption) %></strong></div><%
                End If
            Next
            
        End Sub
    
    End Class
    
    ' Helper class
    Class UCTabMenuItem
        Public ActiveIcon,InactiveIcon
        Public Caption
        Public Url
        Sub Class_Initialize
            ActiveIcon = SysImage("")
            InactiveIcon = SysImage("")
        End Sub
        Sub Init(u,capt,aimg,nimg)
            ActiveIcon = aimg
            InactiveIcon = nimg
            Caption = capt
            Url = u 
        End Sub
    End Class
    
%>