<%

    Class UCViewCard ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        Public ShowEdit, ShowPrint, ShowSelect, ShowClose
        
        ' CONTROLS
        Private LanguageSwitch, ucMap
        Private btnEdit, btnPrintView, btnSelect, btnClose
        
        ' INDICATORS
        Public Closed, Selected, Print, Edit
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            Set ucMap = New UCShowMap
            Set LanguageSwitch = New UCLanguage
            LanguageSwitch.AsyncPostBack(Me) = True
            LanguageSwitch.Label = "&nbsp;"
            LanguageSwitch.Style = "width:100%;"
            LanguageSwitch.Language = PageUILanguage ' TEMORARY
            
            Set btnEdit = Create_CButton(Empty)
            btnEdit.Caption = TR("Edit")
            btnEdit.SkinId = "Yellow"
            Set btnPrintView = Create_CButton(Empty)
            btnPrintView.Caption = TR("Print view")
            btnPrintView.SkinId = "Blue"
            Set btnSelect = Create_CButton(Empty)
            btnSelect.Caption = TR("Select")
            btnSelect.SkinId = "Green"
            Set btnClose = Create_CButton(Empty)
            btnClose.Caption = TR("Close")
            btnClose.SkinId = "Orange"
            
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Sub Show(cid)
            Id = cid
            Active = True
        End Sub
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If btnEdit.Clicked Then
                    Edit = True
                ElseIf btnPrintView.Clicked Then
                    Print = True
                ElseIf btnSelect.Clicked Then
                    Selected = True
                ElseIf btnClose.Clicked Then
                    Closed = True
                    Active = False
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Id
           Id = ConvertTo(vbLong,PostVariables.GetCtlVar(Me,"I"))
        End Property
        Public Property Let Id(v)
           PostVariables.SetCtlVar Me, "I", ConvertTo(vbLong,v)
        End Property
        Public Property Get Active
            Active = ConvertTo(vbBoolean,PostVariables.GetCtlVar(Me,"A"))
        End Property
        Public Property Let Active(v)
            PostVariables.SetCtlVar Me, "A", ConvertTo(vbBoolean,v)
        End Property
        
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
            If Id <> 0 Then Value = Id
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UCViewCard" 
        End Property
        
        ' TO DO: If you are not going to use PreRender phase you can safely remove this method
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL

        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            If Active Then RenderCard
        End Sub
        Public Sub RenderCard
            Dim r, rec, I, rI, imgSrc
            Set r = Database.DB.VExecute("SELECT * FROM CARD WHERE SID=$SID AND LANGUAGE=$LANGUAGE AND ($INCLUDEDELETED OR NOT DELETED) AND " & SQLReadRights,1,1,_
                                        Id, LanguageSwitch.Language,ConvertTo(vbLong,IsAdmin))
            If r.Count > 0 Then
                Set rec = r(1)
                %>
                <table class="viewCard">
                    <tr>
                        <th class="viewCardCaptionMain" colspan="4">
                            <%= TR("Card") & " " & HTMLEncode(rec("CARD_NUMBER")) %>
                        </th>
                    </tr>
                    <tr>
                        <td class="viewCardObject"><%= TR("Object") & ": " & HTMLEncode(rec("OBJECT_NUMBER")) %></td>
                        <td colspan="3" class="viewCardButtons">
                            <%
                            If ShowEdit Then btnEdit.Render
                            If ShowPrint Then btnPrintView.Render
                            If ShowSelect Then btnSelect.Render
                            If ShowClose Then btnClose.Render
                            %>
                        </td>
                    </tr>
                    <!-- Main -->
                    <tr>
                        <td valign="top" nowrap class="viewCardLabel"><%= TR("Location") %></td>
                        <td valign="top" class="viewCardField" colspan="3"><%= HTMLEncode(GetLocation(rec("LOCATION_SID")).FullName) %></td>
                    </tr>
                    <tr>
                        <td valign="top" nowrap class="viewCardLabel"><%= TR("Location description") %></td>
                        <td valign="top" class="viewCardField" colspan="3"><%= HTMLEncode(rec("PLACE_ADDRESS")) %></td>
                    <tr>
                    <tr>
                        <td valign="top" nowrap class="viewCardLabel"><%= TR("Ownership") %></td>
                        <td valign="top" class="viewCardField" colspan="3"><%= Nomenclature("OWNERSHIP",rec("OWNERSHIP_SID")).Name %></td>
                    <tr>
                    <tr>
                        <td valign="top" nowrap class="viewCardLabel"><%= TR("Terrain usage") %></td>
                        <td valign="top" class="viewCardField" colspan="3"><%= Nomenclature("TERRAINUSAGE",rec("TERRAINUSAGE_SID")).Name %></td>
                    <tr>
                    
                    <!-- Geography -->    
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Localization and Geography") %></td>
                    <tr>
                    <tr>
                        <td valign="top" nowrap class="viewCardLabel"><%= TR("Localization") %></td>
                        <td valign="top" class="viewCardField" colspan="3"><%= HTMLEncode(rec("RELATIVE_LOCALIZATION")) %></td>
                    <tr>
                    <% If Not IsNull(rec("MAP_IMAGE_SID")) Then %>
                        <tr>
                            <td valign="top" nowrap class="viewCardCaption" colspan="4"><%= TR("Map of the object location") %></td>
                        <tr>
                        <tr>
                            <td valign="top" nowrap class="viewCardImage" colspan="4">
                                <img src="<%= VirtPath("image.asp") & "?image=" & ConvertTo(vbLong,rec("MAP_IMAGE_SID")) %>" alt="" border="0" />
                            </td>
                        <tr>
                    <% End If %>
                    <% If ConvertTo(vbLong,rec("MAP_SCALE")) <> 0 Or ConvertTo(vbLong,rec("MAP_CREATOR_PERSON_SID")) <> 0 Then %>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Map scale") %></td>
                        <td class="viewCardField" colspan="1"><%= HTMLEncode("1:" & ConvertTo(vbLong,rec("MAP_SCALE"))) %></td>
                        <td class="viewCardLabel"><%= TR("Map date") %></td>
                        <td class="viewCardField" colspan="1"><%= FormatDateString(rec("MAP_DATE"),PageUIDateFormat) %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Map creator") %></td>
                        <td class="viewCardField" colspan="3"><%= GetPerson(rec("MAP_CREATOR_PERSON_SID"),LanguageSwitch.Language).IconAndName %></td>
                    </tr>
                    <% End If %>
                    <%
                    If Not IsNull(rec("LATITUDE")) And Not IsNull(rec("LONGITUDE")) Then
                        ucMap.Latitude = rec("LATITUDE")
                        ucMap.Longitude = rec("LONGITUDE")
                        %>
                        <tr>
                            <td class="viewCardImage" colspan="5"><% ucMap.Render %></td>
                        </tr>
                        <%
                    End If
                    %>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Geomorphology") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("GEOFORM",rec("GEOFORM_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Orography") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("OROGRAPHY",rec("OROGRAPHY_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Hydrography") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("HYDROGRAPHY",rec("HYDROGRAPHY_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Elevation") %></td>
                        <td class="viewCardField" colspan="3"><%
                             If Not IsNull(rec("ELEVATION2")) Then
                                Response.Write TR("Between") & " " & ConvertTo(vbLong,rec("ELEVATION")) & " " & TR("and") & " " & ConvertTo(vbLong,rec("ELEVATION2")) & " " & TR("meters")
                             Else
                                Response.Write ConvertTo(vbLong,rec("ELEVATION")) & " " & TR("meters")
                             End If
                        %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Soil") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("SOIL_TYPE",rec("SOIL_TYPE_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Exposition") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("EXPOSITION",rec("EXPOSITION_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Accessibility") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("ACCESSIBILITY",rec("ACCESSIBILITY_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Observability") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("OBSERVABILITY",rec("OBSERVABILITY_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Slope") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("SLOPE",rec("SLOPE_SID")).Name %></td>
                    </tr>
                    
                    <!-- Information -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Information") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Archive information") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("ARCHIVE_INFO")) %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Museum information") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("MUSEUM_INFO")) %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Publications") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("PUBLICATIONS_INFO")) %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Other information") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("OTHER_INFO")) %></td>
                    </tr>
                    
                    <!-- Specifics -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Characteristics and specifics") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Area") %></td>
                        <td class="viewCardField" colspan="3"><%= FormatDouble(rec("AREA"),2) & " " & TR("dca") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3">
                            <table class="viewCardInner">
                            <tr>
                                <td class="viewCardLabel" colspan="2"><%= TR("Facilities") %></td>
                                <td class="viewCardLabel" colspan="2"><%= TR("Findings") %></td>
                            </tr>
                            <tr>
                                <td class="viewCardField" colspan="2"><%
                                    Set rI = Database.DB.VExecute("SELECT R.*, N.NAME AS NAME, N.CODE AS CODE FROM CARD_FACILITY_REL R, FACILITY " & _
                                                " N WHERE R.CARD_SID=$CardId AND R.LANGUAGE=$LANGUAGE AND N.LANGUAGE=$LANGUAGE AND N.SID=R.FACILITY_SID " & _
                                                " ORDER BY NAME", 1, 0, NullConvertTo(vbLong, rec("SID")), LAnguageSwitch.Language)
                                    For I = 1 To rI.Count
                                        ' Response.Write "<b>" & HTMLEncode(rI(I)("NAME")) & "</b><br/>"
                                        Response.Write HTMLEncode(rI(I)("NAME")) & "<br/>"
                                        If Not IsNull(rI(I)("COMMENTS")) Then
                                            Response.Write "<em>" & HTMLEncode(rI(I)("COMMENTS")) & "</em><br/>"
                                        End If
                                    Next
                                %></td>
                                <td class="viewCardField" colspan="2"><%
                                    Set rI = Database.DB.VExecute("SELECT R.*, N.NAME AS NAME, N.CODE AS CODE FROM CARD_FINDING_REL R, FINDING " & _
                                                " N WHERE R.CARD_SID=$CardId AND R.LANGUAGE=$LANGUAGE AND N.LANGUAGE=$LANGUAGE AND N.SID=R.FINDING_SID " & _
                                                " ORDER BY NAME", 1, 0, NullConvertTo(vbLong, rec("SID")), LAnguageSwitch.Language)
                                    For I = 1 To rI.Count
                                        ' Response.Write "<b>" & HTMLEncode(rI(I)("NAME")) & "</b><br/>"
                                        Response.Write HTMLEncode(rI(I)("NAME")) & "<br/>"
                                        If Not IsNull(rI(I)("COMMENTS")) Then
                                            Response.Write "<em>" & HTMLEncode(rI(I)("COMMENTS")) & "</em><br/>"
                                        End If
                                    Next 
                                %></td>
                            </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Findings concentration") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("CONCENTRATION",rec("CONCENTRATION_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Grouping") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("GROUPING",rec("GROUPING_SID")).Name %></td>
                    </tr>
                    <% If Len(ConvertTo(vbString,rec("SPECIFICS"))) > 0 Then %>
                        <tr>
                            <td class="viewCardLabel" colspan="4"><%= TR("Specifics") %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("SPECIFICS")) %></td>
                        </tr>
                    <% End If %>
                    <% If Not IsNull(rec("PLOT_IMAGE_SID")) Then %>
                        <tr>
                            <td valign="top" nowrap class="viewCardCaption" colspan="4"><%= TR("Plot") %></td>
                        <tr>
                        <tr>
                            <td valign="top" nowrap class="viewCardImage" colspan="4">
                                <img src="<%= VirtPath("image.asp") & "?image=" & ConvertTo(vbLong,rec("PLOT_IMAGE_SID")) %>" alt="" border="0" />
                            </td>
                        <tr>
                    <% End If %>
                    <% If ConvertTo(vbLong,rec("PLOT_SCALE")) <> 0 Or ConvertTo(vbLong,rec("PLOT_CREATOR_PERSON_SID")) <> 0 Then %>
                        <tr>
                            <td class="viewCardLabel"><%= TR("Plot scale") %></td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode("1:" & ConvertTo(vbLong,rec("PLOT_SCALE"))) %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel"><%= TR("Plot creator") %></td>
                            <td class="viewCardField" colspan="1"><%= GetPerson(rec("PLOT_CREATOR_PERSON_SID"),LanguageSwitch.Language).IconAndName %></td>
                            <td class="viewCardLabel"><%= TR("Plot date") %></td>
                            <td class="viewCardField" colspan="1"><%= FormatDateString(rec("PLOT_DATE"),PageUIDateFormat) %></td>
                        </tr>
                    <% End If %>
                        
                    <!-- Type and chronology -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Type and chronology") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3">
                            <table class="viewCardInner">
                                <tr>
                                    <td class="viewCardLabel" colspan="2"><%= TR("Type") %></td>
                                    <td class="viewCardLabel" colspan="2"><%= TR("Chronology") %></td>
                                </tr>
                                <%
                                    Set rI = Database.DB.VExecute("SELECT R.*, N1.NAME AS NAME, N1.CODE AS CODE, N2.NAME AS NAME2, N2.CODE AS CODE2 " & _
                                                    "FROM CARD_TYPE_CHRONOLOGY_REL R, TYPE N1, CHRONOLOGY N2 WHERE R.CARD_SID=$CardId AND R.LANGUAGE=$LANGUAGE AND " & _
                                                    " R.TYPE_SID=N1.SID AND R.CHRONOLOGY_SID=N2.SID AND N1.LANGUAGE=$LANGUAGE AND N2.LANGUAGE=$LANGUAGE " & _
                                                    " ORDER BY N1.NAME, N2.NAME", 1, 0, NullConvertTo(vbLong, rec("SID")), LanguageSwitch.Language)
                                    For I = 1 To rI.Count
                                        %>
                                        <tr>
                                            <td class="viewCardField" colspan="2"><%= HTMLEncode(rI(I)("NAME")) %></td>
                                            <td class="viewCardField" colspan="2"><%= HTMLEncode(rI(I)("NAME2")) %></td>
                                        </tr>
                                        <%
                                        If Not IsNull(rI(I)("COMMENTS")) Then
                                        %>
                                        <tr>
                                            <td class="viewCardField" colspan="1">&nbsp;</td>
                                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rI(I)("COMMENTS")) %></td>
                                        </tr>
                                        <%
                                        End If
                                    Next
                                %>
                            </table>
                        </td>
                    </tr>
                    <% If Len(ConvertTo(vbString,rec("BELONG_COMPLEX"))) > 0 Then %>
                        <tr>
                            <td class="viewCardLabel" colspan="4"><%= TR("Belongs to complex") %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("BELONG_COMPLEX")) %></td>
                        </tr>
                    <% End If %>
                    <% If Len(ConvertTo(vbString,rec("BELONG_SYSTEM"))) > 0 Then %>
                        <tr>
                            <td class="viewCardLabel" colspan="4"><%= TR("Belongs to system") %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("BELONG_SYSTEM")) %></td>
                        </tr>
                    <% End If %>
                    <% If Len(ConvertTo(vbString,rec("BELONG_CULTURE"))) > 0 Then %>
                        <tr>
                            <td class="viewCardLabel" colspan="4"><%= TR("Belongs to culture") %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("BELONG_CULTURE")) %></td>
                        </tr>
                    <% End If %>
                        
                    <!-- History -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("History") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("History of the research") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("RESEARCH_HISTORY")) %></td>
                    </tr>
                        
                    <!-- Status -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Status") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Protection") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("PROTECTION",rec("PROTECTION_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Importance") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("IMPORTANCE",rec("IMPORTANCE_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Guard") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("GUARD",rec("GUARD_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Environment") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("ENVIRONMENT",rec("ENVIRONMENT_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Preservation") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("PRESERVATION",rec("PRESERVATION_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Socialization") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("SOCIALIZATION",rec("SOCIALIZATION_SID")).Name %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel"><%= TR("Usage regime") %></td>
                        <td class="viewCardField" colspan="3"><%= Nomenclature("USAGEREGIME",rec("USAGEREGIME_SID")).Name %></td>
                    </tr>
                    <% If Len(ConvertTo(vbString,rec("COMMENTS"))) > 0 Then %>
                        <tr>
                            <td class="viewCardLabel" colspan="4"><%= TR("Other information and comments") %></td>
                        </tr>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3"><%= HTMLEncode(rec("COMMENTS")) %></td>
                        </tr>
                    <% End If %>
                        
                    <!-- Gallery -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Additional materials") %></td>
                    <tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Attached photos") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%
                            Set rI = Database.DB.VExecute("SELECT I.* FROM IMAGE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG, I.NAME", _
                                             1, 0, NullConvertTo(vbLong, rec("SID")), LanguageSwitch.Language)
                            %>
                            <table class="<%= CssClassImagesVertical %>">
                                <% 
                                For I = 1 To rI.Count
                                    imgSrc = VirtPath("/image.asp") & "?image=" & rI(I)("SID")
                                    %>
                                    <tr>
                                        <td class="viewCardIcon" style="width:<%= ThumbNailSizeIconSmall %>px;">
                                            <a href="<%= imgSrc %>" target="_blank"><img src="<%= imgSrc & "&th=4" %>" border="0" width="<%= ThumbNailSizeIconSmall %>" 
                                                alt="<%= HTMLEncode(rI(I)("CAPTION")) %>" /></a>
                                                
                                        </td>
                                        <td class="viewCardField" style="width:100%;">
                                            <% 
                                            Response.Write "<strong>" & HTMLEncode(rI(I)("NAME")) & "</strong>"
                                            Response.Write "&nbsp;(" & ConvertTo(vbString,rI(I)("WIDTH")) & " x " & ConvertTo(vbString,rI(I)("HEIGHT")) & ")<br/>"
                                            Response.Write TR("Modified") & ": <em>" & FormatDateString(rI(I)("MODIFIED"), PageUIDateTimeFormat) & "</em>&nbsp;"
                                            Response.Write TR("Created") & ": <em>" & FormatDateString(rI(I)("CREATED"), PageUIDateTimeFormat) & "</em>"
                                            Response.Write Nomenclature("IMAGE_TYPE", rI(I)("IMAGE_TYPE_SID")).Name
                                            %>
                                        </td>
                                    </tr>
                                    <%
                                Next
                                %>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Attached files") %></td>
                    </tr>
                    <tr>
                        <td class="viewCardLabel">&nbsp;</td>
                        <td class="viewCardField" colspan="3"><%
                            Set rI = Database.DB.VExecute("SELECT I.* FROM FILE I, RELATION R WHERE I.SID=R.TARGET_SID AND R.OBJECT_SID=$OBJECT_SID AND " & _
                                             " NOT I.DELETED AND I.LANGUAGE=$LANGUAGE AND " & SQLReadRightsTable("I") & " ORDER BY R.ORDER_TAG, I.FILE_NAME", _
                                             1, 0, NullConvertTo(vbLong, rec("SID")), LanguageSwitch.Language)
                            %>
                            <table class="<%= CssClassImagesVertical %>">
                                <% 
                                For I = 1 To rI.Count
                                    imgSrc = VirtPath("/file.asp") & "?file=" & rI(I)("SID")
                                    %>
                                    <tr>
                                        <td class="viewCardIcon" style="width:16px;">
                                            <a href="<%= imgSrc %>" target="_blank"><img src="<%= FileIcon(GetFileExt(rI(I)("FILE_NAME"))) %>" border="0" width="16" 
                                                alt="<%= HTMLEncode(rI(I)("CAPTION")) %>" /></a>
                                        </td>
                                        <td class="viewCardField" style="width:100%;">
                                            <a href="<%= imgSrc %>" target="_blank"><strong><%= HTMLEncode(Ellipsis(rI(I)("FILE_NAME"),80)) %></strong></a><br/>
                                            <%= FileSizeString(rec("SIZE")) %><br/>
                                            <%= TR("Modified") %><%= ": <em>" & FormatDateString(rI(I)("MODIFIED"), PageUIDateTimeFormat) & "</em>&nbsp;" %>
                                            <%= TR("Created") %><%= ": <em>" & FormatDateString(rI(I)("MODIFIED"), PageUIDateTimeFormat) & "</em>&nbsp;" %><br/>
                                            <em><%= HTMLEncode(rI(I)("CAPTION")) %></em>
                                        </td>
                                    </tr>
                                    <%
                                Next
                                %>
                            </table>
                        </td>
                    </tr>
                        
                    <!-- Status -->
                    <tr>
                        <td valign="top" class="viewCardDelimiter" colspan="4"><%= TR("Status") %></td>
                    <tr>
                    <% If Not IsNull(rec("CREATOR_PERSON_ID")) Then %>
                        <tr>
                            <td class="viewCardLabel"><%= TR("Author") %></td>
                            <td class="viewCardField" colspan="3"><%= GetPerson(rec("CREATOR_PERSON_SID"),LanguageSwitch.Language).IconAndName %></td>
                        </tr>
                    <% End If %>
                    <% If Not IsNull(rec("CHECKED_PERSON_SID")) Then %>
                        <tr>
                            <td class="viewCardLabel"><%= TR("Checked by") %></td>
                            <td class="viewCardField" colspan="3"><%= GetPerson(rec("CHECKED_PERSON_SID"),LanguageSwitch.Language).IconAndName %></td>
                        </tr>
                    <% End If %>
                    <tr>
                        <td class="viewCardLabel" colspan="4"><%= TR("Status reports") %></td>
                    </tr>
                    <%
                        set rI = Database.DB.VExecute("SELECT C.*, S.NAME AS STATUS_NAME FROM CARD_CORRECTION C, STATUS S WHERE C.STATUS_SID=S.SID AND C.LANGUAGE=$LANGUAGE AND " & _
                                                      " S.LANGUAGE=$LANGUAGE AND C.CARD_SID=$CARD_SID AND " & SQLReadRightsTable("C") & " ORDER BY CORRECTION_DATE DESC",1, 0, _
                                                      LanguageSwitch.Language, NullConvertTo(vbLong,rec("SID")))
                        For I = 1 To rI.Count
                        %>
                        <tr>
                            <td class="viewCardLabel">&nbsp;</td>
                            <td class="viewCardField" colspan="3">
                                <strong><%= FormatDateString(rI(I)("CORRECTION_DATE"),PageUIDateFormat) & " - " & HTMLEncode(rI(I)("STATUS_NAME"))  %></strong><br/>
                                <%= HTMLEncode(rI(I)("STATUS_COMMENTS")) %><br/>
                                <%= GetPerson(rI(I)("PERSON_SID"),LanguageSwitch.Language).IconAndName %><br/>
                                <%= TR("Created") %> <%= FormatDateString(rI(I)("CREATED"),PageUIDateTimeFormat) %><br/>
                                <%= TR("Modified") %> <%= FormatDateString(rI(I)("MODIFIED"),PageUIDateTimeFormat) %><br/>
                            </td>
                        </tr>
                        <%
                        Next
                    %>
                </table>
                <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCViewCard(ctlName) 
        Set ctl = New UCViewCard ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCViewCard = ctl ' TO DO: Change the control name
    End Function

%>