<%
    Class UCAdmTranslations
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' Not currently used - will be removed from the template in future versions
        Public CssClass
        Public Style
        Public SkinId
        Public ListTableCssClass
        
        ' PARAMETERS
        Private PageSize
        
        ' CONTROLS
        Private cksDel, hidsOriginal
        Private txtsContent, vldContents, txtOriginalFilter, txtContentFilter
        Private btnApply, pager, orderer, btnNew
        Private txtNewContent, vldNewContent, txtNewOriginal, vldNewOriginal
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Class_Initialize
            PageSize = 10
            
            Me.Name = NewCtlName()
            RegisterUserControl Me
            ClientId = NewClientId()
            Rendered = False ' No longer required - about to be deprecated
            
            Set cksDel = Create_CCheckBoxSet(Empty,PageSize)
            cksDel.Caption = TR("Delete")
            
            Set txtsContent = Create_CTextSet(Empty, PageSize)
            Set vldContents = Create_CValidatorProc("ValidateRequired,ValidateLength")
            vldContents.Required = False
            vldContents.MaxLength = 1024
            txtsContent.Attributes("Size") = 40
            vldContents.Group = Me.Name & "Upd"
            Set txtsContent.ControlsValidator = vldContents
            
            Set hidsOriginal = Create_CHiddenSet(Empty, PageSize)
            
            Set txtOriginalFilter = Create_CText(Empty)
            txtOriginalFilter.MaxLength = 64
            txtOriginalFilter.Style = "width: 100%;"
            Set txtContentFilter = Create_CText(Empty)
            txtContentFilter.MaxLength = 64
            txtContentFilter.Style = "width: 100%;"
            Set btnApply = Create_CButton(Empty)
            btnApply.Caption = TR("Apply changes")
            
            Set pager = Create_ButtonPager(Empty)
            pager.PageSize = PageSize
            pager.ShowPages = 4
            
            Set orderer = Create_OrdererSet(Empty)
            orderer.ShowLabels = True
            orderer("CONTENT").Caption = TR("Translation")
            orderer("ORIGINAL").Caption = TR("Original text")
            
            ' Add manually
            Set btnNew = Create_CButton(Empty)
            btnNew.Caption = TR("Add new text manually")
            
            Set txtNewContent = Create_CText(Empty)
            txtNewContent.MaxLength = 1024
            txtNewContent.Style = "width: 100%;"
            Set vldNewContent = vldContents.Clone
            Set vldNewContent.ControlToValidate = txtNewContent
            vldNewContent.Group = Me.Name & "New"
            
            Set txtNewOriginal = Create_CText(Empty)
            txtNewOriginal.MaxLength = 1024
            txtNewOriginal.Style = "width: 100%;"
            Set vldNewOriginal = vldContents.Clone
            Set vldNewOriginal.ControlToValidate = txtNewOriginal
            vldNewOriginal.Required = True
            vldNewOriginal.Group = Me.Name & "New"
            
        End Sub
        
        Public Sub LoadTable
            Dim filter, r, I
            filter = " ($c ISNULL OR CONTENT LIKE $c) AND " & _
                     " ($o ISNULL OR ORIGINAL LIKE $o) AND LANGUAGE=$l "
            pager.ItemCount = ASPCTLResDB.VExecute("SELECT COUNT(*) FROM VRawTranslations WHERE " & filter, 1, 1, _
                                NullLikeString(txtContentFilter.Value,False,True), NullLikeString(txtOriginalFilter.Value,False,True), PageUILanguage)(1)(1)
            Set r = ASPCTLResDB.VExecute("SELECT * FROM VRawTranslations WHERE " & filter & orderer.OrderClause & pager.LimitOffsetClause,1,0, _
                                NullLikeString(txtContentFilter.Value,False,True), NullLikeString(txtOriginalFilter.Value,False,True), PageUILanguage)
                                
            For I = 1 To r.Count
                txtsContent(I).Value = ConvertTo(vbString,r(I)("CONTENT"))
                hidsOriginal(I).Value = ConvertTo(vbString,r(I)("ORIGINAL"))
            Next
            hidsOriginal.UsedCount = r.Count
            txtsContent.UsedCount = r.Count
        End Sub
        
        Sub ProcessPage
            Dim I, bReloadTable
            bReloadTable = False
            If IsPostBack Then
                If btnApply.Clicked Or pager.Clicked Or orderer.Clicked Or btnNew.Clicked Then
                    If Validate(Me.Name & "Upd") Then
                        For I = 1 To hidsOriginal.UsedCount
                            If cksDel(I).Checked Then
                                ' Delete
                                ASPCTLResDB.VExecute "DELETE FROM Texts WHERE MAINTEXTS_ID IN (SELECT ID FROM MainTexts WHERE CONTENT=$c)", 1, 0, hidsOriginal(I).Value
                                ASPCTLResDB.VExecute "DELETE FROM MainTexts WHERE CONTENT=$c", 1, 0, hidsOriginal(I).Value
                            Else
                                ' Update
                                ASPCTLResDB.VExecute "INSERT INTO VTexts (ORIGINAL, CONTENT, LANGUAGE) VALUES ($o,$c,$l)", 1, 0, _
                                                     NullConvertTo(vbString,hidsOriginal(I).Value), _
                                                     NullConvertTo(vbString,txtsContent(I).Value), _
                                                     PageUILanguage
                            End If
                            bReloadTable = True
                        Next
                        
                        If btnNew.Clicked Then
                            If Validate(Me.Name & "New") Then
                                ASPCTLResDB.VExecute "INSERT INTO VTexts (ORIGINAL,CONTENT,LANGUAGE) VALUES ($o,$c,$l)", 1, 0, _
                                                        NullConvertTo(vbString,txtNewOriginal.Value), _
                                                        NullConvertTo(vbString,txtNewContent.Value), _
                                                        PageUILanguage
                                txtNewContent.Value = ""
                                txtNewOriginal.Value = ""
                                bReloadTable = True
                            End If
                        End If
                        
                    Else
                        pager.RestoreSaved
                        orderer.RestoreSaved
                    End If
                End If
            End If
            If bReloadTable Then LoadTable
        End Sub
        
        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ' TO DO: Change the class name to the unique name of your class. Recommendation place the same name as the declared VBScript class name
            ClassType = "UserControl" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <%
                Dim nRec, rec
                %>
                <h4><%= TR("Resource texts") %></h4>
        
                <table class="<%= ListTableCssClass %>" width="100%" style="width:100%">
                    <tr class="heading">
                        <th nowrap width="50%" style="width:50%"><% orderer("ORIGINAL").Render %></th>
                        <th nowrap width="50%" style="width:50%"><% orderer("CONTENT").Render %></th>
                        <th nowrap>&nbsp;</th>
                    </tr>
                    <tr class="filter">
                        <th nowrap width="50%" style="width:50%"><% txtOriginalFilter.Render %></th>
                        <th nowrap width="50%" style="width:50%"><% txtContentFilter.Render %></th>
                        <th><% btnApply.Render %></th>
                    </tr>
                    <%
                    For nRec = 1 To hidsOriginal.UsedCount
                        %>
                        <tr>
                            <td width="50%" style="width:50%"><% hidsOriginal(nRec).Render : hidsOriginal(nRec).RenderLabel %></td>
                            <td width="50%" style="width:50%"><% txtsContent(nRec).Render : txtsContent.Validator(nRec).Render %></td>
                            <td nowrap><% cksDel(nRec).Render %></td>
                        </tr>
                        <%
                    Next
                    %>
                </table>
                <%
                pager.Render
                orderer.Render
                %>
                <hr/>
                <h4><%= TR("Add new resource string manually") %></h4>
                <table class="<%= ListTableCssClass %>" width="100%" style="width:100%">
                    <tr class="heading">
                        <th width="50%" style="width:50%"><%= TR("Original text") %></th>
                        <th width="50%" style="width:50%"><%= TR("Translation (current language)") %></th>
                        <th>&nbsp;</th>
                    </tr>
                    <tr>
                        <td><% txtNewOriginal.Render : vldNewOriginal.Render %></td>
                        <td><% txtNewContent.Render : vldNewContent.Render %></td>
                        <td><% btnNew.Render %></td>
                    </tr>
                </table>
                <hr/>
                Instead of adding manually all the texts uncomment the RecordTexts application variable in the global.asa temporarily and browse through the entire application. 
                This will record all the texts enclosed in TR( ... ) statements and you will be able to see them on this page and translate them.
            </div>
            <%
        End Sub
    
    End Class

%>