<%
    ' For the current user
    Class UCProfileChangePass ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
            Private txtEmail, txtPass1, txtPass2
            Private vldEmail, vldPass1, vldPass2, vldPasses
            Private btnOk
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            
            Set txtEmail = Create_CText(Empty)
            txtEmail.SkinId = "Long"
            Set vldEmail = Create_TextValidator(txtEmail,128,False,4,128,"^[a-zA-Z0-9\@\.\-\_]*$")
            vldEmail.Group = Me.Name
            vldEmail.Message = TR("The email address is incorrect or missing.")
            
            Set txtPass1 = Create_CPass(Empty)
            txtPass1.SkinId = "Normal"
            Set txtPass2 = Create_CPass(Empty)
            txtPass2.SkinId = "Normal"
            Set vldPass1 = Create_TextValidator(txtPass1,16,False,4,16,"^[a-zA-Z0-9\@\.\-\_\=\~\$\%\^\&\*\(\)]*$")
            vldPass1.Group = Me.Name
            vldPass1.Message = TR("The password can contain only letters, numbers and the symbols @.-_=~%^&*()")
            Set vldPass2 = vldPass1.Clone
            Set vldPass2.ControlToValidate = txtPass2
            
            Set vldPasses = Create_CValidatorProc("ValidateSameInput")
            vldPasses.AddControlToValidate txtPass1
            vldPasses.AddControlToValidate txtPass2
            vldPasses.Group = Me.Name
            vldPasses.Message = TR("The two passwords do not match")
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Save changes")
            btnOk.SkinId = "Save"
            
            CssClass = "UCProfileChangePass"
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Sub ProcessPage
            If IsPostBack And IsLoggedOn Then
                If btnOk.Clicked Then
                    If Validate(Me.Name) Then
                        If Len(txtEmail.Value) > 0 Then
                            ' Change e-mail
                            If CurrentUser.SetEmail(txtEmail.Value) Then
                                GlobalInfoMessage = GlobalInfoMessage & TR("The e-mail address has been changed successfuly.")
                            Else
                                If Database.DB.LastErrorCode = SQLITE_CONSTRAINT Then
                                    Database.AddError TR("The specified e-mail is used by another user account.")
                                End If
                            End If
                        End If
                        If Len(txtPass1.Value) > 0 Then
                            CurrentUser.SetPassword txtPass1.Value
                        End If
                    Else
                        Database.InvalidateTransaction
                    End If
                End If
            End If
        End Sub
        Public Property Get AsyncPostBack(o)
            AsyncPostBack = btnOk.AsyncPostBack(o)
        End Property
        Public Property Let AsyncPostBack(o,v)
            btnOk.AsyncPostBack(o) = v
        End Property
        
        Public Property Get Value
            Value = Empty
        End Property
        
        Public Property Get ClassType
            ClassType = "UCProfileChangePass" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% If IsLoggedOn Then RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="caption" colspan="2"><%= TR("Change e-mail or password") %></th>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Change e-mail") %></th>
                    <td class="field"><% txtEmail.Render : vldEmail.Render %><br/>
                        <%= TR("Current") & ": " & CurrentUser.Email %><br/>
                        <em><%= TR("Enter a new e-mail address to change your current one. Leave empty to retain current.") %></em>
                    </td>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Change password") %><% vldPasses.Render %></th>
                    <td class="field">
                        <% txtPass1.Render : vldPass1.Render %><br/>
                        <% txtPass2.Render : vldPass2.Render %>&nbsp;<%= TR("repeat") %><br/>
                        <em><%= TR("Enter a new password two times in the both boxes to change your current one. Leave both empty to retain current.") %></em>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" class="buttons">
                        <%
                            btnOk.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCProfileChangePass(ctlName) 
        Set ctl = New UCProfileChangePass ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCProfileChangePass = ctl ' TO DO: Change the control name
    End Function

%>