<%
    Class UCProfileNotify ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
            Public ShowNote
        
        ' CONTROLS
           Private colFields
           Private btnSave
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
            ' INIT CONTAINED USER CONTROLS
            '   TO DO: Initialize any user controls contained in this control e.g.
            '   Set myUserControl = New UCMyUserControl
            '   myUserControl.SomeProperty = Something
            
            ' INIT CONTAINED WEB CONTROLS
            Dim arrF, arrL, f, I
            arrF = Split(UCNotify_Fields,",")
            arrL = Split(UCNotify_Labels,",")
            Set colFields = CreateCollection
            For I = LBound(arrF) To UBound(arrF)
                Set f = Create_CCheckBox(Empty)
                f.Caption = TR(arrL(I))
                Set colFields(arrF(I)) = f
            Next
            
            Set btnSave = Create_CButton(Empty)
            btnSave.Caption = TR("Save")
            btnSave.SkinId = "Save"
            
            ShowNote = True
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            CssClass = "UCProfileNotify"
            
        End Sub
        
        Public Function Load
            Dim r, I
            Load = False
            Set r = Database.DB.VExecute("SELECT * FROM USER_NOTIFY WHERE USER_ID=$ID",1,1,NullConvertTo(vbLong, CurrentUser.Id))
            If r.Count = 0 Then
                Set r = Database.DB.VExecute("SELECT * FROM GROUP_NOTIFY WHERE GROUP_ID=$ID",1,1,NullConvertTo(vbLong, CurrentUser.GroupId))
            End If
            If r.Count > 0 Then
                Set r = r(1)
                For I = 1 To colFields.Count
                    colFields(I).Checked = ConvertTo(vbBoolean,r(colFields.Key(I)))
                Next
                Load = True
            Else
                For I = 1 To colFields.Count
                    colFields(I).Checked = False
                Next
            End If
        End Function
        Public Function Save
            Dim params
            Save = False
            If Not IsLoggedOn Then Exit Function
            If CurrentUser.Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Set params = CreateCollection
                    For I = 1 To colFields.Count
                        params(colFields.Key(I)) = ConvertTo(vbLong, colFields(I).Checked)
                    Next
                    params("USER_ID") = CurrentUser.Id
                    Database.DB.CExecute "INSERT INTO USER_NOTIFY (USER_ID," & CreateSQLParameterList(colFields) & _
                                            ") VALUES ($USER_ID," & CreateSQLValuesList(colFields) & ")", params
                    
                    If Database.CompleteTransaction Then
                        Save = True
                    End If
                End If
            End If
        End Function
        Public Function Remove
            Dim tbl
            Remove = False
            If CurrentUser.Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    tbl = "USER_NOTIFY"
                    Database.DB.VExecute "DELETE FROM " & tbl & " WHERE " & IfThenElse(IsGroup,"GROUP_ID","USER_ID") & "=$ID", 1, 0, CurrentUser.Id
                    If Database.CompleteTransaction Then
                        Remove = True
                    End If
                End If
            End If
        End Function
        
        Sub ProcessPage
            If IsPostBack Then ' A form post or async post back
                If btnSave.Clicked And IsLoggedOn Then
                    Save
                End If
            End If
        End Sub
        
        ' POST VARIABLES

        ' TO DO: implement or leave empty the Value property
        Public Property Get Value
            Value = Empty
        End Property
        
        
        Public Property Get ClassType
            ClassType = "UCProfileNotify" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            If IsLoggedOn Then
                RenderForm
            End If
        End Sub
        
        Private Sub RenderForm
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="caption" colspan="2"><%= TR("Notify me by e-mail for") %></th>
                </tr>
                <tr>
                    <td class="field" colspan="2">
                        <% 
                            For I = 1 To colFields.Count
                                colFields(I).Render
                                Response.Write "<br/>"
                            Next
                        %>
                    </td>
                </tr>
                <% If ShowNote Then %>
                <tr>
                    <td class="field" colspan="2">
                        * <%= TR("By checking the corresponding checkboxes you agree to receive automatic e-mail from this WEB site.") %>
                    </td>
                </tr>
                <% End If %>
                <tr>
                    <td colspan="2" class="buttons">
                        <%
                            btnSave.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCProfileNotify(ctlName) 
        Set ctl = New UCProfileNotify ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCProfileNotify = ctl ' TO DO: Change the control name
    End Function

%>