<%
    ' For unregistered users only
    Class UCProfilePassRecovery ' TO DO: Change the class name
        
        ' State preservation in GET/QueryString - rarely used in user controls. Should be avoided in controls using too much async post backs
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Public CssClass
        Public Style
        Public SkinId
        Private Rendered ' Not currently used - will be removed from the template in future versions
        
        ' PARAMETERS
        '   TO DO: Declare simple public variables used from outside to parametrize the control e.g.
        '   Public CellCssClass, SelectionEnabled
        
        ' CONTROLS
            Private txtLogin
            Private vldLogin
            Private btnOk
        
        ' INDICATORS
        '   TO DO: Declare indicator properties e.g.
        '   Public Changed
        
        ' INTERNAL
        '   TO DO: Declare fields you need internally for the control functionality
        '   Private myVar
        
        Sub Init
            Rendered = False ' No longer required - about to be deprecated - you can safely delete this line
            
           
            Set txtLogin = Create_CText(Empty)
            txtLogin.SkinId = "Short"
            Set vldLogin = Create_TextValidator(txtLogin,128,True,4,128,"^[a-zA-Z0-9\@\.\-\_]*$")
            vldLogin.Group = Me.Name
            vldLogin.Message = TR("The login/email must be at least 4 letters long and may contain latin letters, numbers and the symbols @.-_")
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Retrieve password")
            btnOk.SkinId = "Save"
            
            CssClass = "UCProfileRegister"
            
            ' TO DO: If needed register the control for PreRender. This can be done as/if need in the ProcessPage if the
            '   Prerender phase is not always required
            '   RegisterForPreRender Me
            
            ' TO DO: Perform additional initialization tasks if any
            
        End Sub
        
        Sub SendEmail(l,e,p)
            Dim m
            Set m = New CMail
            m.Trace = False
            m.SetAdminSender cMailFromName
            If Not m.Load("PASSWORD_RECOVERY",PageUILanguage,Empty) Then
                Database.AddError TR("Error loading the mail template")
                Exit Sub
            End If
            m.ToUser uid
            If Not m.Send Then
                Database.AddError TR("Error") & " " & m.ErrorMessage
            End If
        End Sub
        
        Sub ProcessPage
            Dim oUser
            If IsPostBack Then
                If Not IsLoggedOn Then
                    If btnOk.Clicked Then
                        If Validate(Me.Name) Then
                            If Not RequestAnonymousAction("ACCOUNT_CREDENTIALS",2) Then
                                Database.CancelTransaction TR("You have reached the limit for password recoveries from your IP address dor the day. Please try again tomorrow")
                            End If
                            
                            Set oUser = New CUser
                            Set oUser.Database = Database
                            If oUser.Load(txtLogin.Value) Then
                                If oUser.SendCredentials Then
                                    GlobalInfoMessage = TR("Your credentials has been sent to your e-mail address. Please check your mail.")
                                End If
                            End If
                        Else
                            Database.InvalidateTransaction
                        End If
                    End If
                End If
            End If
        End Sub
        Public Property Get AsyncPostBack(o)
            AsyncPostBack = btnOk.AsyncPostBack(o)
        End Property
        Public Property Let AsyncPostBack(o,v)
            btnOk.AsyncPostBack(o) = v
        End Property
        
        Public Property Get Value
            Value = Empty
        End Property
        
        Public Property Get ClassType
            ClassType = "UCProfilePassRecovery" 
        End Property
        
        Sub PreRender(param) ' The param is always empty in the current versions of ASP-CTL
        End Sub
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% If Not IsLoggedOn Then RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            If Not IsLoggedOn Then
            %>
            <table class="form" >
                <tr>
                    <th nowrap class="caption" colspan="2"><%= TR("Password recovery") %></th>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Username or e-mail") %></th>
                    <td class="field"><% txtLogin.Render : vldLogin.Render %><br/>
                        <em><%= TR("Enter your username or e-mail address to retrieve your password.") %></em>
                    </td>
                </tr>
                <tr>
                    <td colspan="2" class="buttons">
                        <%
                            btnOk.Render
                        %>
                    </th>
                </tr>
            </table>
            <%
            End If
        End Sub
    
    End Class
    
    ' Constructor
    ' TO DO: Change the UserControl part to the name of your control
    Function Create_UCProfilePassRecovery(ctlName) 
        Set ctl = New UCProfilePassRecovery ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCProfilePassRecovery = ctl ' TO DO: Change the control name
    End Function

%>