<%
    ' Entity editing control for the user profile (only)
    
    Function Create_UCProfilePerson(ctlName) 
        Set ctl = New UCProfilePerson ' TO DO: Change the control name
        ctl.Name = IfThenElse(Len(ctlName) > 0,ctlName,NewCtlName)
        ctl.ClientId = NewClientId()
        RegisterUserControl ctl
        ctl.Init ' The initialization must happen after registration
        UserControlProcessLast ctl ' Moves this control after any contained user controls it may have created in the processing chain
        Set Create_UCProfilePerson = ctl ' TO DO: Change the control name
    End Function
    
    Class UCProfilePerson
        
        ' User controls should not usually preserve state in the query string.
        Public PreserveInQueryString
        Public Property Get HttpGetParams
            HttpGetParams = ""
        End Property
        
        ' Standard fields required by the framework
        Public Name
        Public ClientId ' You can use this in the control rendering code to mark the HTML element that encloses the entire control's contents
        Private Rendered ' See the documentation or just ignore it
        Public CssClass
        Public Style
        Public SkinId
        
        ' PARAMETERS
        Public Hide
        Public HideRights
        
        ' FORM FIELDS - name1 is used for name where only one exists
        Private txtName1, txtName2, txtName3, txtTitle
        Private vldName1, vldName2, vldName3, vldTitle
        Private vldNamesPerson
        Private txtComment, vldComment, dtBorn, vldBorn, txtEgn, vldEgn
        Private cImage, cFile
        Private cRights
        Private cPersons
        Private binder
        Private btnOk, btnCancel, btnDelete
        Private btnOpen, btnClose, btnEdit, btnAddNew, btnClear
        
        ' INDICATORS
        Public Changed
        
        ' Internal 
        Private pShowEgn, pShowBorn
        
        ' TO DO: Declare fields you need internally for the control functionality
        
        Sub Init
            If cPersonAllowAvatar Then
                Set cImage = Create_UCImageDlg(Me.Name & "_I")
                cImage.OwnershipLimit = 0
            End If
            If cPersonAllowFile Then
                Set cFile = Create_UCFileDlg(Me.Name & "_F")
            End If
            Set cRights = Create_UCObjectRights(Empty)
            Rendered = False
            cRights.Table = "PERSON"
            
            ' Person Form
            Set txtName1 = Create_UCMultiLangText(Empty)
            txtName1.SkinId = "Gray"
            Set vldName1 = Create_UCValidator(txtName1,Me,"PersonName")
            Set txtName2 = Create_UCMultiLangText(Empty)
            txtName2.SkinId = "Gray"
            Set vldName2 = Create_UCValidator(txtName2,Me,"PersonName")
            Set txtName3 = Create_UCMultiLangText(Empty)
            txtName3.SkinId = "Gray"
            Set vldName3 = Create_UCValidator(txtName3,Me,"PersonName")
            Set txtTitle = Create_UCMultiLangText(Empty)
            txtTitle.SkinId = "Gray"
            Set vldTitle = Create_UCValidator(txtTitle,Me,"PersonTitle")
            
            ' Assures at least two names are specified
            Set vldNamesPerson = Create_CValidatorProc("ValidateRequireSome")
            With vldNamesPerson
                .Required = True
                .MinValue = 2
                .Group = Me.Name
                .AddControlToValidate txtName1
                .AddControlToValidate txtName2
                .AddControlToValidate txtName3
                .AddControlToValidate txtTitle
                .Message = TR("At least two names must be specified")
            End With

            Set txtComment = Create_UCMultiLangTextArea(Empty)
            txtComment.SkinId = "Gray"
            Set vldComment = Create_UCValidator(txtComment, Me, "TextArea")
            
            Set dtBorn = Create_CDateBox(Empty)
            dtBorn.Format = PageUIDateFormat
            Set vldBorn = Create_UCValidator(dtBorn,Me,"DateBorn")
            
            Set txtEgn = Create_CText(Empty)
            txtEgn.SkinId = "Normal"
            Set vldEgn = Create_UCValidator(txtEgn, Me, "EGN")
            
            Set binder = New CRecordBinder
            binder.BindControl txtComment, vbString, "COMMENT", vbString, "Default", "Default"
            binder.BindControl txtName1, vbString, "NAME1", vbString, "Default", "Default"
            binder.BindControl txtName2, vbString, "NAME2", vbString, "Default", "Default"
            binder.BindControl txtName3, vbString, "NAME3", vbString, "Default", "Default"
            binder.BindControl txtTitle, vbString, "TITLE", vbString, "Default", "Default"
            binder.BindControl txtEgn, vbString, "EGN", vbString, "Default", "Default"
            If cPersonAllowAvatar Then
                binder.BindControl cImage, vbLong, "IMAGE_SID", vbLong, "Default", "Default"
            End If
            If cPersonAllowFile Then
                binder.BindControl cFile, vbLong, "FILE_SID", vbLong, "Default", "Default"
            End If
            binder.BindControl dtBorn, vbDouble, "BORN", vbDouble, "Default", "Default"

            ' Buttons
            Set btnEdit = Create_CImageButton(Empty)
            btnEdit.SkinId = "PanelEdit"
            btnEdit.AsyncPostBack(Me) = True
            Set btnAddNew = Create_CImageButton(Empty)
            btnAddNew.SkinId = "PanelNew"
            btnAddNew.AsyncPostBack(Me) = True
            Set btnClear = Create_CImageButton(Empty)
            btnClear.SkinId = "PanelClear"
            btnClear.AsyncPostBack(Me) = True
            
            Set btnOpen = Create_CImageButton(Empty)
            btnOpen.SkinId = "PanelOpen"
            btnOpen.AsyncPostBack(Me) = True
            Set btnClose = Create_CImageButton(Empty)
            btnClose.SkinId = "PanelClose"
            btnClose.AsyncPostBack(Me) = True
            
            Set btnOk = Create_CButton(Empty)
            btnOk.Caption = TR("Ok")
            btnOk.SkinId = "Green"
            btnOk.AsyncPostBack(Me) = True
            Set btnCancel = Create_CButton(Empty)
            btnCancel.Caption = TR("Cancel")
            btnCancel.SkinId = "Orange"
            btnCancel.AsyncPostBack(Me) = True
            Set btnDelete = Create_CButton(Empty)
            btnDelete.Caption = TR("Delete")
            btnDelete.SkinId = "Red"
            btnDelete.AsyncPostBack(Me) = True
            btnDelete.ConfirmationText = TR("Do you really want to remove this item?")
            
            CssClass = "UserControl"
            
        End Sub
        
        Public Property Get ShowNum
            ShowNum = pShowEgn
        End Property
        Public Property Let ShowNum(v)
            pShowEgn = v
            binder.UnBind "EGN"
            If v Then
                binder.BindControl txtEgn, vbString, "EGN", vbString, "Default", "Default"
            End If
        End Property
        Public Property Get ShowBorn
            ShowBorn = pShowBorn
        End Property
        Public Property Let ShowBorn(v)
            pShowBorn = v
            binder.UnBind "BORN"
            If v Then
                binder.BindControl dtBorn, vbDouble, "BORN", vbDouble, "Default", "Default"
            End If
        End Property
        
        
        Public Function Load
            Dim r
            Load = False
            If Not IsLoggedOn Then Exit Function
            Set r = binder.ItemForEdit(CurrentUser.PersonId,"PERSON")
            If r Is Nothing Then Exit Function
            binder.ReadFrom r
            txtComment.Language = PageUILanguage
            cRights.Id = CurrentUser.PersonId
            Load = True
        End Function
        
        Public Function Save
            Dim r, id
            Save = False
            If Validate(Me.Name) Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = CurrentUser.PersonId
                    Set r = binder.ItemForWrite(CurrentUser.PersonId, "PERSON")
                    If Not r Is Nothing Then
                        binder.WriteTo r
                        id = binder.WriteItem(r,"PERSON")
                        IndexEntity id
                    End If
                    If Database.CompleteTransaction Then
                        CurrentUser.SetPersonId id
                        UpdateCurrentUser
                        cRights.Id = CurrentUser.PersonId
                        Save = True
                    End If
                On Error Goto 0
                End If
            Else
                Database.InvalidateTransaction ' This control has its own buttons, Just in case
            End If
        End Function
        Public Function Delete
            Delete = False
            If Id <> 0 Then
                If Database.BeginTransaction Then
                On Error Resume Next
                    Database.FailureValue(Me,"Id") = CurrentUser.PersonId
                    binder.DeleteItem CurrentUser.PersonId, "PERSON"
                    Database.DB.VExecute "DELETE FROM OBJECT_KEYWORD WHERE OBJECT_SID=$sid", 1, 0, CurrentUser.PersonId
                    Id = 0
                    If Database.CompleteTransaction Then
                        CurrentUser.SetPersonId 0
                        UpdateCurrentUser
                        cRights.Id = CurrentUser.PersonId
                        Delete = True
                        Load 0
                    End If
                On Error Goto 0
                End If
            End If
        End Function

        Public Function Complete(bSuccess, Failure, Success)
            Complete = True
            If Not bSuccess Then
                cRights.Id = CurrentUser.PersonId
            End If
        End Function
        
        Sub ProcessPage
            Dim sNames, arr, I
            If IsPostBack Then
                If btnOk.Clicked Then
                    If Save Then
                        Changed = True
                    End If
                ElseIf btnDelete.Clicked Then
                    Delete
                End If
            End If
        End Sub
        
        ' POST VARIABLES
        Public Property Get Value
            Value = Empty
        End Property
        
        Public Property Get ClassType
            ClassType = "UCProfilePerson" 
        End Property
        
        Public Sub Render
            %>
            <div <%= StyleAndCssString(CssClass,Style) %> id="<%= ClientId %>">
                <% RenderPartial %>
            </div>
            <%
        End Sub
        Public Sub RenderPartial
            If Hide Or Not IsLoggedOn Then Exit Sub
            RenderForm
        End Sub
        
        Private Sub RenderForm
            %>
            <table class="form">
                <tr>
                    <th class="caption" colspan="2"><%= TR("Personal data") %><% vldNamesPerson.Render %></th>
                </tr>
                <tr>
                    <th nowrap class="label" colspan="2"><% cRights.Render %></th>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Title") %></th>
                    <td nowrap class="field"><% txtTitle.Render : vldTitle.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("First name") %></th>
                    <td nowrap class="field"><% txtName1.Render : vldName1.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Middle name") %></th>
                    <td nowrap class="field"><% txtName2.Render : vldName2.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="label"><%= TR("Last name") %></th>
                    <td nowrap class="field"><% txtName3.Render : vldName3.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="formLabel"><%= TR("Birthday") %></th>
                    <td nowrap class="formField"><% dtBorn.Render : vldBorn.Render %></td>
                </tr>
                <tr>
                    <th nowrap class="label" colspan="1"><%= TR("Comment") %></th>
                    <td nowrap class="field" colspan="1"><% txtComment.Render : vldComment.Render %></td>
                </tr>
                <% If cPersonAllowAvatar Then %>
                <tr>
                    <th nowrap class="label" colspan="1"><%= TR("Photo/Avatar") %></th>
                    <td nowrap class="field" colspan="1"><% cImage.Render %></td>
                </tr>
                <% End If %>
                <% If cPersonAllowFile Then %>
                    <tr>
                        <th nowrap class="label" colspan="1"><%= TR("File (CV/details)") %></th>
                        <td nowrap class="field" colspan="1"><% cFile.Render %></td>
                    </tr>
                <% End If %>
                <tr>
                    <td nowrap class="formButtons" colspan="2">
                        <% 
                            btnOk.Render
                            Response.Write "&nbsp;"
                            If CurrentUser.PersonId <> 0 Then btnDelete.Render
                        %>
                    </td>
                </tr>
            </table>
            <%
        End Sub
    
    End Class

%>